/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIAbDirectory.idl
 */

#ifndef __gen_nsIAbDirectory_h__
#define __gen_nsIAbDirectory_h__

#include "nsISupports.h"
#include "nsIAbCard.h"
#include "nsISupportsArray.h"

#include "nsFileSpec.h"
#include "nsDirPrefs.h"

/* starting interface:    nsIAbDirectory */
#define NS_IABDIRECTORY_IID_STR "1920e485-0709-11d3-a2ec-001083003d0c"

#define NS_IABDIRECTORY_IID \
  {0x1920e485, 0x0709, 0x11d3, \
    { 0xa2, 0xec, 0x00, 0x10, 0x83, 0x00, 0x3d, 0x0c }}

class nsIAbDirectory : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IABDIRECTORY_IID)

  /* attribute wstring dirName; */
  NS_IMETHOD GetDirName(PRUnichar * *aDirName) = 0;
  NS_IMETHOD SetDirName(const PRUnichar * aDirName) = 0;

  /* attribute unsigned long lastModifiedDate; */
  NS_IMETHOD GetLastModifiedDate(PRUint32 *aLastModifiedDate) = 0;
  NS_IMETHOD SetLastModifiedDate(PRUint32 aLastModifiedDate) = 0;

  /* attribute DIR_Server server; */
  NS_IMETHOD GetServer(DIR_Server * *aServer) = 0;
  NS_IMETHOD SetServer(DIR_Server * aServer) = 0;

  /* readonly attribute string dirFilePath; */
  NS_IMETHOD GetDirFilePath(char * *aDirFilePath) = 0;

  /* readonly attribute nsIEnumerator childNodes; */
  NS_IMETHOD GetChildNodes(nsIEnumerator * *aChildNodes) = 0;

  /* readonly attribute nsIEnumerator childCards; */
  NS_IMETHOD GetChildCards(nsIEnumerator * *aChildCards) = 0;

  /* nsIAbCard addChildCards (in string uriName); */
  NS_IMETHOD AddChildCards(const char *uriName, nsIAbCard **_retval) = 0;

  /* nsIAbDirectory addDirectory (in string uriName); */
  NS_IMETHOD AddDirectory(const char *uriName, nsIAbDirectory **_retval) = 0;

  /* void deleteDirectories (in nsISupportsArray dierctories); */
  NS_IMETHOD DeleteDirectories(nsISupportsArray *dierctories) = 0;

  /* void deleteCards (in nsISupportsArray cards); */
  NS_IMETHOD DeleteCards(nsISupportsArray *cards) = 0;

  /* boolean hasCard (in nsIAbCard cards); */
  NS_IMETHOD HasCard(nsIAbCard *cards, PRBool *_retval) = 0;

  /* boolean hasDirectory (in nsIAbDirectory dir); */
  NS_IMETHOD HasDirectory(nsIAbDirectory *dir, PRBool *_retval) = 0;

  /* readonly attribute nsIEnumerator mailingList; */
  NS_IMETHOD GetMailingList(nsIEnumerator * *aMailingList) = 0;

  /* void createNewDirectory (in wstring dirName, in string fileName); */
  NS_IMETHOD CreateNewDirectory(const PRUnichar *dirName, const char *fileName) = 0;

  /* string getDirUri (); */
  NS_IMETHOD GetDirUri(char **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIABDIRECTORY \
  NS_IMETHOD GetDirName(PRUnichar * *aDirName); \
  NS_IMETHOD SetDirName(const PRUnichar * aDirName); \
  NS_IMETHOD GetLastModifiedDate(PRUint32 *aLastModifiedDate); \
  NS_IMETHOD SetLastModifiedDate(PRUint32 aLastModifiedDate); \
  NS_IMETHOD GetServer(DIR_Server * *aServer); \
  NS_IMETHOD SetServer(DIR_Server * aServer); \
  NS_IMETHOD GetDirFilePath(char * *aDirFilePath); \
  NS_IMETHOD GetChildNodes(nsIEnumerator * *aChildNodes); \
  NS_IMETHOD GetChildCards(nsIEnumerator * *aChildCards); \
  NS_IMETHOD AddChildCards(const char *uriName, nsIAbCard **_retval); \
  NS_IMETHOD AddDirectory(const char *uriName, nsIAbDirectory **_retval); \
  NS_IMETHOD DeleteDirectories(nsISupportsArray *dierctories); \
  NS_IMETHOD DeleteCards(nsISupportsArray *cards); \
  NS_IMETHOD HasCard(nsIAbCard *cards, PRBool *_retval); \
  NS_IMETHOD HasDirectory(nsIAbDirectory *dir, PRBool *_retval); \
  NS_IMETHOD GetMailingList(nsIEnumerator * *aMailingList); \
  NS_IMETHOD CreateNewDirectory(const PRUnichar *dirName, const char *fileName); \
  NS_IMETHOD GetDirUri(char **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIABDIRECTORY(_to) \
  NS_IMETHOD GetDirName(PRUnichar * *aDirName) { return _to ## GetDirName(aDirName); } \
  NS_IMETHOD SetDirName(const PRUnichar * aDirName) { return _to ## SetDirName(aDirName); } \
  NS_IMETHOD GetLastModifiedDate(PRUint32 *aLastModifiedDate) { return _to ## GetLastModifiedDate(aLastModifiedDate); } \
  NS_IMETHOD SetLastModifiedDate(PRUint32 aLastModifiedDate) { return _to ## SetLastModifiedDate(aLastModifiedDate); } \
  NS_IMETHOD GetServer(DIR_Server * *aServer) { return _to ## GetServer(aServer); } \
  NS_IMETHOD SetServer(DIR_Server * aServer) { return _to ## SetServer(aServer); } \
  NS_IMETHOD GetDirFilePath(char * *aDirFilePath) { return _to ## GetDirFilePath(aDirFilePath); } \
  NS_IMETHOD GetChildNodes(nsIEnumerator * *aChildNodes) { return _to ## GetChildNodes(aChildNodes); } \
  NS_IMETHOD GetChildCards(nsIEnumerator * *aChildCards) { return _to ## GetChildCards(aChildCards); } \
  NS_IMETHOD AddChildCards(const char *uriName, nsIAbCard **_retval) { return _to ## AddChildCards(uriName, _retval); } \
  NS_IMETHOD AddDirectory(const char *uriName, nsIAbDirectory **_retval) { return _to ## AddDirectory(uriName, _retval); } \
  NS_IMETHOD DeleteDirectories(nsISupportsArray *dierctories) { return _to ## DeleteDirectories(dierctories); } \
  NS_IMETHOD DeleteCards(nsISupportsArray *cards) { return _to ## DeleteCards(cards); } \
  NS_IMETHOD HasCard(nsIAbCard *cards, PRBool *_retval) { return _to ## HasCard(cards, _retval); } \
  NS_IMETHOD HasDirectory(nsIAbDirectory *dir, PRBool *_retval) { return _to ## HasDirectory(dir, _retval); } \
  NS_IMETHOD GetMailingList(nsIEnumerator * *aMailingList) { return _to ## GetMailingList(aMailingList); } \
  NS_IMETHOD CreateNewDirectory(const PRUnichar *dirName, const char *fileName) { return _to ## CreateNewDirectory(dirName, fileName); } \
  NS_IMETHOD GetDirUri(char **_retval) { return _to ## GetDirUri(_retval); } 


#endif /* __gen_nsIAbDirectory_h__ */
