/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIChromeRegistry.idl
 */

#ifndef __gen_nsIChromeRegistry_h__
#define __gen_nsIChromeRegistry_h__

#include "nsISupports.h"
#include "nsIURL.h"
#include "nsIEnumerator.h"
#include "nsISupportsArray.h"


/* starting interface:    nsIChromeRegistry */
#define NS_ICHROMEREGISTRY_IID_STR "d8c7d8a1-e84c-11d2-bf87-00105a1b0627"

#define NS_ICHROMEREGISTRY_IID \
  {0xd8c7d8a1, 0xe84c, 0x11d2, \
    { 0xbf, 0x87, 0x00, 0x10, 0x5a, 0x1b, 0x06, 0x27 }}

class nsIChromeRegistry : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ICHROMEREGISTRY_IID)

  /**
   * Convert a chrome URL into a canonical representation; specifically,
   *
   *   chrome://package/provider/file
   *
   * Chrome URLs are allowed to be specified in "shorthand", leaving the
   * "file" portion off. In that case, the URL is expanded to:
   *
   *   chrome://package/provider/package.ext
   *
   * where "ext" is:
   *
   *   "xul" for a "content" package,
   *   "css" for a "skin" package, and
   *   "dtd" for a "locale" package.
   *
   * @param aChromeURL the URL that is to be canonified.
   */
  /* void canonify (in nsIURI aChromeURL); */
  NS_IMETHOD Canonify(nsIURI *aChromeURL) = 0;

  /**
   * Convert a chrome URL to a "real" using the information in the registry.
   *
   * @param aChromeURL the URL that is to be converted.
   */
  /* void convertChromeURL (in nsIURI aChromeURL); */
  NS_IMETHOD ConvertChromeURL(nsIURI *aChromeURL) = 0;

  /* nsISimpleEnumerator getOverlays (in nsIURI aChromeURL); */
  NS_IMETHOD GetOverlays(nsIURI *aChromeURL, nsISimpleEnumerator **_retval) = 0;

  /* void reloadChrome (); */
  NS_IMETHOD ReloadChrome(void) = 0;

  /* void refreshSkins (); */
  NS_IMETHOD RefreshSkins(void) = 0;

  /* void applyTheme (in wstring themeName); */
  NS_IMETHOD ApplyTheme(const PRUnichar *themeName) = 0;

  /* void setSkin (in wstring skinName, in wstring packageName); */
  NS_IMETHOD SetSkin(const PRUnichar *skinName, const PRUnichar *packageName) = 0;

  /* void setLocale (in wstring localeName, in wstring packageName); */
  NS_IMETHOD SetLocale(const PRUnichar *localeName, const PRUnichar *packageName) = 0;

  /* void setDefaultSkin (in wstring skinName, in wstring packageName); */
  NS_IMETHOD SetDefaultSkin(const PRUnichar *skinName, const PRUnichar *packageName) = 0;

  /* void setDefaultLocale (in wstring localeName, in wstring packageName); */
  NS_IMETHOD SetDefaultLocale(const PRUnichar *localeName, const PRUnichar *packageName) = 0;

  /* nsISimpleEnumerator getInstalledSkins (); */
  NS_IMETHOD GetInstalledSkins(nsISimpleEnumerator **_retval) = 0;

  /* nsISimpleEnumerator getInstalledPackages (); */
  NS_IMETHOD GetInstalledPackages(nsISimpleEnumerator **_retval) = 0;

  /* nsISimpleEnumerator getInstalledLocales (); */
  NS_IMETHOD GetInstalledLocales(nsISimpleEnumerator **_retval) = 0;

  /* nsISimpleEnumerator getSelectedSkins (); */
  NS_IMETHOD GetSelectedSkins(nsISimpleEnumerator **_retval) = 0;

  /* nsISimpleEnumerator getSelectedPackages (); */
  NS_IMETHOD GetSelectedPackages(nsISimpleEnumerator **_retval) = 0;

  /* nsISimpleEnumerator getSelectedLocales (); */
  NS_IMETHOD GetSelectedLocales(nsISimpleEnumerator **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSICHROMEREGISTRY \
  NS_IMETHOD Canonify(nsIURI *aChromeURL); \
  NS_IMETHOD ConvertChromeURL(nsIURI *aChromeURL); \
  NS_IMETHOD GetOverlays(nsIURI *aChromeURL, nsISimpleEnumerator **_retval); \
  NS_IMETHOD ReloadChrome(void); \
  NS_IMETHOD RefreshSkins(void); \
  NS_IMETHOD ApplyTheme(const PRUnichar *themeName); \
  NS_IMETHOD SetSkin(const PRUnichar *skinName, const PRUnichar *packageName); \
  NS_IMETHOD SetLocale(const PRUnichar *localeName, const PRUnichar *packageName); \
  NS_IMETHOD SetDefaultSkin(const PRUnichar *skinName, const PRUnichar *packageName); \
  NS_IMETHOD SetDefaultLocale(const PRUnichar *localeName, const PRUnichar *packageName); \
  NS_IMETHOD GetInstalledSkins(nsISimpleEnumerator **_retval); \
  NS_IMETHOD GetInstalledPackages(nsISimpleEnumerator **_retval); \
  NS_IMETHOD GetInstalledLocales(nsISimpleEnumerator **_retval); \
  NS_IMETHOD GetSelectedSkins(nsISimpleEnumerator **_retval); \
  NS_IMETHOD GetSelectedPackages(nsISimpleEnumerator **_retval); \
  NS_IMETHOD GetSelectedLocales(nsISimpleEnumerator **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSICHROMEREGISTRY(_to) \
  NS_IMETHOD Canonify(nsIURI *aChromeURL) { return _to ## Canonify(aChromeURL); } \
  NS_IMETHOD ConvertChromeURL(nsIURI *aChromeURL) { return _to ## ConvertChromeURL(aChromeURL); } \
  NS_IMETHOD GetOverlays(nsIURI *aChromeURL, nsISimpleEnumerator **_retval) { return _to ## GetOverlays(aChromeURL, _retval); } \
  NS_IMETHOD ReloadChrome(void) { return _to ## ReloadChrome(); } \
  NS_IMETHOD RefreshSkins(void) { return _to ## RefreshSkins(); } \
  NS_IMETHOD ApplyTheme(const PRUnichar *themeName) { return _to ## ApplyTheme(themeName); } \
  NS_IMETHOD SetSkin(const PRUnichar *skinName, const PRUnichar *packageName) { return _to ## SetSkin(skinName, packageName); } \
  NS_IMETHOD SetLocale(const PRUnichar *localeName, const PRUnichar *packageName) { return _to ## SetLocale(localeName, packageName); } \
  NS_IMETHOD SetDefaultSkin(const PRUnichar *skinName, const PRUnichar *packageName) { return _to ## SetDefaultSkin(skinName, packageName); } \
  NS_IMETHOD SetDefaultLocale(const PRUnichar *localeName, const PRUnichar *packageName) { return _to ## SetDefaultLocale(localeName, packageName); } \
  NS_IMETHOD GetInstalledSkins(nsISimpleEnumerator **_retval) { return _to ## GetInstalledSkins(_retval); } \
  NS_IMETHOD GetInstalledPackages(nsISimpleEnumerator **_retval) { return _to ## GetInstalledPackages(_retval); } \
  NS_IMETHOD GetInstalledLocales(nsISimpleEnumerator **_retval) { return _to ## GetInstalledLocales(_retval); } \
  NS_IMETHOD GetSelectedSkins(nsISimpleEnumerator **_retval) { return _to ## GetSelectedSkins(_retval); } \
  NS_IMETHOD GetSelectedPackages(nsISimpleEnumerator **_retval) { return _to ## GetSelectedPackages(_retval); } \
  NS_IMETHOD GetSelectedLocales(nsISimpleEnumerator **_retval) { return _to ## GetSelectedLocales(_retval); } 

// for component registration
// {D8C7D8A2-E84C-11d2-BF87-00105A1B0627}
#define NS_CHROMEREGISTRY_CID \
{ 0xd8c7d8a2, 0xe84c, 0x11d2, { 0xbf, 0x87, 0x0, 0x10, 0x5a, 0x1b, 0x6, 0x27 } }
extern nsresult
NS_NewChromeRegistry(nsIChromeRegistry* *aResult);

#endif /* __gen_nsIChromeRegistry_h__ */
