/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIClipboard.idl
 */

#ifndef __gen_nsIClipboard_h__
#define __gen_nsIClipboard_h__

#include "nsISupports.h"
#include "nsISupportsArray.h"
#include "nsITransferable.h"
#include "nsIClipboardOwner.h"


/* starting interface:    nsIClipboard */
#define NS_ICLIPBOARD_IID_STR "8b5314ba-db01-11d2-96ce-0060b0fb9956"

#define NS_ICLIPBOARD_IID \
  {0x8b5314ba, 0xdb01, 0x11d2, \
    { 0x96, 0xce, 0x00, 0x60, 0xb0, 0xfb, 0x99, 0x56 }}

class nsIClipboard : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ICLIPBOARD_IID)

  /**
    * Given a transferable, set the data on the native clipboard
    *
    * @param  aTransferable The transferable
    * @param  anOwner The owner of the transferable
    * @result NS_Ok if no errors
    */
  /* void setData (in nsITransferable aTransferable, in nsIClipboardOwner anOwner); */
  NS_IMETHOD SetData(nsITransferable *aTransferable, nsIClipboardOwner *anOwner) = 0;

  /**
    * Given a transferable, get the clipboard data.
    *
    * @param  aTransferable The transferable
    * @result NS_Ok if no errors
    */
  /* void getData (in nsITransferable aTransferable); */
  NS_IMETHOD GetData(nsITransferable *aTransferable) = 0;

  /**
    * This empties the clipboard and notifies the clipboard owner.
    * This empties the "logical" clipboard. It does not clear the native clipboard.
    *
    * @result NS_OK if successful.
    */
  /* void emptyClipboard (); */
  NS_IMETHOD EmptyClipboard(void) = 0;

  /**
    * Some platforms support deferred notification for putting data on the clipboard
    * This method forces the data onto the clipboard in its various formats
    * This may be used if the application going away.
    *
    * @result NS_OK if successful.
    */
  /* void forceDataToClipboard (); */
  NS_IMETHOD ForceDataToClipboard(void) = 0;

  /**
    * This provides a way to give correct UI feedback about, for instance, a paste 
    * should be allowed. It does _NOT_ actually retreive the data and should be a very
    * inexpensive call. All it does is check if there is data on the clipboard matching
    * any of the flavors in the given list.
    *
    * @aFlavorList - nsISupportsString's in a nsISupportsArray (for JavaScript).
    * @outResult - if data is present matching one of 
    * @result NS_OK if successful.
    */
  /* boolean hasDataMatchingFlavors (in nsISupportsArray aFlavorList); */
  NS_IMETHOD HasDataMatchingFlavors(nsISupportsArray *aFlavorList, PRBool *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSICLIPBOARD \
  NS_IMETHOD SetData(nsITransferable *aTransferable, nsIClipboardOwner *anOwner); \
  NS_IMETHOD GetData(nsITransferable *aTransferable); \
  NS_IMETHOD EmptyClipboard(void); \
  NS_IMETHOD ForceDataToClipboard(void); \
  NS_IMETHOD HasDataMatchingFlavors(nsISupportsArray *aFlavorList, PRBool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSICLIPBOARD(_to) \
  NS_IMETHOD SetData(nsITransferable *aTransferable, nsIClipboardOwner *anOwner) { return _to ## SetData(aTransferable, anOwner); } \
  NS_IMETHOD GetData(nsITransferable *aTransferable) { return _to ## GetData(aTransferable); } \
  NS_IMETHOD EmptyClipboard(void) { return _to ## EmptyClipboard(); } \
  NS_IMETHOD ForceDataToClipboard(void) { return _to ## ForceDataToClipboard(); } \
  NS_IMETHOD HasDataMatchingFlavors(nsISupportsArray *aFlavorList, PRBool *_retval) { return _to ## HasDataMatchingFlavors(aFlavorList, _retval); } 


#endif /* __gen_nsIClipboard_h__ */
