/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIDocShell.idl
 */

#ifndef __gen_nsIDocShell_h__
#define __gen_nsIDocShell_h__

#include "nsISupports.h"
#include "domstubs.h"
#include "nsIPref.h"
#include "nsIURIContentListener.h"
#include "nsIURI.h"

#include "nsIPresContext.h"
#include "nsIContentViewer.h"
#include "nsIDocumentLoaderObserver.h"
class nsIChromeEventHandler; /* forward declaration */


/* starting interface:    nsIDocShell */
#define NS_IDOCSHELL_IID_STR "69e5de00-7b8b-11d3-af61-00a024ffc08c"

#define NS_IDOCSHELL_IID \
  {0x69e5de00, 0x7b8b, 0x11d3, \
    { 0xaf, 0x61, 0x00, 0xa0, 0x24, 0xff, 0xc0, 0x8c }}

class nsIDocShell : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IDOCSHELL_IID)

  /* [noscript] void loadURI (in nsIURI uri, in nsIPresContext presContext); */
  NS_IMETHOD LoadURI(nsIURI *uri, nsIPresContext * presContext) = 0;

  /* [noscript] void loadURIVia (in nsIURI uri, in nsIPresContext presContext, in unsigned long adapterBinding); */
  NS_IMETHOD LoadURIVia(nsIURI *uri, nsIPresContext * presContext, PRUint32 adapterBinding) = 0;

  /* void stopLoad (); */
  NS_IMETHOD StopLoad(void) = 0;

  /* [noscript] void setDocument (in nsIDOMDocument document, in nsIDOMElement rootNode); */
  NS_IMETHOD SetDocument(nsIDOMDocument *document, nsIDOMElement *rootNode) = 0;

  /* readonly attribute nsIURI currentURI; */
  NS_IMETHOD GetCurrentURI(nsIURI * *aCurrentURI) = 0;

  /* attribute nsIDocumentLoaderObserver docLoaderObserver; */
  NS_IMETHOD GetDocLoaderObserver(nsIDocumentLoaderObserver * *aDocLoaderObserver) = 0;
  NS_IMETHOD SetDocLoaderObserver(nsIDocumentLoaderObserver * aDocLoaderObserver) = 0;

  /* readonly attribute nsIPresContext presContext; */
  NS_IMETHOD GetPresContext(nsIPresContext * *aPresContext) = 0;

  /* readonly attribute nsIPresShell presShell; */
  NS_IMETHOD GetPresShell(nsIPresShell * *aPresShell) = 0;

  /* readonly attribute nsIContentViewer contentViewer; */
  NS_IMETHOD GetContentViewer(nsIContentViewer * *aContentViewer) = 0;

  /* attribute nsIChromeEventHandler chromeEventHandler; */
  NS_IMETHOD GetChromeEventHandler(nsIChromeEventHandler * *aChromeEventHandler) = 0;
  NS_IMETHOD SetChromeEventHandler(nsIChromeEventHandler * aChromeEventHandler) = 0;

  /* attribute nsIURIContentListener parentURIContentListener; */
  NS_IMETHOD GetParentURIContentListener(nsIURIContentListener * *aParentURIContentListener) = 0;
  NS_IMETHOD SetParentURIContentListener(nsIURIContentListener * aParentURIContentListener) = 0;

  /* attribute nsIPref prefs; */
  NS_IMETHOD GetPrefs(nsIPref * *aPrefs) = 0;
  NS_IMETHOD SetPrefs(nsIPref * aPrefs) = 0;

  /**
	* Set/Get the document scale factor.  When setting this attribute, a
	* NS_ERROR_NOT_IMPLEMENTED error may be returned by implementations
	* not supporting zoom.  Implementations not supporting zoom should return
	* 1.0 all the time for the Get operation.  1.0 by the way is the default
	* of zoom.  This means 100% of normal scaling or in other words normal size
	* no zoom. 
	*/
  /* attribute float zoom; */
  NS_IMETHOD GetZoom(float *aZoom) = 0;
  NS_IMETHOD SetZoom(float aZoom) = 0;

  /* attribute long marginWidth; */
  NS_IMETHOD GetMarginWidth(PRInt32 *aMarginWidth) = 0;
  NS_IMETHOD SetMarginWidth(PRInt32 aMarginWidth) = 0;

  /* attribute long marginHeight; */
  NS_IMETHOD GetMarginHeight(PRInt32 *aMarginHeight) = 0;
  NS_IMETHOD SetMarginHeight(PRInt32 aMarginHeight) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIDOCSHELL \
  NS_IMETHOD LoadURI(nsIURI *uri, nsIPresContext * presContext); \
  NS_IMETHOD LoadURIVia(nsIURI *uri, nsIPresContext * presContext, PRUint32 adapterBinding); \
  NS_IMETHOD StopLoad(void); \
  NS_IMETHOD SetDocument(nsIDOMDocument *document, nsIDOMElement *rootNode); \
  NS_IMETHOD GetCurrentURI(nsIURI * *aCurrentURI); \
  NS_IMETHOD GetDocLoaderObserver(nsIDocumentLoaderObserver * *aDocLoaderObserver); \
  NS_IMETHOD SetDocLoaderObserver(nsIDocumentLoaderObserver * aDocLoaderObserver); \
  NS_IMETHOD GetPresContext(nsIPresContext * *aPresContext); \
  NS_IMETHOD GetPresShell(nsIPresShell * *aPresShell); \
  NS_IMETHOD GetContentViewer(nsIContentViewer * *aContentViewer); \
  NS_IMETHOD GetChromeEventHandler(nsIChromeEventHandler * *aChromeEventHandler); \
  NS_IMETHOD SetChromeEventHandler(nsIChromeEventHandler * aChromeEventHandler); \
  NS_IMETHOD GetParentURIContentListener(nsIURIContentListener * *aParentURIContentListener); \
  NS_IMETHOD SetParentURIContentListener(nsIURIContentListener * aParentURIContentListener); \
  NS_IMETHOD GetPrefs(nsIPref * *aPrefs); \
  NS_IMETHOD SetPrefs(nsIPref * aPrefs); \
  NS_IMETHOD GetZoom(float *aZoom); \
  NS_IMETHOD SetZoom(float aZoom); \
  NS_IMETHOD GetMarginWidth(PRInt32 *aMarginWidth); \
  NS_IMETHOD SetMarginWidth(PRInt32 aMarginWidth); \
  NS_IMETHOD GetMarginHeight(PRInt32 *aMarginHeight); \
  NS_IMETHOD SetMarginHeight(PRInt32 aMarginHeight); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIDOCSHELL(_to) \
  NS_IMETHOD LoadURI(nsIURI *uri, nsIPresContext * presContext) { return _to ## LoadURI(uri, presContext); } \
  NS_IMETHOD LoadURIVia(nsIURI *uri, nsIPresContext * presContext, PRUint32 adapterBinding) { return _to ## LoadURIVia(uri, presContext, adapterBinding); } \
  NS_IMETHOD StopLoad(void) { return _to ## StopLoad(); } \
  NS_IMETHOD SetDocument(nsIDOMDocument *document, nsIDOMElement *rootNode) { return _to ## SetDocument(document, rootNode); } \
  NS_IMETHOD GetCurrentURI(nsIURI * *aCurrentURI) { return _to ## GetCurrentURI(aCurrentURI); } \
  NS_IMETHOD GetDocLoaderObserver(nsIDocumentLoaderObserver * *aDocLoaderObserver) { return _to ## GetDocLoaderObserver(aDocLoaderObserver); } \
  NS_IMETHOD SetDocLoaderObserver(nsIDocumentLoaderObserver * aDocLoaderObserver) { return _to ## SetDocLoaderObserver(aDocLoaderObserver); } \
  NS_IMETHOD GetPresContext(nsIPresContext * *aPresContext) { return _to ## GetPresContext(aPresContext); } \
  NS_IMETHOD GetPresShell(nsIPresShell * *aPresShell) { return _to ## GetPresShell(aPresShell); } \
  NS_IMETHOD GetContentViewer(nsIContentViewer * *aContentViewer) { return _to ## GetContentViewer(aContentViewer); } \
  NS_IMETHOD GetChromeEventHandler(nsIChromeEventHandler * *aChromeEventHandler) { return _to ## GetChromeEventHandler(aChromeEventHandler); } \
  NS_IMETHOD SetChromeEventHandler(nsIChromeEventHandler * aChromeEventHandler) { return _to ## SetChromeEventHandler(aChromeEventHandler); } \
  NS_IMETHOD GetParentURIContentListener(nsIURIContentListener * *aParentURIContentListener) { return _to ## GetParentURIContentListener(aParentURIContentListener); } \
  NS_IMETHOD SetParentURIContentListener(nsIURIContentListener * aParentURIContentListener) { return _to ## SetParentURIContentListener(aParentURIContentListener); } \
  NS_IMETHOD GetPrefs(nsIPref * *aPrefs) { return _to ## GetPrefs(aPrefs); } \
  NS_IMETHOD SetPrefs(nsIPref * aPrefs) { return _to ## SetPrefs(aPrefs); } \
  NS_IMETHOD GetZoom(float *aZoom) { return _to ## GetZoom(aZoom); } \
  NS_IMETHOD SetZoom(float aZoom) { return _to ## SetZoom(aZoom); } \
  NS_IMETHOD GetMarginWidth(PRInt32 *aMarginWidth) { return _to ## GetMarginWidth(aMarginWidth); } \
  NS_IMETHOD SetMarginWidth(PRInt32 aMarginWidth) { return _to ## SetMarginWidth(aMarginWidth); } \
  NS_IMETHOD GetMarginHeight(PRInt32 *aMarginHeight) { return _to ## GetMarginHeight(aMarginHeight); } \
  NS_IMETHOD SetMarginHeight(PRInt32 aMarginHeight) { return _to ## SetMarginHeight(aMarginHeight); } 


#endif /* __gen_nsIDocShell_h__ */
