/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIFilePicker.idl
 */

#ifndef __gen_nsIFilePicker_h__
#define __gen_nsIFilePicker_h__

#include "nsISupports.h"
#include "nsIFileSpec.h"

class nsIDOMWindow; /* forward declaration */


/* starting interface:    nsIFilePicker */
#define NS_IFILEPICKER_IID_STR "c47de916-1dd1-11b2-8141-82507fa02b21"

#define NS_IFILEPICKER_IID \
  {0xc47de916, 0x1dd1, 0x11b2, \
    { 0x81, 0x41, 0x82, 0x50, 0x7f, 0xa0, 0x2b, 0x21 }}

class nsIFilePicker : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IFILEPICKER_IID)

  enum { modeLoad = 0 };

  enum { modeSave = 1 };

  enum { modeGetFolder = 2 };

  enum { returnOK = 0 };

  enum { returnCancel = 1 };

  enum { returnReplace = 2 };

  /**
  * Create the file widget.
  *
  * @param      parent   nsIDOMWindow parent.  This dialog should be dependant on this parent.
  * @param      title    The title for the file widget
  * @param      mode     load, save, or get folder
  *
  */
  /* void create (in nsIDOMWindow parent, in wstring title, in short mode); */
  NS_IMETHOD Create(nsIDOMWindow *parent, const PRUnichar *title, PRInt16 mode) = 0;

  /**
  * Set the list of file filters 
  *
  * @param      titles           array of filter titles
  * @param      filters          array of filters to associate with titles 
  * @param      numberOfFilters  number of filters.  
  *
  */
  /* void setFilterList (in long numberOfFilters, [array, size_is (numberOfFilters)] in wstring titles, [array, size_is (numberOfFilters)] in wstring filters); */
  NS_IMETHOD SetFilterList(PRInt32 numberOfFilters, const PRUnichar **titles, const PRUnichar **filters) = 0;

  /**
  * Get the index into the filter list for the type of file the user wants to save
  *
  * @param      selectedFilter    the index of the selected item in the filter list
  *
  */
  /* readonly attribute long selectedFilter; */
  NS_IMETHOD GetSelectedFilter(PRInt32 *aSelectedFilter) = 0;

  /* attribute wstring defaultString; */
  NS_IMETHOD GetDefaultString(PRUnichar * *aDefaultString) = 0;
  NS_IMETHOD SetDefaultString(const PRUnichar * aDefaultString) = 0;

  /**
  * Set the directory that the file open/save dialog initially displays
  *
  * @param      displayDirectory  the name of the directory
  *
  */
  /* attribute nsIFileSpec displayDirectory; */
  NS_IMETHOD GetDisplayDirectory(nsIFileSpec * *aDisplayDirectory) = 0;
  NS_IMETHOD SetDisplayDirectory(nsIFileSpec * aDisplayDirectory) = 0;

  /**
  * Get the nsFileSpec for the file or directory.
  *
  * @return Returns the file currently selected
  */
  /* readonly attribute nsIFileSpec file; */
  NS_IMETHOD GetFile(nsIFileSpec * *aFile) = 0;

  /**
  * Show File Dialog. The dialog is displayed modally.
  *
  * @return returnOK if the user selects OK, returnCancel if the user selects cancel
  *
  */
  /* short show (); */
  NS_IMETHOD Show(PRInt16 *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIFILEPICKER \
  NS_IMETHOD Create(nsIDOMWindow *parent, const PRUnichar *title, PRInt16 mode); \
  NS_IMETHOD SetFilterList(PRInt32 numberOfFilters, const PRUnichar **titles, const PRUnichar **filters); \
  NS_IMETHOD GetSelectedFilter(PRInt32 *aSelectedFilter); \
  NS_IMETHOD GetDefaultString(PRUnichar * *aDefaultString); \
  NS_IMETHOD SetDefaultString(const PRUnichar * aDefaultString); \
  NS_IMETHOD GetDisplayDirectory(nsIFileSpec * *aDisplayDirectory); \
  NS_IMETHOD SetDisplayDirectory(nsIFileSpec * aDisplayDirectory); \
  NS_IMETHOD GetFile(nsIFileSpec * *aFile); \
  NS_IMETHOD Show(PRInt16 *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIFILEPICKER(_to) \
  NS_IMETHOD Create(nsIDOMWindow *parent, const PRUnichar *title, PRInt16 mode) { return _to ## Create(parent, title, mode); } \
  NS_IMETHOD SetFilterList(PRInt32 numberOfFilters, const PRUnichar **titles, const PRUnichar **filters) { return _to ## SetFilterList(numberOfFilters, titles, filters); } \
  NS_IMETHOD GetSelectedFilter(PRInt32 *aSelectedFilter) { return _to ## GetSelectedFilter(aSelectedFilter); } \
  NS_IMETHOD GetDefaultString(PRUnichar * *aDefaultString) { return _to ## GetDefaultString(aDefaultString); } \
  NS_IMETHOD SetDefaultString(const PRUnichar * aDefaultString) { return _to ## SetDefaultString(aDefaultString); } \
  NS_IMETHOD GetDisplayDirectory(nsIFileSpec * *aDisplayDirectory) { return _to ## GetDisplayDirectory(aDisplayDirectory); } \
  NS_IMETHOD SetDisplayDirectory(nsIFileSpec * aDisplayDirectory) { return _to ## SetDisplayDirectory(aDisplayDirectory); } \
  NS_IMETHOD GetFile(nsIFileSpec * *aFile) { return _to ## GetFile(aFile); } \
  NS_IMETHOD Show(PRInt16 *_retval) { return _to ## Show(_retval); } 


#endif /* __gen_nsIFilePicker_h__ */
