/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIFileSpecWithUI.idl
 */

#ifndef __gen_nsIFileSpecWithUI_h__
#define __gen_nsIFileSpecWithUI_h__

#include "nsIFileSpec.h"
#include "nsIComponentManager.h"

class nsIDOMWindow; /* forward declaration */


/* starting interface:    nsIFileSpecWithUI */
#define NS_IFILESPECWITHUI_IID_STR "8ddf7681-139a-11d3-915f-dc1f8c138b7c"

#define NS_IFILESPECWITHUI_IID \
  {0x8ddf7681, 0x139a, 0x11d3, \
    { 0x91, 0x5f, 0xdc, 0x1f, 0x8c, 0x13, 0x8b, 0x7c }}

class nsIFileSpecWithUI : public nsIFileSpec {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IFILESPECWITHUI_IID)

  enum { eAllReadable = 1 };

  enum { eHTMLFiles = 2 };

  enum { eXMLFiles = 4 };

  enum { eImageFiles = 8 };

  enum { eMailFiles = 16 };

  enum { eTextFiles = 32 };

  enum { eAllFiles = 64 };

  enum { eAllStandardFilters = 127 };

  enum { eAllMailOutputFilters = 50 };

  enum { eExtraFilter = 2147483648 };

  enum { kNumStandardFilters = 7 };

  enum { kNumMailFilters = 3 };

  /* void chooseInputFile (in string title, in unsigned long filterMask, in string extraFilterTitle, in string extraFilter); */
  NS_IMETHOD ChooseInputFile(const char *title, PRUint32 filterMask, const char *extraFilterTitle, const char *extraFilter) = 0;

  /* void chooseOutputFile (in string windowTitle, in string suggestedLeafName, in unsigned long filterMask); */
  NS_IMETHOD ChooseOutputFile(const char *windowTitle, const char *suggestedLeafName, PRUint32 filterMask) = 0;

  /* string chooseFile (in string title); */
  NS_IMETHOD ChooseFile(const char *title, char **_retval) = 0;

  /* string chooseDirectory (in string title); */
  NS_IMETHOD ChooseDirectory(const char *title, char **_retval) = 0;

  /* attribute nsIDOMWindow parentWindow; */
  NS_IMETHOD GetParentWindow(nsIDOMWindow * *aParentWindow) = 0;
  NS_IMETHOD SetParentWindow(nsIDOMWindow * aParentWindow) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIFILESPECWITHUI \
  NS_IMETHOD ChooseInputFile(const char *title, PRUint32 filterMask, const char *extraFilterTitle, const char *extraFilter); \
  NS_IMETHOD ChooseOutputFile(const char *windowTitle, const char *suggestedLeafName, PRUint32 filterMask); \
  NS_IMETHOD ChooseFile(const char *title, char **_retval); \
  NS_IMETHOD ChooseDirectory(const char *title, char **_retval); \
  NS_IMETHOD GetParentWindow(nsIDOMWindow * *aParentWindow); \
  NS_IMETHOD SetParentWindow(nsIDOMWindow * aParentWindow); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIFILESPECWITHUI(_to) \
  NS_IMETHOD ChooseInputFile(const char *title, PRUint32 filterMask, const char *extraFilterTitle, const char *extraFilter) { return _to ## ChooseInputFile(title, filterMask, extraFilterTitle, extraFilter); } \
  NS_IMETHOD ChooseOutputFile(const char *windowTitle, const char *suggestedLeafName, PRUint32 filterMask) { return _to ## ChooseOutputFile(windowTitle, suggestedLeafName, filterMask); } \
  NS_IMETHOD ChooseFile(const char *title, char **_retval) { return _to ## ChooseFile(title, _retval); } \
  NS_IMETHOD ChooseDirectory(const char *title, char **_retval) { return _to ## ChooseDirectory(title, _retval); } \
  NS_IMETHOD GetParentWindow(nsIDOMWindow * *aParentWindow) { return _to ## GetParentWindow(aParentWindow); } \
  NS_IMETHOD SetParentWindow(nsIDOMWindow * aParentWindow) { return _to ## SetParentWindow(aParentWindow); } 

// Define Progid and CID
// {e3326a80-2816-11d3-a7e5-98cb48c74f3c}
#define NS_FILESPECWITHUI_CID \
{ 0xe3326a80, 0x2816, 0x11d3, { 0xa7, 0xe5, 0x98, 0xcb, 0x48, 0xc7, 0x4f, 0x3c } }
#define NS_FILESPECWITHUI_PROGID "component://netscape/filespecwithui"
#define NS_FILESPECWITHUI_CLASSNAME "nsIFileSpecWithUI"
// Factory methods
inline nsIFileSpecWithUI* NS_CreateFileSpecWithUI()
{
     nsIFileSpecWithUI* spec = nsnull;
     nsresult rv = nsComponentManager::CreateInstance(
     	(const char*)NS_FILESPECWITHUI_PROGID,
     	(nsISupports*)nsnull,
     	(const nsID&)NS_GET_IID(nsIFileSpecWithUI),
     	(void**)&spec);
     NS_ASSERTION(NS_SUCCEEDED(rv), "ERROR: Could not make a file spec.");
     return spec;
}

#endif /* __gen_nsIFileSpecWithUI_h__ */
