/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIHTTPChannel.idl
 */

#ifndef __gen_nsIHTTPChannel_h__
#define __gen_nsIHTTPChannel_h__

#include "nsIChannel.h"

class nsIHTTPEventSink; /* forward declaration */

class nsIStreamListener; /* forward declaration */

class nsISimpleEnumerator; /* forward declaration */

class nsIAtom; /* forward declaration */

class nsIInputStream; /* forward declaration */

class nsIURI; /* forward declaration */


/* starting interface:    nsIHTTPChannel */
#define NS_IHTTPCHANNEL_IID_STR "35c00430-1938-11d3-933a-000064657374"

#define NS_IHTTPCHANNEL_IID \
  {0x35c00430, 0x1938, 0x11d3, \
    { 0x93, 0x3a, 0x00, 0x00, 0x64, 0x65, 0x73, 0x74 }}

class nsIHTTPChannel : public nsIChannel {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IHTTPCHANNEL_IID)

  /**
     * More load attributes for http.
     */
  enum { BYPASS_CACHE = 2 };

  enum { BYPASS_PROXY = 4 };

  /**
      * Referrer sending policy.
      */
  enum { REFERRER_NONE = 0 };

  enum { REFERRER_LINK_CLICK = 1 };

  enum { REFERRER_INLINES = 2 };

  enum { REFERRER_NON_HTTP = 3 };

  /* string GetRequestHeader (in nsIAtom headerAtom); */
  NS_IMETHOD GetRequestHeader(nsIAtom *headerAtom, char **_retval) = 0;

  /* void SetRequestHeader (in nsIAtom headerAtom, in string value); */
  NS_IMETHOD SetRequestHeader(nsIAtom *headerAtom, const char *value) = 0;

  /* nsISimpleEnumerator GetRequestHeaderEnumerator (); */
  NS_IMETHOD GetRequestHeaderEnumerator(nsISimpleEnumerator **_retval) = 0;

  /* void SetRequestMethod (in unsigned long method); */
  NS_IMETHOD SetRequestMethod(PRUint32 method) = 0;

  /* attribute nsIInputStream PostDataStream; */
  NS_IMETHOD GetPostDataStream(nsIInputStream * *aPostDataStream) = 0;
  NS_IMETHOD SetPostDataStream(nsIInputStream * aPostDataStream) = 0;

  /* string GetResponseHeader (in nsIAtom headerAtom); */
  NS_IMETHOD GetResponseHeader(nsIAtom *headerAtom, char **_retval) = 0;

  /* void SetResponseHeader (in nsIAtom headerAtom, in string headerValue); */
  NS_IMETHOD SetResponseHeader(nsIAtom *headerAtom, const char *headerValue) = 0;

  /* nsISimpleEnumerator GetResponseHeaderEnumerator (); */
  NS_IMETHOD GetResponseHeaderEnumerator(nsISimpleEnumerator **_retval) = 0;

  /* void SetReferrer (in nsIURI referrer, in unsigned long referrerLevel); */
  NS_IMETHOD SetReferrer(nsIURI *referrer, PRUint32 referrerLevel) = 0;

  /* readonly attribute unsigned long ResponseStatus; */
  NS_IMETHOD GetResponseStatus(PRUint32 *aResponseStatus) = 0;

  /* readonly attribute string ResponseString; */
  NS_IMETHOD GetResponseString(char * *aResponseString) = 0;

  /* readonly attribute nsIHTTPEventSink EventSink; */
  NS_IMETHOD GetEventSink(nsIHTTPEventSink * *aEventSink) = 0;

  /* readonly attribute nsIStreamListener ResponseDataListener; */
  NS_IMETHOD GetResponseDataListener(nsIStreamListener * *aResponseDataListener) = 0;

  /* readonly attribute string Charset; */
  NS_IMETHOD GetCharset(char * *aCharset) = 0;

  /* attribute PRBool AuthTriedWithPrehost; */
  NS_IMETHOD GetAuthTriedWithPrehost(PRBool *aAuthTriedWithPrehost) = 0;
  NS_IMETHOD SetAuthTriedWithPrehost(PRBool aAuthTriedWithPrehost) = 0;

  /* readonly attribute PRBool UsingProxy; */
  NS_IMETHOD GetUsingProxy(PRBool *aUsingProxy) = 0;

  /* attribute string ProxyRequestURI; */
  NS_IMETHOD GetProxyRequestURI(char * *aProxyRequestURI) = 0;
  NS_IMETHOD SetProxyRequestURI(const char * aProxyRequestURI) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIHTTPCHANNEL \
  NS_IMETHOD GetRequestHeader(nsIAtom *headerAtom, char **_retval); \
  NS_IMETHOD SetRequestHeader(nsIAtom *headerAtom, const char *value); \
  NS_IMETHOD GetRequestHeaderEnumerator(nsISimpleEnumerator **_retval); \
  NS_IMETHOD SetRequestMethod(PRUint32 method); \
  NS_IMETHOD GetPostDataStream(nsIInputStream * *aPostDataStream); \
  NS_IMETHOD SetPostDataStream(nsIInputStream * aPostDataStream); \
  NS_IMETHOD GetResponseHeader(nsIAtom *headerAtom, char **_retval); \
  NS_IMETHOD SetResponseHeader(nsIAtom *headerAtom, const char *headerValue); \
  NS_IMETHOD GetResponseHeaderEnumerator(nsISimpleEnumerator **_retval); \
  NS_IMETHOD SetReferrer(nsIURI *referrer, PRUint32 referrerLevel); \
  NS_IMETHOD GetResponseStatus(PRUint32 *aResponseStatus); \
  NS_IMETHOD GetResponseString(char * *aResponseString); \
  NS_IMETHOD GetEventSink(nsIHTTPEventSink * *aEventSink); \
  NS_IMETHOD GetResponseDataListener(nsIStreamListener * *aResponseDataListener); \
  NS_IMETHOD GetCharset(char * *aCharset); \
  NS_IMETHOD GetAuthTriedWithPrehost(PRBool *aAuthTriedWithPrehost); \
  NS_IMETHOD SetAuthTriedWithPrehost(PRBool aAuthTriedWithPrehost); \
  NS_IMETHOD GetUsingProxy(PRBool *aUsingProxy); \
  NS_IMETHOD GetProxyRequestURI(char * *aProxyRequestURI); \
  NS_IMETHOD SetProxyRequestURI(const char * aProxyRequestURI); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIHTTPCHANNEL(_to) \
  NS_IMETHOD GetRequestHeader(nsIAtom *headerAtom, char **_retval) { return _to ## GetRequestHeader(headerAtom, _retval); } \
  NS_IMETHOD SetRequestHeader(nsIAtom *headerAtom, const char *value) { return _to ## SetRequestHeader(headerAtom, value); } \
  NS_IMETHOD GetRequestHeaderEnumerator(nsISimpleEnumerator **_retval) { return _to ## GetRequestHeaderEnumerator(_retval); } \
  NS_IMETHOD SetRequestMethod(PRUint32 method) { return _to ## SetRequestMethod(method); } \
  NS_IMETHOD GetPostDataStream(nsIInputStream * *aPostDataStream) { return _to ## GetPostDataStream(aPostDataStream); } \
  NS_IMETHOD SetPostDataStream(nsIInputStream * aPostDataStream) { return _to ## SetPostDataStream(aPostDataStream); } \
  NS_IMETHOD GetResponseHeader(nsIAtom *headerAtom, char **_retval) { return _to ## GetResponseHeader(headerAtom, _retval); } \
  NS_IMETHOD SetResponseHeader(nsIAtom *headerAtom, const char *headerValue) { return _to ## SetResponseHeader(headerAtom, headerValue); } \
  NS_IMETHOD GetResponseHeaderEnumerator(nsISimpleEnumerator **_retval) { return _to ## GetResponseHeaderEnumerator(_retval); } \
  NS_IMETHOD SetReferrer(nsIURI *referrer, PRUint32 referrerLevel) { return _to ## SetReferrer(referrer, referrerLevel); } \
  NS_IMETHOD GetResponseStatus(PRUint32 *aResponseStatus) { return _to ## GetResponseStatus(aResponseStatus); } \
  NS_IMETHOD GetResponseString(char * *aResponseString) { return _to ## GetResponseString(aResponseString); } \
  NS_IMETHOD GetEventSink(nsIHTTPEventSink * *aEventSink) { return _to ## GetEventSink(aEventSink); } \
  NS_IMETHOD GetResponseDataListener(nsIStreamListener * *aResponseDataListener) { return _to ## GetResponseDataListener(aResponseDataListener); } \
  NS_IMETHOD GetCharset(char * *aCharset) { return _to ## GetCharset(aCharset); } \
  NS_IMETHOD GetAuthTriedWithPrehost(PRBool *aAuthTriedWithPrehost) { return _to ## GetAuthTriedWithPrehost(aAuthTriedWithPrehost); } \
  NS_IMETHOD SetAuthTriedWithPrehost(PRBool aAuthTriedWithPrehost) { return _to ## SetAuthTriedWithPrehost(aAuthTriedWithPrehost); } \
  NS_IMETHOD GetUsingProxy(PRBool *aUsingProxy) { return _to ## GetUsingProxy(aUsingProxy); } \
  NS_IMETHOD GetProxyRequestURI(char * *aProxyRequestURI) { return _to ## GetProxyRequestURI(aProxyRequestURI); } \
  NS_IMETHOD SetProxyRequestURI(const char * aProxyRequestURI) { return _to ## SetProxyRequestURI(aProxyRequestURI); } 


#endif /* __gen_nsIHTTPChannel_h__ */
