/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIHTTPProtocolHandler.idl
 */

#ifndef __gen_nsIHTTPProtocolHandler_h__
#define __gen_nsIHTTPProtocolHandler_h__

#include "nsIProtocolHandler.h"

class nsIInputStream; /* forward declaration */

class nsAuthEngine;
#define NS_IHTTPHANDLER_CID                           \
{ /* 52A30880-DD95-11d3-A1A7-0050041CAF44 */         \
 0x52a30880, 0xdd95, 0x11d3, { 0xa1, 0xa7, 0x0, 0x50, 0x4, 0x1c, 0xaf, 0x44 } \
}

/* starting interface:    nsIHTTPProtocolHandler */
#define NS_IHTTPPROTOCOLHANDLER_IID_STR "ad1d53ae-3e25-11d3-8cd3-0060b0fc14a3"

#define NS_IHTTPPROTOCOLHANDLER_IID \
  {0xad1d53ae, 0x3e25, 0x11d3, \
    { 0x8c, 0xd3, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3 }}

class nsIHTTPProtocolHandler : public nsIProtocolHandler {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IHTTPPROTOCOLHANDLER_IID)

  enum { ENCODE_NORMAL = 0 };

  enum { ENCODE_ADD_CRLF = 1 };

  enum { ENCODE_QUOTE_LINES = 2 };

  /**
     *
     */
  /* nsIInputStream NewEncodeStream (in nsIInputStream rawStream, in unsigned long encodeFlags); */
  NS_IMETHOD NewEncodeStream(nsIInputStream *rawStream, PRUint32 encodeFlags, nsIInputStream **_retval) = 0;

  /**
     *
     */
  /* nsIInputStream NewDecodeStream (in nsIInputStream encodedStream, in unsigned long encodeFlags); */
  NS_IMETHOD NewDecodeStream(nsIInputStream *encodedStream, PRUint32 encodeFlags, nsIInputStream **_retval) = 0;

  /**
     *
     */
  /* nsIInputStream NewPostDataStream (in boolean isFile, in string data, in unsigned long encodeFlags); */
  NS_IMETHOD NewPostDataStream(PRBool isFile, const char *data, PRUint32 encodeFlags, nsIInputStream **_retval) = 0;

  /* attribute string acceptLanguages; */
  NS_IMETHOD GetAcceptLanguages(char * *aAcceptLanguages) = 0;
  NS_IMETHOD SetAcceptLanguages(const char * aAcceptLanguages) = 0;

  /* [noscript] void getAuthEngine (out nsAuthEnginePtr authEngine); */
  NS_IMETHOD GetAuthEngine(nsAuthEngine * *authEngine) = 0;

  /**
     * Get the application name.
	 *
     * @return The name of this application (eg. "Mozilla").
     */
  /* readonly attribute wstring appName; */
  NS_IMETHOD GetAppName(PRUnichar * *aAppName) = 0;

  /**
     * Get the application version string.
     *
     * @return The complete version (major and minor) string. (eg. "5.0")
     */
  /* readonly attribute wstring appVersion; */
  NS_IMETHOD GetAppVersion(PRUnichar * *aAppVersion) = 0;

  /**
     * The vendor name.
     *
     * @return The vendor name (if any).
     */
  /* attribute wstring vendorName; */
  NS_IMETHOD GetVendorName(PRUnichar * *aVendorName) = 0;
  NS_IMETHOD SetVendorName(const PRUnichar * aVendorName) = 0;

  /**
     * The vendor version string.
     *
     * @return The vendor version (major and minor) string (if any).
     */
  /* attribute wstring vendorVersion; */
  NS_IMETHOD GetVendorVersion(PRUnichar * *aVendorVersion) = 0;
  NS_IMETHOD SetVendorVersion(const PRUnichar * aVendorVersion) = 0;

  /**
     * A product name.
     *
     * @return The product name (if any).
     */
  /* attribute wstring productName; */
  NS_IMETHOD GetProductName(PRUnichar * *aProductName) = 0;
  NS_IMETHOD SetProductName(const PRUnichar * aProductName) = 0;

  /**
     * A product version string.
     *
     * @return A vendor version (major and minor) string (if any).
     */
  /* attribute wstring productVersion; */
  NS_IMETHOD GetProductVersion(PRUnichar * *aProductVersion) = 0;
  NS_IMETHOD SetProductVersion(const PRUnichar * aProductVersion) = 0;

  /**
     * Get the current platform.
     *
     * @return The platform this application is running on
     *		   (eg. "Windows", "Macintosh", "X11")
     */
  /* readonly attribute wstring platform; */
  NS_IMETHOD GetPlatform(PRUnichar * *aPlatform) = 0;

  /**
     * Get the translation of the application. The value for language
     * is usually a 2-letter code such as "en" and occasionally a 
     * five-character code to indicate a language subtype, such as "zh_CN". 
     */
  /* attribute wstring language; */
  NS_IMETHOD GetLanguage(PRUnichar * *aLanguage) = 0;
  NS_IMETHOD SetLanguage(const PRUnichar * aLanguage) = 0;

  /**
     * Get the HTTP advertised user agent string.
     */
  /* readonly attribute wstring userAgent; */
  NS_IMETHOD GetUserAgent(PRUnichar * *aUserAgent) = 0;

  /**
     * Get/Set the application comment misc portion.
     */
  /* attribute wstring misc; */
  NS_IMETHOD GetMisc(PRUnichar * *aMisc) = 0;
  NS_IMETHOD SetMisc(const PRUnichar * aMisc) = 0;

  /**
     * Get/Set the vendor comment. Note this is the entire comment contents.
     */
  /* attribute wstring vendorComment; */
  NS_IMETHOD GetVendorComment(PRUnichar * *aVendorComment) = 0;
  NS_IMETHOD SetVendorComment(const PRUnichar * aVendorComment) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIHTTPPROTOCOLHANDLER \
  NS_IMETHOD NewEncodeStream(nsIInputStream *rawStream, PRUint32 encodeFlags, nsIInputStream **_retval); \
  NS_IMETHOD NewDecodeStream(nsIInputStream *encodedStream, PRUint32 encodeFlags, nsIInputStream **_retval); \
  NS_IMETHOD NewPostDataStream(PRBool isFile, const char *data, PRUint32 encodeFlags, nsIInputStream **_retval); \
  NS_IMETHOD GetAcceptLanguages(char * *aAcceptLanguages); \
  NS_IMETHOD SetAcceptLanguages(const char * aAcceptLanguages); \
  NS_IMETHOD GetAuthEngine(nsAuthEngine * *authEngine); \
  NS_IMETHOD GetAppName(PRUnichar * *aAppName); \
  NS_IMETHOD GetAppVersion(PRUnichar * *aAppVersion); \
  NS_IMETHOD GetVendorName(PRUnichar * *aVendorName); \
  NS_IMETHOD SetVendorName(const PRUnichar * aVendorName); \
  NS_IMETHOD GetVendorVersion(PRUnichar * *aVendorVersion); \
  NS_IMETHOD SetVendorVersion(const PRUnichar * aVendorVersion); \
  NS_IMETHOD GetProductName(PRUnichar * *aProductName); \
  NS_IMETHOD SetProductName(const PRUnichar * aProductName); \
  NS_IMETHOD GetProductVersion(PRUnichar * *aProductVersion); \
  NS_IMETHOD SetProductVersion(const PRUnichar * aProductVersion); \
  NS_IMETHOD GetPlatform(PRUnichar * *aPlatform); \
  NS_IMETHOD GetLanguage(PRUnichar * *aLanguage); \
  NS_IMETHOD SetLanguage(const PRUnichar * aLanguage); \
  NS_IMETHOD GetUserAgent(PRUnichar * *aUserAgent); \
  NS_IMETHOD GetMisc(PRUnichar * *aMisc); \
  NS_IMETHOD SetMisc(const PRUnichar * aMisc); \
  NS_IMETHOD GetVendorComment(PRUnichar * *aVendorComment); \
  NS_IMETHOD SetVendorComment(const PRUnichar * aVendorComment); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIHTTPPROTOCOLHANDLER(_to) \
  NS_IMETHOD NewEncodeStream(nsIInputStream *rawStream, PRUint32 encodeFlags, nsIInputStream **_retval) { return _to ## NewEncodeStream(rawStream, encodeFlags, _retval); } \
  NS_IMETHOD NewDecodeStream(nsIInputStream *encodedStream, PRUint32 encodeFlags, nsIInputStream **_retval) { return _to ## NewDecodeStream(encodedStream, encodeFlags, _retval); } \
  NS_IMETHOD NewPostDataStream(PRBool isFile, const char *data, PRUint32 encodeFlags, nsIInputStream **_retval) { return _to ## NewPostDataStream(isFile, data, encodeFlags, _retval); } \
  NS_IMETHOD GetAcceptLanguages(char * *aAcceptLanguages) { return _to ## GetAcceptLanguages(aAcceptLanguages); } \
  NS_IMETHOD SetAcceptLanguages(const char * aAcceptLanguages) { return _to ## SetAcceptLanguages(aAcceptLanguages); } \
  NS_IMETHOD GetAuthEngine(nsAuthEngine * *authEngine) { return _to ## GetAuthEngine(authEngine); } \
  NS_IMETHOD GetAppName(PRUnichar * *aAppName) { return _to ## GetAppName(aAppName); } \
  NS_IMETHOD GetAppVersion(PRUnichar * *aAppVersion) { return _to ## GetAppVersion(aAppVersion); } \
  NS_IMETHOD GetVendorName(PRUnichar * *aVendorName) { return _to ## GetVendorName(aVendorName); } \
  NS_IMETHOD SetVendorName(const PRUnichar * aVendorName) { return _to ## SetVendorName(aVendorName); } \
  NS_IMETHOD GetVendorVersion(PRUnichar * *aVendorVersion) { return _to ## GetVendorVersion(aVendorVersion); } \
  NS_IMETHOD SetVendorVersion(const PRUnichar * aVendorVersion) { return _to ## SetVendorVersion(aVendorVersion); } \
  NS_IMETHOD GetProductName(PRUnichar * *aProductName) { return _to ## GetProductName(aProductName); } \
  NS_IMETHOD SetProductName(const PRUnichar * aProductName) { return _to ## SetProductName(aProductName); } \
  NS_IMETHOD GetProductVersion(PRUnichar * *aProductVersion) { return _to ## GetProductVersion(aProductVersion); } \
  NS_IMETHOD SetProductVersion(const PRUnichar * aProductVersion) { return _to ## SetProductVersion(aProductVersion); } \
  NS_IMETHOD GetPlatform(PRUnichar * *aPlatform) { return _to ## GetPlatform(aPlatform); } \
  NS_IMETHOD GetLanguage(PRUnichar * *aLanguage) { return _to ## GetLanguage(aLanguage); } \
  NS_IMETHOD SetLanguage(const PRUnichar * aLanguage) { return _to ## SetLanguage(aLanguage); } \
  NS_IMETHOD GetUserAgent(PRUnichar * *aUserAgent) { return _to ## GetUserAgent(aUserAgent); } \
  NS_IMETHOD GetMisc(PRUnichar * *aMisc) { return _to ## GetMisc(aMisc); } \
  NS_IMETHOD SetMisc(const PRUnichar * aMisc) { return _to ## SetMisc(aMisc); } \
  NS_IMETHOD GetVendorComment(PRUnichar * *aVendorComment) { return _to ## GetVendorComment(aVendorComment); } \
  NS_IMETHOD SetVendorComment(const PRUnichar * aVendorComment) { return _to ## SetVendorComment(aVendorComment); } 

//Possible errors
#define NS_ERROR_BAD_REQUEST    NS_ERROR_GENERATE_FAILURE(NS_ERROR_MODULE_NETWORK, 200)
#define NS_ERROR_BUSY           NS_ERROR_GENERATE_FAILURE(NS_ERROR_MODULE_NETWORK, 201)
// HTTP protocol handler will do_GetService() each CID or Progid that is registered
// under this category when it comes alive.
#define NS_HTTP_STARTUP_CATEGORY "http-startup-category"

#endif /* __gen_nsIHTTPProtocolHandler_h__ */
