/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIMsgFolder.idl
 */

#ifndef __gen_nsIMsgFolder_h__
#define __gen_nsIMsgFolder_h__

#include "nsISupports.h"
#include "nsIFolder.h"
#include "nsIMsgThread.h"
#include "nsIMsgIncomingServer.h"
#include "nsIFileSpec.h"
#include "nsISupportsArray.h"
#include "nsIMsgCopyServiceListener.h"

#include "nsIMsgDatabase.h"
#include "nsMsgKeyArray.h"
class nsIMessage; /* forward declaration */

class nsIMsgWindow; /* forward declaration */

class nsIMsgDatabase; /* forward declaration */

class nsMsgKeyArray; /* forward declaration */

class nsIMsgFolderCacheElement; /* forward declaration */

class nsAutoString; /* forward declaration */


/* starting interface:    nsIMsgFolder */
#define NS_IMSGFOLDER_IID_STR "85e39ff0-b248-11d2-b7ef-00805f05ffa5"

#define NS_IMSGFOLDER_IID \
  {0x85e39ff0, 0xb248, 0x11d2, \
    { 0xb7, 0xef, 0x00, 0x80, 0x5f, 0x05, 0xff, 0xa5 }}

class nsIMsgFolder : public nsIFolder {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IMSGFOLDER_IID)

  /* void AddUnique (in nsISupports element); */
  NS_IMETHOD AddUnique(nsISupports *element) = 0;

  /* void ReplaceElement (in nsISupports element, in nsISupports newElement); */
  NS_IMETHOD ReplaceElement(nsISupports *element, nsISupports *newElement) = 0;

  /* nsISimpleEnumerator getMessages (in nsIMsgWindow aMsgWindow); */
  NS_IMETHOD GetMessages(nsIMsgWindow *aMsgWindow, nsISimpleEnumerator **_retval) = 0;

  /* nsISimpleEnumerator getThreads (in nsIMsgWindow aMsgWindow); */
  NS_IMETHOD GetThreads(nsIMsgWindow *aMsgWindow, nsISimpleEnumerator **_retval) = 0;

  /* void startFolderLoading (); */
  NS_IMETHOD StartFolderLoading(void) = 0;

  /* void endFolderLoading (); */
  NS_IMETHOD EndFolderLoading(void) = 0;

  /* void updateFolder (in nsIMsgWindow aWindow); */
  NS_IMETHOD UpdateFolder(nsIMsgWindow *aWindow) = 0;

  /* nsIMsgThread getThreadForMessage (in nsIMessage message); */
  NS_IMETHOD GetThreadForMessage(nsIMessage *message, nsIMsgThread **_retval) = 0;

  /* boolean hasMessage (in nsIMessage message); */
  NS_IMETHOD HasMessage(nsIMessage *message, PRBool *_retval) = 0;

  /* nsIEnumerator getVisibleSubFolders (); */
  NS_IMETHOD GetVisibleSubFolders(nsIEnumerator **_retval) = 0;

  /* readonly attribute wstring prettiestName; */
  NS_IMETHOD GetPrettiestName(PRUnichar * *aPrettiestName) = 0;

  /**
   * URL for this folder
   */
  /* readonly attribute string folderURL; */
  NS_IMETHOD GetFolderURL(char * *aFolderURL) = 0;

  /**
   * should probably move to the server
   */
  /* readonly attribute boolean deleteIsMoveToTrash; */
  NS_IMETHOD GetDeleteIsMoveToTrash(PRBool *aDeleteIsMoveToTrash) = 0;

  /**
   * should probably move to the server
   */
  /* readonly attribute boolean showDeletedMessages; */
  NS_IMETHOD GetShowDeletedMessages(PRBool *aShowDeletedMessages) = 0;

  /**
   * this folder's parent server
   */
  /* readonly attribute nsIMsgIncomingServer server; */
  NS_IMETHOD GetServer(nsIMsgIncomingServer * *aServer) = 0;

  /**
   * is this folder the "phantom" server folder?
   */
  /* readonly attribute boolean isServer; */
  NS_IMETHOD GetIsServer(PRBool *aIsServer) = 0;

  /* readonly attribute boolean canSubscribe; */
  NS_IMETHOD GetCanSubscribe(PRBool *aCanSubscribe) = 0;

  /* readonly attribute boolean canFileMessages; */
  NS_IMETHOD GetCanFileMessages(PRBool *aCanFileMessages) = 0;

  /**
   * does this folder allow subfolders?
   * for example, newsgroups cannot have subfolders, and the INBOX
   * on some IMAP servers cannot have subfolders
   */
  /* readonly attribute boolean canCreateSubfolders; */
  NS_IMETHOD GetCanCreateSubfolders(PRBool *aCanCreateSubfolders) = 0;

  /**
   * can you change the name of this folder?
   * for example, newsgroups
   * and some special folders can't be renamed
   */
  /* readonly attribute boolean canRename; */
  NS_IMETHOD GetCanRename(PRBool *aCanRename) = 0;

  /**
   * the phantom server folder
   */
  /* readonly attribute nsIMsgFolder rootFolder; */
  NS_IMETHOD GetRootFolder(nsIMsgFolder * *aRootFolder) = 0;

  /* void ForceDBClosed (); */
  NS_IMETHOD ForceDBClosed(void) = 0;

  /* void Delete (); */
  NS_IMETHOD Delete(void) = 0;

  /* void deleteSubFolders (in nsISupportsArray folders); */
  NS_IMETHOD DeleteSubFolders(nsISupportsArray *folders) = 0;

  /* void propagateDelete (in nsIMsgFolder folder, in boolean deleteStorage); */
  NS_IMETHOD PropagateDelete(nsIMsgFolder *folder, PRBool deleteStorage) = 0;

  /* void recursiveDelete (in boolean deleteStorage); */
  NS_IMETHOD RecursiveDelete(PRBool deleteStorage) = 0;

  /* void createSubfolder (in wstring folderName); */
  NS_IMETHOD CreateSubfolder(const PRUnichar *folderName) = 0;

  /* [noscript] nsIMsgFolder addSubfolder (in nsAutoString folderName); */
  NS_IMETHOD AddSubfolder(nsAutoString *folderName, nsIMsgFolder **_retval) = 0;

  /* void compact (); */
  NS_IMETHOD Compact(void) = 0;

  /* void emptyTrash (in nsIMsgWindow aMsgWindow); */
  NS_IMETHOD EmptyTrash(nsIMsgWindow *aMsgWindow) = 0;

  /**
   * change the name of the folder
   *
   * @param name the new name of the folder
   */
  /* void rename (in wstring name); */
  NS_IMETHOD Rename(const PRUnichar *name) = 0;

  /* void adopt (in nsIMsgFolder srcFolder, out unsigned long outPos); */
  NS_IMETHOD Adopt(nsIMsgFolder *srcFolder, PRUint32 *outPos) = 0;

  /**
   * looks in immediate children of this folder for the given name
   *
   * @param name the name of the target subfolder
   */
  /* boolean containsChildNamed (in string name); */
  NS_IMETHOD ContainsChildNamed(const char *name, PRBool *_retval) = 0;

  /* boolean isAncestorOf (in nsIMsgFolder folder); */
  NS_IMETHOD IsAncestorOf(nsIMsgFolder *folder, PRBool *_retval) = 0;

  /* string generateUniqueSubfolderName (in string prefix, in nsIMsgFolder otherFolder); */
  NS_IMETHOD GenerateUniqueSubfolderName(const char *prefix, nsIMsgFolder *otherFolder, char **_retval) = 0;

  /* void updateSummaryTotals (in boolean force); */
  NS_IMETHOD UpdateSummaryTotals(PRBool force) = 0;

  /* void summaryChanged (); */
  NS_IMETHOD SummaryChanged(void) = 0;

  /**
   * get the total number of unread messages in this folder,
   * or in all subfolders
   *
   * @param deep if true, descends into all subfolders and gets a grand total
   */
  /* long getNumUnread (in boolean deep); */
  NS_IMETHOD GetNumUnread(PRBool deep, PRInt32 *_retval) = 0;

  /**
   * get the total number of messages in this folder,
   * or in all subfolders
   *
   * @param deep if true, descends into all subfolders and gets a grand total
   */
  /* long getTotalMessages (in boolean deep); */
  NS_IMETHOD GetTotalMessages(PRBool deep, PRInt32 *_retval) = 0;

  /**
  * does this folder have new messages
  *
  */
  /* boolean hasNewMessages (); */
  NS_IMETHOD HasNewMessages(PRBool *_retval) = 0;

  /**
   * return the first new message in the folder
   *
   */
  /* readonly attribute nsIMessage firstNewMessage; */
  NS_IMETHOD GetFirstNewMessage(nsIMessage * *aFirstNewMessage) = 0;

  /**
   * clear new status flag of all of the new messages
   *
   */
  /* void clearNewMessages (); */
  NS_IMETHOD ClearNewMessages(void) = 0;

  /* readonly attribute unsigned long expungedBytesCount; */
  NS_IMETHOD GetExpungedBytesCount(PRUint32 *aExpungedBytesCount) = 0;

  /**
   * can this folder be deleted?
   * for example, special folders cannot be deleted
   */
  /* readonly attribute boolean deletable; */
  NS_IMETHOD GetDeletable(PRBool *aDeletable) = 0;

  /**
   * should we be displaying recipients instead of the sender?
   * for example, in the Sent folder, recipients are more relevant
   * than the sender
   */
  /* readonly attribute boolean displayRecipients; */
  NS_IMETHOD GetDisplayRecipients(PRBool *aDisplayRecipients) = 0;

  /**
   * used to determine if it will take a long time to download all
   * the headers in this folder - so that we can do folder notifications
   * synchronously instead of asynchronously
   */
  /* boolean manyHeadersToDownload (); */
  NS_IMETHOD ManyHeadersToDownload(PRBool *_retval) = 0;

  /* readonly attribute boolean requiresCleanup; */
  NS_IMETHOD GetRequiresCleanup(PRBool *aRequiresCleanup) = 0;

  /* void clearRequiresCleanup (); */
  NS_IMETHOD ClearRequiresCleanup(void) = 0;

  /**
   * this should go into a news-specific interface
   */
  /* readonly attribute boolean knowsSearchNntpExtension; */
  NS_IMETHOD GetKnowsSearchNntpExtension(PRBool *aKnowsSearchNntpExtension) = 0;

  /**
   * this should go into a news-specific interface
   */
  /* readonly attribute boolean allowsPosting; */
  NS_IMETHOD GetAllowsPosting(PRBool *aAllowsPosting) = 0;

  /* readonly attribute string relativePathName; */
  NS_IMETHOD GetRelativePathName(char * *aRelativePathName) = 0;

  /**
   * size of this folder (including headers??) on disk
   */
  /* readonly attribute unsigned long sizeOnDisk; */
  NS_IMETHOD GetSizeOnDisk(PRUint32 *aSizeOnDisk) = 0;

  /**
   * set the password for this folder (what is this used for?)
   */
  /* void rememberPassword (in string password); */
  NS_IMETHOD RememberPassword(const char *password) = 0;

  /* readonly attribute string rememberedPassword; */
  NS_IMETHOD GetRememberedPassword(char * *aRememberedPassword) = 0;

  /* boolean userNeedsToAuthenticateForFolder (in boolean displayOnly); */
  NS_IMETHOD UserNeedsToAuthenticateForFolder(PRBool displayOnly, PRBool *_retval) = 0;

  /* readonly attribute string username; */
  NS_IMETHOD GetUsername(char * *aUsername) = 0;

  /* readonly attribute string hostname; */
  NS_IMETHOD GetHostname(char * *aHostname) = 0;

  /* void setFlag (in unsigned long flag); */
  NS_IMETHOD SetFlag(PRUint32 flag) = 0;

  /* void clearFlag (in unsigned long flag); */
  NS_IMETHOD ClearFlag(PRUint32 flag) = 0;

  /* boolean getFlag (in unsigned long flag); */
  NS_IMETHOD GetFlag(PRUint32 flag, PRBool *_retval) = 0;

  /* void toggleFlag (in unsigned long flag); */
  NS_IMETHOD ToggleFlag(PRUint32 flag) = 0;

  /* void onFlagChange (in unsigned long flag); */
  NS_IMETHOD OnFlagChange(PRUint32 flag) = 0;

  /* readonly attribute unsigned long flags; */
  NS_IMETHOD GetFlags(PRUint32 *aFlags) = 0;

  /* nsIMsgFolder getFoldersWithFlag (in unsigned long flags, in unsigned long resultsize, out unsigned long numFolders); */
  NS_IMETHOD GetFoldersWithFlag(PRUint32 flags, PRUint32 resultsize, PRUint32 *numFolders, nsIMsgFolder **_retval) = 0;

  /* void getExpansionArray (in nsISupportsArray expansionArray); */
  NS_IMETHOD GetExpansionArray(nsISupportsArray *expansionArray) = 0;

  /* void deleteMessages (in nsISupportsArray message, in nsIMsgWindow msgWindow, in boolean deleteStorage, in boolean isMove); */
  NS_IMETHOD DeleteMessages(nsISupportsArray *message, nsIMsgWindow *msgWindow, PRBool deleteStorage, PRBool isMove) = 0;

  /* void copyMessages (in nsIMsgFolder srcFolder, in nsISupportsArray messages, in boolean isMove, in nsIMsgWindow msgWindow, in nsIMsgCopyServiceListener listener); */
  NS_IMETHOD CopyMessages(nsIMsgFolder *srcFolder, nsISupportsArray *messages, PRBool isMove, nsIMsgWindow *msgWindow, nsIMsgCopyServiceListener *listener) = 0;

  /* void copyFileMessage (in nsIFileSpec fileSpec, in nsIMessage msgToReplace, in boolean isDraft, in nsIMsgWindow msgWindow, in nsIMsgCopyServiceListener listener); */
  NS_IMETHOD CopyFileMessage(nsIFileSpec *fileSpec, nsIMessage *msgToReplace, PRBool isDraft, nsIMsgWindow *msgWindow, nsIMsgCopyServiceListener *listener) = 0;

  /* void acquireSemaphore (in nsISupports semHolder); */
  NS_IMETHOD AcquireSemaphore(nsISupports *semHolder) = 0;

  /* void releaseSemaphore (in nsISupports semHolder); */
  NS_IMETHOD ReleaseSemaphore(nsISupports *semHolder) = 0;

  /* boolean testSemaphore (in nsISupports semHolder); */
  NS_IMETHOD TestSemaphore(nsISupports *semHolder, PRBool *_retval) = 0;

  /* readonly attribute boolean locked; */
  NS_IMETHOD GetLocked(PRBool *aLocked) = 0;

  /* nsIMessage createMessageFromMsgDBHdr (in nsIMsgDBHdr msgDBHdr); */
  NS_IMETHOD CreateMessageFromMsgDBHdr(nsIMsgDBHdr *msgDBHdr, nsIMessage **_retval) = 0;

  /* void getNewMessages (in nsIMsgWindow aWindow); */
  NS_IMETHOD GetNewMessages(nsIMsgWindow *aWindow) = 0;

  /**
   * write out summary data for this folder
   * to the given folder cache (i.e. panacea.dat)
   */
  /* void writeToFolderCache (in nsIMsgFolderCache folderCache); */
  NS_IMETHOD WriteToFolderCache(nsIMsgFolderCache *folderCache) = 0;

  /**
   * the charset of this folder
   */
  /* attribute wstring charset; */
  NS_IMETHOD GetCharset(PRUnichar * *aCharset) = 0;
  NS_IMETHOD SetCharset(const PRUnichar * aCharset) = 0;

  /* attribute unsigned long biffState; */
  NS_IMETHOD GetBiffState(PRUint32 *aBiffState) = 0;
  NS_IMETHOD SetBiffState(PRUint32 aBiffState) = 0;

  /**
   * the number of new messages since this folder was last visited
   */
  /* attribute long numNewMessages; */
  NS_IMETHOD GetNumNewMessages(PRInt32 *aNumNewMessages) = 0;
  NS_IMETHOD SetNumNewMessages(PRInt32 aNumNewMessages) = 0;

  /**
   * verbose description of the new messages in this folder
   */
  /* readonly attribute wstring newMessagesNotificationDescription; */
  NS_IMETHOD GetNewMessagesNotificationDescription(PRUnichar * *aNewMessagesNotificationDescription) = 0;

  /**
   * local path of this folder
   */
  /* attribute nsIFileSpec path; */
  NS_IMETHOD GetPath(nsIFileSpec * *aPath) = 0;
  NS_IMETHOD SetPath(nsIFileSpec * aPath) = 0;

  /* void markMessagesRead (in nsISupportsArray messages, in boolean markRead); */
  NS_IMETHOD MarkMessagesRead(nsISupportsArray *messages, PRBool markRead) = 0;

  /* void markAllMessagesRead (); */
  NS_IMETHOD MarkAllMessagesRead(void) = 0;

  /* void markMessagesFlagged (in nsISupportsArray messages, in boolean markFlagged); */
  NS_IMETHOD MarkMessagesFlagged(nsISupportsArray *messages, PRBool markFlagged) = 0;

  /* nsIMsgDatabase getMsgDatabase (in nsIMsgWindow msgWindow); */
  NS_IMETHOD GetMsgDatabase(nsIMsgWindow *msgWindow, nsIMsgDatabase **_retval) = 0;

  /* nsIMsgFolder getChildWithURI (in string uri, in boolean deep); */
  NS_IMETHOD GetChildWithURI(const char *uri, PRBool deep, nsIMsgFolder **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMSGFOLDER \
  NS_IMETHOD AddUnique(nsISupports *element); \
  NS_IMETHOD ReplaceElement(nsISupports *element, nsISupports *newElement); \
  NS_IMETHOD GetMessages(nsIMsgWindow *aMsgWindow, nsISimpleEnumerator **_retval); \
  NS_IMETHOD GetThreads(nsIMsgWindow *aMsgWindow, nsISimpleEnumerator **_retval); \
  NS_IMETHOD StartFolderLoading(void); \
  NS_IMETHOD EndFolderLoading(void); \
  NS_IMETHOD UpdateFolder(nsIMsgWindow *aWindow); \
  NS_IMETHOD GetThreadForMessage(nsIMessage *message, nsIMsgThread **_retval); \
  NS_IMETHOD HasMessage(nsIMessage *message, PRBool *_retval); \
  NS_IMETHOD GetVisibleSubFolders(nsIEnumerator **_retval); \
  NS_IMETHOD GetPrettiestName(PRUnichar * *aPrettiestName); \
  NS_IMETHOD GetFolderURL(char * *aFolderURL); \
  NS_IMETHOD GetDeleteIsMoveToTrash(PRBool *aDeleteIsMoveToTrash); \
  NS_IMETHOD GetShowDeletedMessages(PRBool *aShowDeletedMessages); \
  NS_IMETHOD GetServer(nsIMsgIncomingServer * *aServer); \
  NS_IMETHOD GetIsServer(PRBool *aIsServer); \
  NS_IMETHOD GetCanSubscribe(PRBool *aCanSubscribe); \
  NS_IMETHOD GetCanFileMessages(PRBool *aCanFileMessages); \
  NS_IMETHOD GetCanCreateSubfolders(PRBool *aCanCreateSubfolders); \
  NS_IMETHOD GetCanRename(PRBool *aCanRename); \
  NS_IMETHOD GetRootFolder(nsIMsgFolder * *aRootFolder); \
  NS_IMETHOD ForceDBClosed(void); \
  NS_IMETHOD Delete(void); \
  NS_IMETHOD DeleteSubFolders(nsISupportsArray *folders); \
  NS_IMETHOD PropagateDelete(nsIMsgFolder *folder, PRBool deleteStorage); \
  NS_IMETHOD RecursiveDelete(PRBool deleteStorage); \
  NS_IMETHOD CreateSubfolder(const PRUnichar *folderName); \
  NS_IMETHOD AddSubfolder(nsAutoString *folderName, nsIMsgFolder **_retval); \
  NS_IMETHOD Compact(void); \
  NS_IMETHOD EmptyTrash(nsIMsgWindow *aMsgWindow); \
  NS_IMETHOD Rename(const PRUnichar *name); \
  NS_IMETHOD Adopt(nsIMsgFolder *srcFolder, PRUint32 *outPos); \
  NS_IMETHOD ContainsChildNamed(const char *name, PRBool *_retval); \
  NS_IMETHOD IsAncestorOf(nsIMsgFolder *folder, PRBool *_retval); \
  NS_IMETHOD GenerateUniqueSubfolderName(const char *prefix, nsIMsgFolder *otherFolder, char **_retval); \
  NS_IMETHOD UpdateSummaryTotals(PRBool force); \
  NS_IMETHOD SummaryChanged(void); \
  NS_IMETHOD GetNumUnread(PRBool deep, PRInt32 *_retval); \
  NS_IMETHOD GetTotalMessages(PRBool deep, PRInt32 *_retval); \
  NS_IMETHOD HasNewMessages(PRBool *_retval); \
  NS_IMETHOD GetFirstNewMessage(nsIMessage * *aFirstNewMessage); \
  NS_IMETHOD ClearNewMessages(void); \
  NS_IMETHOD GetExpungedBytesCount(PRUint32 *aExpungedBytesCount); \
  NS_IMETHOD GetDeletable(PRBool *aDeletable); \
  NS_IMETHOD GetDisplayRecipients(PRBool *aDisplayRecipients); \
  NS_IMETHOD ManyHeadersToDownload(PRBool *_retval); \
  NS_IMETHOD GetRequiresCleanup(PRBool *aRequiresCleanup); \
  NS_IMETHOD ClearRequiresCleanup(void); \
  NS_IMETHOD GetKnowsSearchNntpExtension(PRBool *aKnowsSearchNntpExtension); \
  NS_IMETHOD GetAllowsPosting(PRBool *aAllowsPosting); \
  NS_IMETHOD GetRelativePathName(char * *aRelativePathName); \
  NS_IMETHOD GetSizeOnDisk(PRUint32 *aSizeOnDisk); \
  NS_IMETHOD RememberPassword(const char *password); \
  NS_IMETHOD GetRememberedPassword(char * *aRememberedPassword); \
  NS_IMETHOD UserNeedsToAuthenticateForFolder(PRBool displayOnly, PRBool *_retval); \
  NS_IMETHOD GetUsername(char * *aUsername); \
  NS_IMETHOD GetHostname(char * *aHostname); \
  NS_IMETHOD SetFlag(PRUint32 flag); \
  NS_IMETHOD ClearFlag(PRUint32 flag); \
  NS_IMETHOD GetFlag(PRUint32 flag, PRBool *_retval); \
  NS_IMETHOD ToggleFlag(PRUint32 flag); \
  NS_IMETHOD OnFlagChange(PRUint32 flag); \
  NS_IMETHOD GetFlags(PRUint32 *aFlags); \
  NS_IMETHOD GetFoldersWithFlag(PRUint32 flags, PRUint32 resultsize, PRUint32 *numFolders, nsIMsgFolder **_retval); \
  NS_IMETHOD GetExpansionArray(nsISupportsArray *expansionArray); \
  NS_IMETHOD DeleteMessages(nsISupportsArray *message, nsIMsgWindow *msgWindow, PRBool deleteStorage, PRBool isMove); \
  NS_IMETHOD CopyMessages(nsIMsgFolder *srcFolder, nsISupportsArray *messages, PRBool isMove, nsIMsgWindow *msgWindow, nsIMsgCopyServiceListener *listener); \
  NS_IMETHOD CopyFileMessage(nsIFileSpec *fileSpec, nsIMessage *msgToReplace, PRBool isDraft, nsIMsgWindow *msgWindow, nsIMsgCopyServiceListener *listener); \
  NS_IMETHOD AcquireSemaphore(nsISupports *semHolder); \
  NS_IMETHOD ReleaseSemaphore(nsISupports *semHolder); \
  NS_IMETHOD TestSemaphore(nsISupports *semHolder, PRBool *_retval); \
  NS_IMETHOD GetLocked(PRBool *aLocked); \
  NS_IMETHOD CreateMessageFromMsgDBHdr(nsIMsgDBHdr *msgDBHdr, nsIMessage **_retval); \
  NS_IMETHOD GetNewMessages(nsIMsgWindow *aWindow); \
  NS_IMETHOD WriteToFolderCache(nsIMsgFolderCache *folderCache); \
  NS_IMETHOD GetCharset(PRUnichar * *aCharset); \
  NS_IMETHOD SetCharset(const PRUnichar * aCharset); \
  NS_IMETHOD GetBiffState(PRUint32 *aBiffState); \
  NS_IMETHOD SetBiffState(PRUint32 aBiffState); \
  NS_IMETHOD GetNumNewMessages(PRInt32 *aNumNewMessages); \
  NS_IMETHOD SetNumNewMessages(PRInt32 aNumNewMessages); \
  NS_IMETHOD GetNewMessagesNotificationDescription(PRUnichar * *aNewMessagesNotificationDescription); \
  NS_IMETHOD GetPath(nsIFileSpec * *aPath); \
  NS_IMETHOD SetPath(nsIFileSpec * aPath); \
  NS_IMETHOD MarkMessagesRead(nsISupportsArray *messages, PRBool markRead); \
  NS_IMETHOD MarkAllMessagesRead(void); \
  NS_IMETHOD MarkMessagesFlagged(nsISupportsArray *messages, PRBool markFlagged); \
  NS_IMETHOD GetMsgDatabase(nsIMsgWindow *msgWindow, nsIMsgDatabase **_retval); \
  NS_IMETHOD GetChildWithURI(const char *uri, PRBool deep, nsIMsgFolder **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMSGFOLDER(_to) \
  NS_IMETHOD AddUnique(nsISupports *element) { return _to ## AddUnique(element); } \
  NS_IMETHOD ReplaceElement(nsISupports *element, nsISupports *newElement) { return _to ## ReplaceElement(element, newElement); } \
  NS_IMETHOD GetMessages(nsIMsgWindow *aMsgWindow, nsISimpleEnumerator **_retval) { return _to ## GetMessages(aMsgWindow, _retval); } \
  NS_IMETHOD GetThreads(nsIMsgWindow *aMsgWindow, nsISimpleEnumerator **_retval) { return _to ## GetThreads(aMsgWindow, _retval); } \
  NS_IMETHOD StartFolderLoading(void) { return _to ## StartFolderLoading(); } \
  NS_IMETHOD EndFolderLoading(void) { return _to ## EndFolderLoading(); } \
  NS_IMETHOD UpdateFolder(nsIMsgWindow *aWindow) { return _to ## UpdateFolder(aWindow); } \
  NS_IMETHOD GetThreadForMessage(nsIMessage *message, nsIMsgThread **_retval) { return _to ## GetThreadForMessage(message, _retval); } \
  NS_IMETHOD HasMessage(nsIMessage *message, PRBool *_retval) { return _to ## HasMessage(message, _retval); } \
  NS_IMETHOD GetVisibleSubFolders(nsIEnumerator **_retval) { return _to ## GetVisibleSubFolders(_retval); } \
  NS_IMETHOD GetPrettiestName(PRUnichar * *aPrettiestName) { return _to ## GetPrettiestName(aPrettiestName); } \
  NS_IMETHOD GetFolderURL(char * *aFolderURL) { return _to ## GetFolderURL(aFolderURL); } \
  NS_IMETHOD GetDeleteIsMoveToTrash(PRBool *aDeleteIsMoveToTrash) { return _to ## GetDeleteIsMoveToTrash(aDeleteIsMoveToTrash); } \
  NS_IMETHOD GetShowDeletedMessages(PRBool *aShowDeletedMessages) { return _to ## GetShowDeletedMessages(aShowDeletedMessages); } \
  NS_IMETHOD GetServer(nsIMsgIncomingServer * *aServer) { return _to ## GetServer(aServer); } \
  NS_IMETHOD GetIsServer(PRBool *aIsServer) { return _to ## GetIsServer(aIsServer); } \
  NS_IMETHOD GetCanSubscribe(PRBool *aCanSubscribe) { return _to ## GetCanSubscribe(aCanSubscribe); } \
  NS_IMETHOD GetCanFileMessages(PRBool *aCanFileMessages) { return _to ## GetCanFileMessages(aCanFileMessages); } \
  NS_IMETHOD GetCanCreateSubfolders(PRBool *aCanCreateSubfolders) { return _to ## GetCanCreateSubfolders(aCanCreateSubfolders); } \
  NS_IMETHOD GetCanRename(PRBool *aCanRename) { return _to ## GetCanRename(aCanRename); } \
  NS_IMETHOD GetRootFolder(nsIMsgFolder * *aRootFolder) { return _to ## GetRootFolder(aRootFolder); } \
  NS_IMETHOD ForceDBClosed(void) { return _to ## ForceDBClosed(); } \
  NS_IMETHOD Delete(void) { return _to ## Delete(); } \
  NS_IMETHOD DeleteSubFolders(nsISupportsArray *folders) { return _to ## DeleteSubFolders(folders); } \
  NS_IMETHOD PropagateDelete(nsIMsgFolder *folder, PRBool deleteStorage) { return _to ## PropagateDelete(folder, deleteStorage); } \
  NS_IMETHOD RecursiveDelete(PRBool deleteStorage) { return _to ## RecursiveDelete(deleteStorage); } \
  NS_IMETHOD CreateSubfolder(const PRUnichar *folderName) { return _to ## CreateSubfolder(folderName); } \
  NS_IMETHOD AddSubfolder(nsAutoString *folderName, nsIMsgFolder **_retval) { return _to ## AddSubfolder(folderName, _retval); } \
  NS_IMETHOD Compact(void) { return _to ## Compact(); } \
  NS_IMETHOD EmptyTrash(nsIMsgWindow *aMsgWindow) { return _to ## EmptyTrash(aMsgWindow); } \
  NS_IMETHOD Rename(const PRUnichar *name) { return _to ## Rename(name); } \
  NS_IMETHOD Adopt(nsIMsgFolder *srcFolder, PRUint32 *outPos) { return _to ## Adopt(srcFolder, outPos); } \
  NS_IMETHOD ContainsChildNamed(const char *name, PRBool *_retval) { return _to ## ContainsChildNamed(name, _retval); } \
  NS_IMETHOD IsAncestorOf(nsIMsgFolder *folder, PRBool *_retval) { return _to ## IsAncestorOf(folder, _retval); } \
  NS_IMETHOD GenerateUniqueSubfolderName(const char *prefix, nsIMsgFolder *otherFolder, char **_retval) { return _to ## GenerateUniqueSubfolderName(prefix, otherFolder, _retval); } \
  NS_IMETHOD UpdateSummaryTotals(PRBool force) { return _to ## UpdateSummaryTotals(force); } \
  NS_IMETHOD SummaryChanged(void) { return _to ## SummaryChanged(); } \
  NS_IMETHOD GetNumUnread(PRBool deep, PRInt32 *_retval) { return _to ## GetNumUnread(deep, _retval); } \
  NS_IMETHOD GetTotalMessages(PRBool deep, PRInt32 *_retval) { return _to ## GetTotalMessages(deep, _retval); } \
  NS_IMETHOD HasNewMessages(PRBool *_retval) { return _to ## HasNewMessages(_retval); } \
  NS_IMETHOD GetFirstNewMessage(nsIMessage * *aFirstNewMessage) { return _to ## GetFirstNewMessage(aFirstNewMessage); } \
  NS_IMETHOD ClearNewMessages(void) { return _to ## ClearNewMessages(); } \
  NS_IMETHOD GetExpungedBytesCount(PRUint32 *aExpungedBytesCount) { return _to ## GetExpungedBytesCount(aExpungedBytesCount); } \
  NS_IMETHOD GetDeletable(PRBool *aDeletable) { return _to ## GetDeletable(aDeletable); } \
  NS_IMETHOD GetDisplayRecipients(PRBool *aDisplayRecipients) { return _to ## GetDisplayRecipients(aDisplayRecipients); } \
  NS_IMETHOD ManyHeadersToDownload(PRBool *_retval) { return _to ## ManyHeadersToDownload(_retval); } \
  NS_IMETHOD GetRequiresCleanup(PRBool *aRequiresCleanup) { return _to ## GetRequiresCleanup(aRequiresCleanup); } \
  NS_IMETHOD ClearRequiresCleanup(void) { return _to ## ClearRequiresCleanup(); } \
  NS_IMETHOD GetKnowsSearchNntpExtension(PRBool *aKnowsSearchNntpExtension) { return _to ## GetKnowsSearchNntpExtension(aKnowsSearchNntpExtension); } \
  NS_IMETHOD GetAllowsPosting(PRBool *aAllowsPosting) { return _to ## GetAllowsPosting(aAllowsPosting); } \
  NS_IMETHOD GetRelativePathName(char * *aRelativePathName) { return _to ## GetRelativePathName(aRelativePathName); } \
  NS_IMETHOD GetSizeOnDisk(PRUint32 *aSizeOnDisk) { return _to ## GetSizeOnDisk(aSizeOnDisk); } \
  NS_IMETHOD RememberPassword(const char *password) { return _to ## RememberPassword(password); } \
  NS_IMETHOD GetRememberedPassword(char * *aRememberedPassword) { return _to ## GetRememberedPassword(aRememberedPassword); } \
  NS_IMETHOD UserNeedsToAuthenticateForFolder(PRBool displayOnly, PRBool *_retval) { return _to ## UserNeedsToAuthenticateForFolder(displayOnly, _retval); } \
  NS_IMETHOD GetUsername(char * *aUsername) { return _to ## GetUsername(aUsername); } \
  NS_IMETHOD GetHostname(char * *aHostname) { return _to ## GetHostname(aHostname); } \
  NS_IMETHOD SetFlag(PRUint32 flag) { return _to ## SetFlag(flag); } \
  NS_IMETHOD ClearFlag(PRUint32 flag) { return _to ## ClearFlag(flag); } \
  NS_IMETHOD GetFlag(PRUint32 flag, PRBool *_retval) { return _to ## GetFlag(flag, _retval); } \
  NS_IMETHOD ToggleFlag(PRUint32 flag) { return _to ## ToggleFlag(flag); } \
  NS_IMETHOD OnFlagChange(PRUint32 flag) { return _to ## OnFlagChange(flag); } \
  NS_IMETHOD GetFlags(PRUint32 *aFlags) { return _to ## GetFlags(aFlags); } \
  NS_IMETHOD GetFoldersWithFlag(PRUint32 flags, PRUint32 resultsize, PRUint32 *numFolders, nsIMsgFolder **_retval) { return _to ## GetFoldersWithFlag(flags, resultsize, numFolders, _retval); } \
  NS_IMETHOD GetExpansionArray(nsISupportsArray *expansionArray) { return _to ## GetExpansionArray(expansionArray); } \
  NS_IMETHOD DeleteMessages(nsISupportsArray *message, nsIMsgWindow *msgWindow, PRBool deleteStorage, PRBool isMove) { return _to ## DeleteMessages(message, msgWindow, deleteStorage, isMove); } \
  NS_IMETHOD CopyMessages(nsIMsgFolder *srcFolder, nsISupportsArray *messages, PRBool isMove, nsIMsgWindow *msgWindow, nsIMsgCopyServiceListener *listener) { return _to ## CopyMessages(srcFolder, messages, isMove, msgWindow, listener); } \
  NS_IMETHOD CopyFileMessage(nsIFileSpec *fileSpec, nsIMessage *msgToReplace, PRBool isDraft, nsIMsgWindow *msgWindow, nsIMsgCopyServiceListener *listener) { return _to ## CopyFileMessage(fileSpec, msgToReplace, isDraft, msgWindow, listener); } \
  NS_IMETHOD AcquireSemaphore(nsISupports *semHolder) { return _to ## AcquireSemaphore(semHolder); } \
  NS_IMETHOD ReleaseSemaphore(nsISupports *semHolder) { return _to ## ReleaseSemaphore(semHolder); } \
  NS_IMETHOD TestSemaphore(nsISupports *semHolder, PRBool *_retval) { return _to ## TestSemaphore(semHolder, _retval); } \
  NS_IMETHOD GetLocked(PRBool *aLocked) { return _to ## GetLocked(aLocked); } \
  NS_IMETHOD CreateMessageFromMsgDBHdr(nsIMsgDBHdr *msgDBHdr, nsIMessage **_retval) { return _to ## CreateMessageFromMsgDBHdr(msgDBHdr, _retval); } \
  NS_IMETHOD GetNewMessages(nsIMsgWindow *aWindow) { return _to ## GetNewMessages(aWindow); } \
  NS_IMETHOD WriteToFolderCache(nsIMsgFolderCache *folderCache) { return _to ## WriteToFolderCache(folderCache); } \
  NS_IMETHOD GetCharset(PRUnichar * *aCharset) { return _to ## GetCharset(aCharset); } \
  NS_IMETHOD SetCharset(const PRUnichar * aCharset) { return _to ## SetCharset(aCharset); } \
  NS_IMETHOD GetBiffState(PRUint32 *aBiffState) { return _to ## GetBiffState(aBiffState); } \
  NS_IMETHOD SetBiffState(PRUint32 aBiffState) { return _to ## SetBiffState(aBiffState); } \
  NS_IMETHOD GetNumNewMessages(PRInt32 *aNumNewMessages) { return _to ## GetNumNewMessages(aNumNewMessages); } \
  NS_IMETHOD SetNumNewMessages(PRInt32 aNumNewMessages) { return _to ## SetNumNewMessages(aNumNewMessages); } \
  NS_IMETHOD GetNewMessagesNotificationDescription(PRUnichar * *aNewMessagesNotificationDescription) { return _to ## GetNewMessagesNotificationDescription(aNewMessagesNotificationDescription); } \
  NS_IMETHOD GetPath(nsIFileSpec * *aPath) { return _to ## GetPath(aPath); } \
  NS_IMETHOD SetPath(nsIFileSpec * aPath) { return _to ## SetPath(aPath); } \
  NS_IMETHOD MarkMessagesRead(nsISupportsArray *messages, PRBool markRead) { return _to ## MarkMessagesRead(messages, markRead); } \
  NS_IMETHOD MarkAllMessagesRead(void) { return _to ## MarkAllMessagesRead(); } \
  NS_IMETHOD MarkMessagesFlagged(nsISupportsArray *messages, PRBool markFlagged) { return _to ## MarkMessagesFlagged(messages, markFlagged); } \
  NS_IMETHOD GetMsgDatabase(nsIMsgWindow *msgWindow, nsIMsgDatabase **_retval) { return _to ## GetMsgDatabase(msgWindow, _retval); } \
  NS_IMETHOD GetChildWithURI(const char *uri, PRBool deep, nsIMsgFolder **_retval) { return _to ## GetChildWithURI(uri, deep, _retval); } 


#endif /* __gen_nsIMsgFolder_h__ */
