/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIMsgIncomingServer.idl
 */

#ifndef __gen_nsIMsgIncomingServer_h__
#define __gen_nsIMsgIncomingServer_h__

#include "nsISupports.h"
#include "nsIFileSpec.h"

class nsIFolder; /* forward declaration */

class nsIMsgFolderCache; /* forward declaration */

class nsIMsgWindow; /* forward declaration */


/* starting interface:    nsIMsgIncomingServer */
#define NS_IMSGINCOMINGSERVER_IID_STR "60dcb100-e3f2-11d2-b7fc-00805f05ffa5"

#define NS_IMSGINCOMINGSERVER_IID \
  {0x60dcb100, 0xe3f2, 0x11d2, \
    { 0xb7, 0xfc, 0x00, 0x80, 0x5f, 0x05, 0xff, 0xa5 }}

class nsIMsgIncomingServer : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IMSGINCOMINGSERVER_IID)

  /**
   * internal pref key - guaranteed to be unique across all servers
   */
  /* attribute string key; */
  NS_IMETHOD GetKey(char * *aKey) = 0;
  NS_IMETHOD SetKey(const char * aKey) = 0;

  /**
   * pretty name - should be "userid on hostname"
   * if the pref is not set
   */
  /* attribute wstring prettyName; */
  NS_IMETHOD GetPrettyName(PRUnichar * *aPrettyName) = 0;
  NS_IMETHOD SetPrettyName(const PRUnichar * aPrettyName) = 0;

  /**
   * hostname of the server
   */
  /* attribute string hostName; */
  NS_IMETHOD GetHostName(char * *aHostName) = 0;
  NS_IMETHOD SetHostName(const char * aHostName) = 0;

  /* attribute long port; */
  NS_IMETHOD GetPort(PRInt32 *aPort) = 0;
  NS_IMETHOD SetPort(PRInt32 aPort) = 0;

  /**
   * userid to log into the server
   */
  /* attribute string username; */
  NS_IMETHOD GetUsername(char * *aUsername) = 0;
  NS_IMETHOD SetUsername(const char * aUsername) = 0;

  /**
   * protocol type, i.e. "pop3", "imap", "nntp", "none", etc
   * used to construct URLs
   */
  /* attribute string type; */
  NS_IMETHOD GetType(char * *aType) = 0;
  NS_IMETHOD SetType(const char * aType) = 0;

  /**
   * the schema for the local mail store, such
   * as "mailbox", "imap", or "news"
   * used to construct URIs
   */
  /* readonly attribute string localStoreType; */
  NS_IMETHOD GetLocalStoreType(char * *aLocalStoreType) = 0;

  /* attribute boolean rememberPassword; */
  NS_IMETHOD GetRememberPassword(PRBool *aRememberPassword) = 0;
  NS_IMETHOD SetRememberPassword(PRBool aRememberPassword) = 0;

  /* attribute string password; */
  NS_IMETHOD GetPassword(char * *aPassword) = 0;
  NS_IMETHOD SetPassword(const char * aPassword) = 0;

  /* string getPasswordWithUI (in wstring aPromptString, in wstring aPromptTitle, in nsIMsgWindow aMsgWindow); */
  NS_IMETHOD GetPasswordWithUI(const PRUnichar *aPromptString, const PRUnichar *aPromptTitle, nsIMsgWindow *aMsgWindow, char **_retval) = 0;

  /* void forgetPassword (); */
  NS_IMETHOD ForgetPassword(void) = 0;

  /* attribute boolean downloadOnBiff; */
  NS_IMETHOD GetDownloadOnBiff(PRBool *aDownloadOnBiff) = 0;
  NS_IMETHOD SetDownloadOnBiff(PRBool aDownloadOnBiff) = 0;

  /* attribute boolean doBiff; */
  NS_IMETHOD GetDoBiff(PRBool *aDoBiff) = 0;
  NS_IMETHOD SetDoBiff(PRBool aDoBiff) = 0;

  /* attribute long biffMinutes; */
  NS_IMETHOD GetBiffMinutes(PRInt32 *aBiffMinutes) = 0;
  NS_IMETHOD SetBiffMinutes(PRInt32 aBiffMinutes) = 0;

  /* attribute nsIFileSpec localPath; */
  NS_IMETHOD GetLocalPath(nsIFileSpec * *aLocalPath) = 0;
  NS_IMETHOD SetLocalPath(nsIFileSpec * aLocalPath) = 0;

  /* readonly attribute string serverURI; */
  NS_IMETHOD GetServerURI(char * *aServerURI) = 0;

  /* attribute nsIFolder RootFolder; */
  NS_IMETHOD GetRootFolder(nsIFolder * *aRootFolder) = 0;
  NS_IMETHOD SetRootFolder(nsIFolder * aRootFolder) = 0;

  /* attribute boolean serverBusy; */
  NS_IMETHOD GetServerBusy(PRBool *aServerBusy) = 0;
  NS_IMETHOD SetServerBusy(PRBool aServerBusy) = 0;

  /* attribute string redirectorType; */
  NS_IMETHOD GetRedirectorType(char * *aRedirectorType) = 0;
  NS_IMETHOD SetRedirectorType(const char * aRedirectorType) = 0;

  /* void SetDefaultLocalPath (in nsIFileSpec aDefaultLocalPath); */
  NS_IMETHOD SetDefaultLocalPath(nsIFileSpec *aDefaultLocalPath) = 0;

  /* void PerformBiff (); */
  NS_IMETHOD PerformBiff(void) = 0;

  /* void WriteToFolderCache (in nsIMsgFolderCache folderCache); */
  NS_IMETHOD WriteToFolderCache(nsIMsgFolderCache *folderCache) = 0;

  /* void CloseCachedConnections (); */
  NS_IMETHOD CloseCachedConnections(void) = 0;

  /* boolean getBoolValue (in string attr); */
  NS_IMETHOD GetBoolValue(const char *attr, PRBool *_retval) = 0;

  /* void setBoolValue (in string attr, in boolean value); */
  NS_IMETHOD SetBoolValue(const char *attr, PRBool value) = 0;

  /* string getCharValue (in string attr); */
  NS_IMETHOD GetCharValue(const char *attr, char **_retval) = 0;

  /* void setCharValue (in string attr, in string value); */
  NS_IMETHOD SetCharValue(const char *attr, const char *value) = 0;

  /* wstring getUnicharValue (in string attr); */
  NS_IMETHOD GetUnicharValue(const char *attr, PRUnichar **_retval) = 0;

  /* void setUnicharValue (in string attr, in wstring value); */
  NS_IMETHOD SetUnicharValue(const char *attr, const PRUnichar *value) = 0;

  /* long getIntValue (in string attr); */
  NS_IMETHOD GetIntValue(const char *attr, PRInt32 *_retval) = 0;

  /* void setIntValue (in string attr, in long value); */
  NS_IMETHOD SetIntValue(const char *attr, PRInt32 value) = 0;

  /* nsIFileSpec getFileValue (in string attr); */
  NS_IMETHOD GetFileValue(const char *attr, nsIFileSpec **_retval) = 0;

  /* void setFileValue (in string attr, in nsIFileSpec value); */
  NS_IMETHOD SetFileValue(const char *attr, nsIFileSpec *value) = 0;

  /**
   * this is really dangerous. this destroys all pref values
   * do not call this unless you know what you're doing!
   */
  /* void clearAllValues (); */
  NS_IMETHOD ClearAllValues(void) = 0;

  /* attribute boolean valid; */
  NS_IMETHOD GetValid(PRBool *aValid) = 0;
  NS_IMETHOD SetValid(PRBool aValid) = 0;

  /* wstring toString (); */
  NS_IMETHOD ToString(PRUnichar **_retval) = 0;

  /* attribute boolean isSecure; */
  NS_IMETHOD GetIsSecure(PRBool *aIsSecure) = 0;
  NS_IMETHOD SetIsSecure(PRBool aIsSecure) = 0;

  /* boolean equals (in nsIMsgIncomingServer server); */
  NS_IMETHOD Equals(nsIMsgIncomingServer *server, PRBool *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMSGINCOMINGSERVER \
  NS_IMETHOD GetKey(char * *aKey); \
  NS_IMETHOD SetKey(const char * aKey); \
  NS_IMETHOD GetPrettyName(PRUnichar * *aPrettyName); \
  NS_IMETHOD SetPrettyName(const PRUnichar * aPrettyName); \
  NS_IMETHOD GetHostName(char * *aHostName); \
  NS_IMETHOD SetHostName(const char * aHostName); \
  NS_IMETHOD GetPort(PRInt32 *aPort); \
  NS_IMETHOD SetPort(PRInt32 aPort); \
  NS_IMETHOD GetUsername(char * *aUsername); \
  NS_IMETHOD SetUsername(const char * aUsername); \
  NS_IMETHOD GetType(char * *aType); \
  NS_IMETHOD SetType(const char * aType); \
  NS_IMETHOD GetLocalStoreType(char * *aLocalStoreType); \
  NS_IMETHOD GetRememberPassword(PRBool *aRememberPassword); \
  NS_IMETHOD SetRememberPassword(PRBool aRememberPassword); \
  NS_IMETHOD GetPassword(char * *aPassword); \
  NS_IMETHOD SetPassword(const char * aPassword); \
  NS_IMETHOD GetPasswordWithUI(const PRUnichar *aPromptString, const PRUnichar *aPromptTitle, nsIMsgWindow *aMsgWindow, char **_retval); \
  NS_IMETHOD ForgetPassword(void); \
  NS_IMETHOD GetDownloadOnBiff(PRBool *aDownloadOnBiff); \
  NS_IMETHOD SetDownloadOnBiff(PRBool aDownloadOnBiff); \
  NS_IMETHOD GetDoBiff(PRBool *aDoBiff); \
  NS_IMETHOD SetDoBiff(PRBool aDoBiff); \
  NS_IMETHOD GetBiffMinutes(PRInt32 *aBiffMinutes); \
  NS_IMETHOD SetBiffMinutes(PRInt32 aBiffMinutes); \
  NS_IMETHOD GetLocalPath(nsIFileSpec * *aLocalPath); \
  NS_IMETHOD SetLocalPath(nsIFileSpec * aLocalPath); \
  NS_IMETHOD GetServerURI(char * *aServerURI); \
  NS_IMETHOD GetRootFolder(nsIFolder * *aRootFolder); \
  NS_IMETHOD SetRootFolder(nsIFolder * aRootFolder); \
  NS_IMETHOD GetServerBusy(PRBool *aServerBusy); \
  NS_IMETHOD SetServerBusy(PRBool aServerBusy); \
  NS_IMETHOD GetRedirectorType(char * *aRedirectorType); \
  NS_IMETHOD SetRedirectorType(const char * aRedirectorType); \
  NS_IMETHOD SetDefaultLocalPath(nsIFileSpec *aDefaultLocalPath); \
  NS_IMETHOD PerformBiff(void); \
  NS_IMETHOD WriteToFolderCache(nsIMsgFolderCache *folderCache); \
  NS_IMETHOD CloseCachedConnections(void); \
  NS_IMETHOD GetBoolValue(const char *attr, PRBool *_retval); \
  NS_IMETHOD SetBoolValue(const char *attr, PRBool value); \
  NS_IMETHOD GetCharValue(const char *attr, char **_retval); \
  NS_IMETHOD SetCharValue(const char *attr, const char *value); \
  NS_IMETHOD GetUnicharValue(const char *attr, PRUnichar **_retval); \
  NS_IMETHOD SetUnicharValue(const char *attr, const PRUnichar *value); \
  NS_IMETHOD GetIntValue(const char *attr, PRInt32 *_retval); \
  NS_IMETHOD SetIntValue(const char *attr, PRInt32 value); \
  NS_IMETHOD GetFileValue(const char *attr, nsIFileSpec **_retval); \
  NS_IMETHOD SetFileValue(const char *attr, nsIFileSpec *value); \
  NS_IMETHOD ClearAllValues(void); \
  NS_IMETHOD GetValid(PRBool *aValid); \
  NS_IMETHOD SetValid(PRBool aValid); \
  NS_IMETHOD ToString(PRUnichar **_retval); \
  NS_IMETHOD GetIsSecure(PRBool *aIsSecure); \
  NS_IMETHOD SetIsSecure(PRBool aIsSecure); \
  NS_IMETHOD Equals(nsIMsgIncomingServer *server, PRBool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMSGINCOMINGSERVER(_to) \
  NS_IMETHOD GetKey(char * *aKey) { return _to ## GetKey(aKey); } \
  NS_IMETHOD SetKey(const char * aKey) { return _to ## SetKey(aKey); } \
  NS_IMETHOD GetPrettyName(PRUnichar * *aPrettyName) { return _to ## GetPrettyName(aPrettyName); } \
  NS_IMETHOD SetPrettyName(const PRUnichar * aPrettyName) { return _to ## SetPrettyName(aPrettyName); } \
  NS_IMETHOD GetHostName(char * *aHostName) { return _to ## GetHostName(aHostName); } \
  NS_IMETHOD SetHostName(const char * aHostName) { return _to ## SetHostName(aHostName); } \
  NS_IMETHOD GetPort(PRInt32 *aPort) { return _to ## GetPort(aPort); } \
  NS_IMETHOD SetPort(PRInt32 aPort) { return _to ## SetPort(aPort); } \
  NS_IMETHOD GetUsername(char * *aUsername) { return _to ## GetUsername(aUsername); } \
  NS_IMETHOD SetUsername(const char * aUsername) { return _to ## SetUsername(aUsername); } \
  NS_IMETHOD GetType(char * *aType) { return _to ## GetType(aType); } \
  NS_IMETHOD SetType(const char * aType) { return _to ## SetType(aType); } \
  NS_IMETHOD GetLocalStoreType(char * *aLocalStoreType) { return _to ## GetLocalStoreType(aLocalStoreType); } \
  NS_IMETHOD GetRememberPassword(PRBool *aRememberPassword) { return _to ## GetRememberPassword(aRememberPassword); } \
  NS_IMETHOD SetRememberPassword(PRBool aRememberPassword) { return _to ## SetRememberPassword(aRememberPassword); } \
  NS_IMETHOD GetPassword(char * *aPassword) { return _to ## GetPassword(aPassword); } \
  NS_IMETHOD SetPassword(const char * aPassword) { return _to ## SetPassword(aPassword); } \
  NS_IMETHOD GetPasswordWithUI(const PRUnichar *aPromptString, const PRUnichar *aPromptTitle, nsIMsgWindow *aMsgWindow, char **_retval) { return _to ## GetPasswordWithUI(aPromptString, aPromptTitle, aMsgWindow, _retval); } \
  NS_IMETHOD ForgetPassword(void) { return _to ## ForgetPassword(); } \
  NS_IMETHOD GetDownloadOnBiff(PRBool *aDownloadOnBiff) { return _to ## GetDownloadOnBiff(aDownloadOnBiff); } \
  NS_IMETHOD SetDownloadOnBiff(PRBool aDownloadOnBiff) { return _to ## SetDownloadOnBiff(aDownloadOnBiff); } \
  NS_IMETHOD GetDoBiff(PRBool *aDoBiff) { return _to ## GetDoBiff(aDoBiff); } \
  NS_IMETHOD SetDoBiff(PRBool aDoBiff) { return _to ## SetDoBiff(aDoBiff); } \
  NS_IMETHOD GetBiffMinutes(PRInt32 *aBiffMinutes) { return _to ## GetBiffMinutes(aBiffMinutes); } \
  NS_IMETHOD SetBiffMinutes(PRInt32 aBiffMinutes) { return _to ## SetBiffMinutes(aBiffMinutes); } \
  NS_IMETHOD GetLocalPath(nsIFileSpec * *aLocalPath) { return _to ## GetLocalPath(aLocalPath); } \
  NS_IMETHOD SetLocalPath(nsIFileSpec * aLocalPath) { return _to ## SetLocalPath(aLocalPath); } \
  NS_IMETHOD GetServerURI(char * *aServerURI) { return _to ## GetServerURI(aServerURI); } \
  NS_IMETHOD GetRootFolder(nsIFolder * *aRootFolder) { return _to ## GetRootFolder(aRootFolder); } \
  NS_IMETHOD SetRootFolder(nsIFolder * aRootFolder) { return _to ## SetRootFolder(aRootFolder); } \
  NS_IMETHOD GetServerBusy(PRBool *aServerBusy) { return _to ## GetServerBusy(aServerBusy); } \
  NS_IMETHOD SetServerBusy(PRBool aServerBusy) { return _to ## SetServerBusy(aServerBusy); } \
  NS_IMETHOD GetRedirectorType(char * *aRedirectorType) { return _to ## GetRedirectorType(aRedirectorType); } \
  NS_IMETHOD SetRedirectorType(const char * aRedirectorType) { return _to ## SetRedirectorType(aRedirectorType); } \
  NS_IMETHOD SetDefaultLocalPath(nsIFileSpec *aDefaultLocalPath) { return _to ## SetDefaultLocalPath(aDefaultLocalPath); } \
  NS_IMETHOD PerformBiff(void) { return _to ## PerformBiff(); } \
  NS_IMETHOD WriteToFolderCache(nsIMsgFolderCache *folderCache) { return _to ## WriteToFolderCache(folderCache); } \
  NS_IMETHOD CloseCachedConnections(void) { return _to ## CloseCachedConnections(); } \
  NS_IMETHOD GetBoolValue(const char *attr, PRBool *_retval) { return _to ## GetBoolValue(attr, _retval); } \
  NS_IMETHOD SetBoolValue(const char *attr, PRBool value) { return _to ## SetBoolValue(attr, value); } \
  NS_IMETHOD GetCharValue(const char *attr, char **_retval) { return _to ## GetCharValue(attr, _retval); } \
  NS_IMETHOD SetCharValue(const char *attr, const char *value) { return _to ## SetCharValue(attr, value); } \
  NS_IMETHOD GetUnicharValue(const char *attr, PRUnichar **_retval) { return _to ## GetUnicharValue(attr, _retval); } \
  NS_IMETHOD SetUnicharValue(const char *attr, const PRUnichar *value) { return _to ## SetUnicharValue(attr, value); } \
  NS_IMETHOD GetIntValue(const char *attr, PRInt32 *_retval) { return _to ## GetIntValue(attr, _retval); } \
  NS_IMETHOD SetIntValue(const char *attr, PRInt32 value) { return _to ## SetIntValue(attr, value); } \
  NS_IMETHOD GetFileValue(const char *attr, nsIFileSpec **_retval) { return _to ## GetFileValue(attr, _retval); } \
  NS_IMETHOD SetFileValue(const char *attr, nsIFileSpec *value) { return _to ## SetFileValue(attr, value); } \
  NS_IMETHOD ClearAllValues(void) { return _to ## ClearAllValues(); } \
  NS_IMETHOD GetValid(PRBool *aValid) { return _to ## GetValid(aValid); } \
  NS_IMETHOD SetValid(PRBool aValid) { return _to ## SetValid(aValid); } \
  NS_IMETHOD ToString(PRUnichar **_retval) { return _to ## ToString(_retval); } \
  NS_IMETHOD GetIsSecure(PRBool *aIsSecure) { return _to ## GetIsSecure(aIsSecure); } \
  NS_IMETHOD SetIsSecure(PRBool aIsSecure) { return _to ## SetIsSecure(aIsSecure); } \
  NS_IMETHOD Equals(nsIMsgIncomingServer *server, PRBool *_retval) { return _to ## Equals(server, _retval); } 

/* some useful macros to implement nsIMsgIncomingServer accessors */
#define NS_IMPL_SERVERPREF_STR(_class, _postfix, _prefname)	\
NS_IMETHODIMP								   	\
_class::Get##_postfix(char **retval)   			\
{											   	\
  return GetCharValue(_prefname, retval);		\
}												\
NS_IMETHODIMP	   								\
_class::Set##_postfix(const char *chvalue)			\
{												\
  return SetCharValue(_prefname, chvalue);		\
}
#define NS_IMPL_SERVERPREF_BOOL(_class, _postfix, _prefname)\
NS_IMETHODIMP								   	\
_class::Get##_postfix(PRBool *retval)   		\
{											   	\
  return GetBoolValue(_prefname, retval);		\
}												\
NS_IMETHODIMP	   								\
_class::Set##_postfix(PRBool bvalue)			\
{												\
  return SetBoolValue(_prefname, bvalue);		\
}
#define NS_IMPL_SERVERPREF_INT(_class, _postfix, _prefname)\
NS_IMETHODIMP								   	\
_class::Get##_postfix(PRInt32 *retval)   		\
{											   	\
  return GetIntValue(_prefname, retval);			\
}												\
NS_IMETHODIMP	   								\
_class::Set##_postfix(PRInt32 ivalue)			\
{												\
  return SetIntValue(_prefname, ivalue);			\
}
#define NS_IMPL_SERVERPREF_FILE(_class, _postfix, _prefname)\
NS_IMETHODIMP								   	\
_class::Get##_postfix(nsIFileSpec **retval)   		\
{											   	\
  return GetFileValue(_prefname, retval);			\
}												\
NS_IMETHODIMP	   								\
_class::Set##_postfix(nsIFileSpec* ivalue)			\
{												\
  return SetFileValue(_prefname, ivalue);			\
}

#endif /* __gen_nsIMsgIncomingServer_h__ */
