/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIProfile.idl
 */

#ifndef __gen_nsIProfile_h__
#define __gen_nsIProfile_h__

#include "nsISupports.h"

class nsICmdLineService; /* forward declaration */

class nsIFileSpec; /* forward declaration */

#include "nsFileSpec.h"
#include "nsICmdLineService.h"
      
#define NS_PROFILE_CID                                 \
  { /* {02b0625b-e7f3-11d2-9f5a-006008a6efe9} */       \
    0x02b0625b,                                        \
    0xe7f3,                                            \
    0x11d2,                                            \
    { 0x9f, 0x5a, 0x00, 0x60, 0x08, 0xa6, 0xef, 0xe9 } \
  }
#define NS_PROFILE_PROGID	\
	"component://netscape/profile/manager"
#define PREG_PREF	"browser.registration.enable"

/* starting interface:    nsIProfile */
#define NS_IPROFILE_IID_STR "02b0625a-e7f3-11d2-9f5a-006008a6efe9"

#define NS_IPROFILE_IID \
  {0x02b0625a, 0xe7f3, 0x11d2, \
    { 0x9f, 0x5a, 0x00, 0x60, 0x08, 0xa6, 0xef, 0xe9 }}

class nsIProfile : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPROFILE_IID)

  /* [noscript] void startupWithArgs (in nsICmdLineService cmdLine); */
  NS_IMETHOD StartupWithArgs(nsICmdLineService *cmdLine) = 0;

  /* void startup (in string filename); */
  NS_IMETHOD Startup(const char *filename) = 0;

  /* [noscript] void getProfileDir (in string profileName, in nsFileSpec profileDir); */
  NS_IMETHOD GetProfileDir(const char *profileName, nsFileSpec * profileDir) = 0;

  /* readonly attribute long profileCount; */
  NS_IMETHOD GetProfileCount(PRInt32 *aProfileCount) = 0;

  /* readonly attribute string currentProfile; */
  NS_IMETHOD GetCurrentProfile(char * *aCurrentProfile) = 0;

  /* readonly attribute string firstProfile; */
  NS_IMETHOD GetFirstProfile(char * *aFirstProfile) = 0;

  /* [noscript] void getCurrentProfileDir (in nsFileSpec profileDir); */
  NS_IMETHOD GetCurrentProfileDir(nsFileSpec * profileDir) = 0;

  /* [noscript] void setProfileDir (in string profileName, in nsFileSpecRef profileDir); */
  NS_IMETHOD SetProfileDir(const char *profileName, nsFileSpec & profileDir) = 0;

  /* boolean profileExists (in string profileName); */
  NS_IMETHOD ProfileExists(const char *profileName, PRBool *_retval) = 0;

  /* void migrateProfileInfo (); */
  NS_IMETHOD MigrateProfileInfo(void) = 0;

  /* void createNewProfile (in string profileName, in string nativeProfileDir); */
  NS_IMETHOD CreateNewProfile(const char *profileName, const char *nativeProfileDir) = 0;

  /* void renameProfile (in string oldName, in string newName); */
  NS_IMETHOD RenameProfile(const char *oldName, const char *newName) = 0;

  /* void deleteProfile (in string name, in boolean canDeleteFiles); */
  NS_IMETHOD DeleteProfile(const char *name, PRBool canDeleteFiles) = 0;

  /* string getProfileList (); */
  NS_IMETHOD GetProfileList(char **_retval) = 0;

  /* void startApprunner (in string profileName); */
  NS_IMETHOD StartApprunner(const char *profileName) = 0;

  /* void migrateProfile (in string profileName, in boolean showProgressAsModalWindow); */
  NS_IMETHOD MigrateProfile(const char *profileName, PRBool showProgressAsModalWindow) = 0;

  /* string getCookie (); */
  NS_IMETHOD GetCookie(char **_retval) = 0;

  /* void ProcessPRegCookie (); */
  NS_IMETHOD ProcessPRegCookie(void) = 0;

  /* string isPregCookieSet (in string profileName); */
  NS_IMETHOD IsPregCookieSet(const char *profileName, char **_retval) = 0;

  /* void processPREGInfo (in string data); */
  NS_IMETHOD ProcessPREGInfo(const char *data) = 0;

  /* long get4xProfileCount (); */
  NS_IMETHOD Get4xProfileCount(PRInt32 *_retval) = 0;

  /* void migrateAllProfiles (); */
  NS_IMETHOD MigrateAllProfiles(void) = 0;

  /* void cloneProfile (in string profileName); */
  NS_IMETHOD CloneProfile(const char *profileName) = 0;

  /* void forgetCurrentProfile (); */
  NS_IMETHOD ForgetCurrentProfile(void) = 0;

  /* void loadNewProfilePrefs (); */
  NS_IMETHOD LoadNewProfilePrefs(void) = 0;

  /* boolean isCurrentProfileAvailable (); */
  NS_IMETHOD IsCurrentProfileAvailable(PRBool *_retval) = 0;

  /* attribute boolean automigrate; */
  NS_IMETHOD GetAutomigrate(PRBool *aAutomigrate) = 0;
  NS_IMETHOD SetAutomigrate(PRBool aAutomigrate) = 0;

  /* readonly attribute nsIFileSpec defaultProfileParentDir; */
  NS_IMETHOD GetDefaultProfileParentDir(nsIFileSpec * *aDefaultProfileParentDir) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPROFILE \
  NS_IMETHOD StartupWithArgs(nsICmdLineService *cmdLine); \
  NS_IMETHOD Startup(const char *filename); \
  NS_IMETHOD GetProfileDir(const char *profileName, nsFileSpec * profileDir); \
  NS_IMETHOD GetProfileCount(PRInt32 *aProfileCount); \
  NS_IMETHOD GetCurrentProfile(char * *aCurrentProfile); \
  NS_IMETHOD GetFirstProfile(char * *aFirstProfile); \
  NS_IMETHOD GetCurrentProfileDir(nsFileSpec * profileDir); \
  NS_IMETHOD SetProfileDir(const char *profileName, nsFileSpec & profileDir); \
  NS_IMETHOD ProfileExists(const char *profileName, PRBool *_retval); \
  NS_IMETHOD MigrateProfileInfo(void); \
  NS_IMETHOD CreateNewProfile(const char *profileName, const char *nativeProfileDir); \
  NS_IMETHOD RenameProfile(const char *oldName, const char *newName); \
  NS_IMETHOD DeleteProfile(const char *name, PRBool canDeleteFiles); \
  NS_IMETHOD GetProfileList(char **_retval); \
  NS_IMETHOD StartApprunner(const char *profileName); \
  NS_IMETHOD MigrateProfile(const char *profileName, PRBool showProgressAsModalWindow); \
  NS_IMETHOD GetCookie(char **_retval); \
  NS_IMETHOD ProcessPRegCookie(void); \
  NS_IMETHOD IsPregCookieSet(const char *profileName, char **_retval); \
  NS_IMETHOD ProcessPREGInfo(const char *data); \
  NS_IMETHOD Get4xProfileCount(PRInt32 *_retval); \
  NS_IMETHOD MigrateAllProfiles(void); \
  NS_IMETHOD CloneProfile(const char *profileName); \
  NS_IMETHOD ForgetCurrentProfile(void); \
  NS_IMETHOD LoadNewProfilePrefs(void); \
  NS_IMETHOD IsCurrentProfileAvailable(PRBool *_retval); \
  NS_IMETHOD GetAutomigrate(PRBool *aAutomigrate); \
  NS_IMETHOD SetAutomigrate(PRBool aAutomigrate); \
  NS_IMETHOD GetDefaultProfileParentDir(nsIFileSpec * *aDefaultProfileParentDir); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPROFILE(_to) \
  NS_IMETHOD StartupWithArgs(nsICmdLineService *cmdLine) { return _to ## StartupWithArgs(cmdLine); } \
  NS_IMETHOD Startup(const char *filename) { return _to ## Startup(filename); } \
  NS_IMETHOD GetProfileDir(const char *profileName, nsFileSpec * profileDir) { return _to ## GetProfileDir(profileName, profileDir); } \
  NS_IMETHOD GetProfileCount(PRInt32 *aProfileCount) { return _to ## GetProfileCount(aProfileCount); } \
  NS_IMETHOD GetCurrentProfile(char * *aCurrentProfile) { return _to ## GetCurrentProfile(aCurrentProfile); } \
  NS_IMETHOD GetFirstProfile(char * *aFirstProfile) { return _to ## GetFirstProfile(aFirstProfile); } \
  NS_IMETHOD GetCurrentProfileDir(nsFileSpec * profileDir) { return _to ## GetCurrentProfileDir(profileDir); } \
  NS_IMETHOD SetProfileDir(const char *profileName, nsFileSpec & profileDir) { return _to ## SetProfileDir(profileName, profileDir); } \
  NS_IMETHOD ProfileExists(const char *profileName, PRBool *_retval) { return _to ## ProfileExists(profileName, _retval); } \
  NS_IMETHOD MigrateProfileInfo(void) { return _to ## MigrateProfileInfo(); } \
  NS_IMETHOD CreateNewProfile(const char *profileName, const char *nativeProfileDir) { return _to ## CreateNewProfile(profileName, nativeProfileDir); } \
  NS_IMETHOD RenameProfile(const char *oldName, const char *newName) { return _to ## RenameProfile(oldName, newName); } \
  NS_IMETHOD DeleteProfile(const char *name, PRBool canDeleteFiles) { return _to ## DeleteProfile(name, canDeleteFiles); } \
  NS_IMETHOD GetProfileList(char **_retval) { return _to ## GetProfileList(_retval); } \
  NS_IMETHOD StartApprunner(const char *profileName) { return _to ## StartApprunner(profileName); } \
  NS_IMETHOD MigrateProfile(const char *profileName, PRBool showProgressAsModalWindow) { return _to ## MigrateProfile(profileName, showProgressAsModalWindow); } \
  NS_IMETHOD GetCookie(char **_retval) { return _to ## GetCookie(_retval); } \
  NS_IMETHOD ProcessPRegCookie(void) { return _to ## ProcessPRegCookie(); } \
  NS_IMETHOD IsPregCookieSet(const char *profileName, char **_retval) { return _to ## IsPregCookieSet(profileName, _retval); } \
  NS_IMETHOD ProcessPREGInfo(const char *data) { return _to ## ProcessPREGInfo(data); } \
  NS_IMETHOD Get4xProfileCount(PRInt32 *_retval) { return _to ## Get4xProfileCount(_retval); } \
  NS_IMETHOD MigrateAllProfiles(void) { return _to ## MigrateAllProfiles(); } \
  NS_IMETHOD CloneProfile(const char *profileName) { return _to ## CloneProfile(profileName); } \
  NS_IMETHOD ForgetCurrentProfile(void) { return _to ## ForgetCurrentProfile(); } \
  NS_IMETHOD LoadNewProfilePrefs(void) { return _to ## LoadNewProfilePrefs(); } \
  NS_IMETHOD IsCurrentProfileAvailable(PRBool *_retval) { return _to ## IsCurrentProfileAvailable(_retval); } \
  NS_IMETHOD GetAutomigrate(PRBool *aAutomigrate) { return _to ## GetAutomigrate(aAutomigrate); } \
  NS_IMETHOD SetAutomigrate(PRBool aAutomigrate) { return _to ## SetAutomigrate(aAutomigrate); } \
  NS_IMETHOD GetDefaultProfileParentDir(nsIFileSpec * *aDefaultProfileParentDir) { return _to ## GetDefaultProfileParentDir(aDefaultProfileParentDir); } 


#endif /* __gen_nsIProfile_h__ */
