/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIProgress.idl
 */

#ifndef __gen_nsIProgress_h__
#define __gen_nsIProgress_h__

#include "nsISupports.h"

class nsIProgressListener; /* forward declaration */


/* starting interface:    nsIProgress */
#define NS_IPROGRESS_IID_STR "69e5df04-7b8b-11d3-af61-00a024ffc08c"

#define NS_IPROGRESS_IID \
  {0x69e5df04, 0x7b8b, 0x11d3, \
    { 0xaf, 0x61, 0x00, 0xa0, 0x24, 0xff, 0xc0, 0x8c }}

/**
 * The nsIProgress interface is used to look at the progress of a given browser
 * loading.
 */
class nsIProgress : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPROGRESS_IID)

  enum { step_dns = 1 };

  enum { step_connecting = 2 };

  enum { step_negotiating = 3 };

  enum { step_transferring = 4 };

  enum { step_done = 5 };

  enum { step_failedDNS = 6 };

  enum { step_failedConnect = 7 };

  enum { step_failedTransfer = 8 };

  enum { step_userCancelled = 9 };

  /* void addProgressListener (in nsIProgressListener listener, out long cookie); */
  NS_IMETHOD AddProgressListener(nsIProgressListener *listener, PRInt32 *cookie) = 0;

  /* void removeProgressListener (in nsIProgressListener listener, in long cookie); */
  NS_IMETHOD RemoveProgressListener(nsIProgressListener *listener, PRInt32 cookie) = 0;

  /* readonly attribute long connectionStatus; */
  NS_IMETHOD GetConnectionStatus(PRInt32 *aConnectionStatus) = 0;

  /* readonly attribute boolean active; */
  NS_IMETHOD GetActive(PRBool *aActive) = 0;

  /* readonly attribute long curSelfProgress; */
  NS_IMETHOD GetCurSelfProgress(PRInt32 *aCurSelfProgress) = 0;

  /* readonly attribute long maxSelfProgress; */
  NS_IMETHOD GetMaxSelfProgress(PRInt32 *aMaxSelfProgress) = 0;

  /* readonly attribute long curTotalProgress; */
  NS_IMETHOD GetCurTotalProgress(PRInt32 *aCurTotalProgress) = 0;

  /* readonly attribute long maxTotalProgress; */
  NS_IMETHOD GetMaxTotalProgress(PRInt32 *aMaxTotalProgress) = 0;

  /* void getChildPart (in long childPart, out nsIProgress childProgress); */
  NS_IMETHOD GetChildPart(PRInt32 childPart, nsIProgress **childProgress) = 0;

  /* readonly attribute long numChildParts; */
  NS_IMETHOD GetNumChildParts(PRInt32 *aNumChildParts) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPROGRESS \
  NS_IMETHOD AddProgressListener(nsIProgressListener *listener, PRInt32 *cookie); \
  NS_IMETHOD RemoveProgressListener(nsIProgressListener *listener, PRInt32 cookie); \
  NS_IMETHOD GetConnectionStatus(PRInt32 *aConnectionStatus); \
  NS_IMETHOD GetActive(PRBool *aActive); \
  NS_IMETHOD GetCurSelfProgress(PRInt32 *aCurSelfProgress); \
  NS_IMETHOD GetMaxSelfProgress(PRInt32 *aMaxSelfProgress); \
  NS_IMETHOD GetCurTotalProgress(PRInt32 *aCurTotalProgress); \
  NS_IMETHOD GetMaxTotalProgress(PRInt32 *aMaxTotalProgress); \
  NS_IMETHOD GetChildPart(PRInt32 childPart, nsIProgress **childProgress); \
  NS_IMETHOD GetNumChildParts(PRInt32 *aNumChildParts); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPROGRESS(_to) \
  NS_IMETHOD AddProgressListener(nsIProgressListener *listener, PRInt32 *cookie) { return _to ## AddProgressListener(listener, cookie); } \
  NS_IMETHOD RemoveProgressListener(nsIProgressListener *listener, PRInt32 cookie) { return _to ## RemoveProgressListener(listener, cookie); } \
  NS_IMETHOD GetConnectionStatus(PRInt32 *aConnectionStatus) { return _to ## GetConnectionStatus(aConnectionStatus); } \
  NS_IMETHOD GetActive(PRBool *aActive) { return _to ## GetActive(aActive); } \
  NS_IMETHOD GetCurSelfProgress(PRInt32 *aCurSelfProgress) { return _to ## GetCurSelfProgress(aCurSelfProgress); } \
  NS_IMETHOD GetMaxSelfProgress(PRInt32 *aMaxSelfProgress) { return _to ## GetMaxSelfProgress(aMaxSelfProgress); } \
  NS_IMETHOD GetCurTotalProgress(PRInt32 *aCurTotalProgress) { return _to ## GetCurTotalProgress(aCurTotalProgress); } \
  NS_IMETHOD GetMaxTotalProgress(PRInt32 *aMaxTotalProgress) { return _to ## GetMaxTotalProgress(aMaxTotalProgress); } \
  NS_IMETHOD GetChildPart(PRInt32 childPart, nsIProgress **childProgress) { return _to ## GetChildPart(childPart, childProgress); } \
  NS_IMETHOD GetNumChildParts(PRInt32 *aNumChildParts) { return _to ## GetNumChildParts(aNumChildParts); } 


#endif /* __gen_nsIProgress_h__ */
