/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIProtocolHandler.idl
 */

#ifndef __gen_nsIProtocolHandler_h__
#define __gen_nsIProtocolHandler_h__

#include "nsISupports.h"
#include "nsIChannel.h"

class nsIURI; /* forward declaration */

class nsIInterfaceRequestor; /* forward declaration */

class nsILoadGroup; /* forward declaration */


/* starting interface:    nsIProtocolHandler */
#define NS_IPROTOCOLHANDLER_IID_STR "15fd6940-8ea7-11d3-93ad-00104ba0fd40"

#define NS_IPROTOCOLHANDLER_IID \
  {0x15fd6940, 0x8ea7, 0x11d3, \
    { 0x93, 0xad, 0x00, 0x10, 0x4b, 0xa0, 0xfd, 0x40 }}

class nsIProtocolHandler : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPROTOCOLHANDLER_IID)

  /* readonly attribute string scheme; */
  NS_IMETHOD GetScheme(char * *aScheme) = 0;

  /* readonly attribute long defaultPort; */
  NS_IMETHOD GetDefaultPort(PRInt32 *aDefaultPort) = 0;

  /**
     * Makes a URI object that is suitable for loading by this protocol.
     * In the usual case (when only the accessors provided by nsIURI are 
     * needed), this method just constructs a standard URI using the
     * component manager with kStandardURLCID.
     */
  /* nsIURI newURI (in string aSpec, in nsIURI aBaseURI); */
  NS_IMETHOD NewURI(const char *aSpec, nsIURI *aBaseURI, nsIURI **_retval) = 0;

  /**
     * Constructs a new channel for this protocol handler. 
     *
     * @param originalURI - Specifies the original URI which caused the creation
     * of this channel. This can occur when the construction of one channel
     * (e.g. for resource:) causes another channel to be created on its behalf
     * (e.g. a file: channel), or if a redirect occurs, causing the current
     * URL to become different from the original URL. If NULL, the aURI parameter
     * will be used as the originalURI instead.
     */
  /* nsIChannel newChannel (in string verb, in nsIURI aURI, in nsILoadGroup aLoadGroup, in nsIInterfaceRequestor notificationCallbacks, in nsLoadFlags loadAttributes, in nsIURI originalURI, in unsigned long bufferSegmentSize, in unsigned long bufferMaxSize); */
  NS_IMETHOD NewChannel(const char *verb, nsIURI *aURI, nsILoadGroup *aLoadGroup, nsIInterfaceRequestor *notificationCallbacks, nsLoadFlags loadAttributes, nsIURI *originalURI, PRUint32 bufferSegmentSize, PRUint32 bufferMaxSize, nsIChannel **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPROTOCOLHANDLER \
  NS_IMETHOD GetScheme(char * *aScheme); \
  NS_IMETHOD GetDefaultPort(PRInt32 *aDefaultPort); \
  NS_IMETHOD NewURI(const char *aSpec, nsIURI *aBaseURI, nsIURI **_retval); \
  NS_IMETHOD NewChannel(const char *verb, nsIURI *aURI, nsILoadGroup *aLoadGroup, nsIInterfaceRequestor *notificationCallbacks, nsLoadFlags loadAttributes, nsIURI *originalURI, PRUint32 bufferSegmentSize, PRUint32 bufferMaxSize, nsIChannel **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPROTOCOLHANDLER(_to) \
  NS_IMETHOD GetScheme(char * *aScheme) { return _to ## GetScheme(aScheme); } \
  NS_IMETHOD GetDefaultPort(PRInt32 *aDefaultPort) { return _to ## GetDefaultPort(aDefaultPort); } \
  NS_IMETHOD NewURI(const char *aSpec, nsIURI *aBaseURI, nsIURI **_retval) { return _to ## NewURI(aSpec, aBaseURI, _retval); } \
  NS_IMETHOD NewChannel(const char *verb, nsIURI *aURI, nsILoadGroup *aLoadGroup, nsIInterfaceRequestor *notificationCallbacks, nsLoadFlags loadAttributes, nsIURI *originalURI, PRUint32 bufferSegmentSize, PRUint32 bufferMaxSize, nsIChannel **_retval) { return _to ## NewChannel(verb, aURI, aLoadGroup, notificationCallbacks, loadAttributes, originalURI, bufferSegmentSize, bufferMaxSize, _retval); } 

#define NS_NETWORK_PROTOCOL_PROGID               "component://netscape/network/protocol"
#define NS_NETWORK_PROTOCOL_PROGID_PREFIX        NS_NETWORK_PROTOCOL_PROGID "?name="
#define NS_NETWORK_PROTOCOL_PROGID_PREFIX_LENGTH 43     // nsCRT::strlen(NS_NETWORK_PROTOCOL_PROGID_PREFIX)
// Unknown Protocol Error
#define NS_ERROR_UNKNOWN_PROTOCOL  NS_ERROR_GENERATE_FAILURE(NS_ERROR_MODULE_NETWORK, 18)

#endif /* __gen_nsIProtocolHandler_h__ */
