/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIRegistry.idl
 */

#ifndef __gen_nsIRegistry_h__
#define __gen_nsIRegistry_h__

#include "nsISupports.h"
#include "nsIEnumerator.h"

typedef PRUint32 nsRegistryKey;

typedef PRInt32 nsWellKnownRegistry;


/* starting interface:    nsIRegistry */
#define NS_IREGISTRY_IID_STR "5d41a440-8e37-11d2-8059-00600811a9c3"

#define NS_IREGISTRY_IID \
  {0x5d41a440, 0x8e37, 0x11d2, \
    { 0x80, 0x59, 0x00, 0x60, 0x08, 0x11, 0xa9, 0xc3 }}

class nsIRegistry : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IREGISTRY_IID)

  enum { None = 0 };

  enum { Users = 1 };

  enum { Common = 2 };

  enum { CurrentUser = 3 };

  enum { ApplicationComponentRegistry = 1 };

  enum { ApplicationRegistry = 2 };

  enum { ApplicationCustomRegistry = -1 };

  /* void open (in string regFile); */
  NS_IMETHOD Open(const char *regFile) = 0;

  /* void openWellKnownRegistry (in nsWellKnownRegistry regid); */
  NS_IMETHOD OpenWellKnownRegistry(nsWellKnownRegistry regid) = 0;

  /* void flush (); */
  NS_IMETHOD Flush(void) = 0;

  /* boolean isOpen (); */
  NS_IMETHOD IsOpen(PRBool *_retval) = 0;

  /* nsRegistryKey addKey (in nsRegistryKey baseKey, in wstring keyname); */
  NS_IMETHOD AddKey(nsRegistryKey baseKey, const PRUnichar *keyname, nsRegistryKey *_retval) = 0;

  /* nsRegistryKey getKey (in nsRegistryKey baseKey, in wstring keyname); */
  NS_IMETHOD GetKey(nsRegistryKey baseKey, const PRUnichar *keyname, nsRegistryKey *_retval) = 0;

  /* void removeKey (in nsRegistryKey baseKey, in wstring keyname); */
  NS_IMETHOD RemoveKey(nsRegistryKey baseKey, const PRUnichar *keyname) = 0;

  /* wstring getString (in nsRegistryKey baseKey, in wstring valname); */
  NS_IMETHOD GetString(nsRegistryKey baseKey, const PRUnichar *valname, PRUnichar **_retval) = 0;

  /* void setString (in nsRegistryKey baseKey, in wstring valname, in wstring value); */
  NS_IMETHOD SetString(nsRegistryKey baseKey, const PRUnichar *valname, const PRUnichar *value) = 0;

  /* string getStringUTF8 (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD GetStringUTF8(nsRegistryKey baseKey, const char *path, char **_retval) = 0;

  /* void setStringUTF8 (in nsRegistryKey baseKey, in string path, in string value); */
  NS_IMETHOD SetStringUTF8(nsRegistryKey baseKey, const char *path, const char *value) = 0;

  /* PRInt32 getInt (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD GetInt(nsRegistryKey baseKey, const char *path, PRInt32 *_retval) = 0;

  /* void setInt (in nsRegistryKey baseKey, in string path, in PRInt32 value); */
  NS_IMETHOD SetInt(nsRegistryKey baseKey, const char *path, PRInt32 value) = 0;

  /* PRInt64 getLongLong (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD GetLongLong(nsRegistryKey baseKey, const char *path, PRInt64 *_retval) = 0;

  /* void setLongLong (in nsRegistryKey baseKey, in string path, inout PRInt64 value); */
  NS_IMETHOD SetLongLong(nsRegistryKey baseKey, const char *path, PRInt64 *value) = 0;

  /* nsRegistryKey addSubtree (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD AddSubtree(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval) = 0;

  /* void removeSubtree (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD RemoveSubtree(nsRegistryKey baseKey, const char *path) = 0;

  /* nsRegistryKey getSubtree (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD GetSubtree(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval) = 0;

  /* nsRegistryKey addSubtreeRaw (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD AddSubtreeRaw(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval) = 0;

  /* void removeSubtreeRaw (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD RemoveSubtreeRaw(nsRegistryKey baseKey, const char *path) = 0;

  /* nsRegistryKey getSubtreeRaw (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD GetSubtreeRaw(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval) = 0;

  /* nsIEnumerator enumerateSubtrees (in nsRegistryKey baseKey); */
  NS_IMETHOD EnumerateSubtrees(nsRegistryKey baseKey, nsIEnumerator **_retval) = 0;

  /* nsIEnumerator enumerateAllSubtrees (in nsRegistryKey baseKey); */
  NS_IMETHOD EnumerateAllSubtrees(nsRegistryKey baseKey, nsIEnumerator **_retval) = 0;

  /* nsIEnumerator enumerateValues (in nsRegistryKey baseKey); */
  NS_IMETHOD EnumerateValues(nsRegistryKey baseKey, nsIEnumerator **_retval) = 0;

  enum { String = 1 };

  enum { Int32 = 2 };

  enum { Bytes = 3 };

  enum { File = 4 };

  /* unsigned long getValueType (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD GetValueType(nsRegistryKey baseKey, const char *path, PRUint32 *_retval) = 0;

  /* PRUint32 getValueLength (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD GetValueLength(nsRegistryKey baseKey, const char *path, PRUint32 *_retval) = 0;

  /* void deleteValue (in nsRegistryKey baseKey, in string path); */
  NS_IMETHOD DeleteValue(nsRegistryKey baseKey, const char *path) = 0;

  /* attribute string currentUserName; */
  NS_IMETHOD GetCurrentUserName(char * *aCurrentUserName) = 0;
  NS_IMETHOD SetCurrentUserName(const char * aCurrentUserName) = 0;

  /* void pack (); */
  NS_IMETHOD Pack(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIREGISTRY \
  NS_IMETHOD Open(const char *regFile); \
  NS_IMETHOD OpenWellKnownRegistry(nsWellKnownRegistry regid); \
  NS_IMETHOD Flush(void); \
  NS_IMETHOD IsOpen(PRBool *_retval); \
  NS_IMETHOD AddKey(nsRegistryKey baseKey, const PRUnichar *keyname, nsRegistryKey *_retval); \
  NS_IMETHOD GetKey(nsRegistryKey baseKey, const PRUnichar *keyname, nsRegistryKey *_retval); \
  NS_IMETHOD RemoveKey(nsRegistryKey baseKey, const PRUnichar *keyname); \
  NS_IMETHOD GetString(nsRegistryKey baseKey, const PRUnichar *valname, PRUnichar **_retval); \
  NS_IMETHOD SetString(nsRegistryKey baseKey, const PRUnichar *valname, const PRUnichar *value); \
  NS_IMETHOD GetStringUTF8(nsRegistryKey baseKey, const char *path, char **_retval); \
  NS_IMETHOD SetStringUTF8(nsRegistryKey baseKey, const char *path, const char *value); \
  NS_IMETHOD GetInt(nsRegistryKey baseKey, const char *path, PRInt32 *_retval); \
  NS_IMETHOD SetInt(nsRegistryKey baseKey, const char *path, PRInt32 value); \
  NS_IMETHOD GetLongLong(nsRegistryKey baseKey, const char *path, PRInt64 *_retval); \
  NS_IMETHOD SetLongLong(nsRegistryKey baseKey, const char *path, PRInt64 *value); \
  NS_IMETHOD AddSubtree(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval); \
  NS_IMETHOD RemoveSubtree(nsRegistryKey baseKey, const char *path); \
  NS_IMETHOD GetSubtree(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval); \
  NS_IMETHOD AddSubtreeRaw(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval); \
  NS_IMETHOD RemoveSubtreeRaw(nsRegistryKey baseKey, const char *path); \
  NS_IMETHOD GetSubtreeRaw(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval); \
  NS_IMETHOD EnumerateSubtrees(nsRegistryKey baseKey, nsIEnumerator **_retval); \
  NS_IMETHOD EnumerateAllSubtrees(nsRegistryKey baseKey, nsIEnumerator **_retval); \
  NS_IMETHOD EnumerateValues(nsRegistryKey baseKey, nsIEnumerator **_retval); \
  NS_IMETHOD GetValueType(nsRegistryKey baseKey, const char *path, PRUint32 *_retval); \
  NS_IMETHOD GetValueLength(nsRegistryKey baseKey, const char *path, PRUint32 *_retval); \
  NS_IMETHOD DeleteValue(nsRegistryKey baseKey, const char *path); \
  NS_IMETHOD GetCurrentUserName(char * *aCurrentUserName); \
  NS_IMETHOD SetCurrentUserName(const char * aCurrentUserName); \
  NS_IMETHOD Pack(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIREGISTRY(_to) \
  NS_IMETHOD Open(const char *regFile) { return _to ## Open(regFile); } \
  NS_IMETHOD OpenWellKnownRegistry(nsWellKnownRegistry regid) { return _to ## OpenWellKnownRegistry(regid); } \
  NS_IMETHOD Flush(void) { return _to ## Flush(); } \
  NS_IMETHOD IsOpen(PRBool *_retval) { return _to ## IsOpen(_retval); } \
  NS_IMETHOD AddKey(nsRegistryKey baseKey, const PRUnichar *keyname, nsRegistryKey *_retval) { return _to ## AddKey(baseKey, keyname, _retval); } \
  NS_IMETHOD GetKey(nsRegistryKey baseKey, const PRUnichar *keyname, nsRegistryKey *_retval) { return _to ## GetKey(baseKey, keyname, _retval); } \
  NS_IMETHOD RemoveKey(nsRegistryKey baseKey, const PRUnichar *keyname) { return _to ## RemoveKey(baseKey, keyname); } \
  NS_IMETHOD GetString(nsRegistryKey baseKey, const PRUnichar *valname, PRUnichar **_retval) { return _to ## GetString(baseKey, valname, _retval); } \
  NS_IMETHOD SetString(nsRegistryKey baseKey, const PRUnichar *valname, const PRUnichar *value) { return _to ## SetString(baseKey, valname, value); } \
  NS_IMETHOD GetStringUTF8(nsRegistryKey baseKey, const char *path, char **_retval) { return _to ## GetStringUTF8(baseKey, path, _retval); } \
  NS_IMETHOD SetStringUTF8(nsRegistryKey baseKey, const char *path, const char *value) { return _to ## SetStringUTF8(baseKey, path, value); } \
  NS_IMETHOD GetInt(nsRegistryKey baseKey, const char *path, PRInt32 *_retval) { return _to ## GetInt(baseKey, path, _retval); } \
  NS_IMETHOD SetInt(nsRegistryKey baseKey, const char *path, PRInt32 value) { return _to ## SetInt(baseKey, path, value); } \
  NS_IMETHOD GetLongLong(nsRegistryKey baseKey, const char *path, PRInt64 *_retval) { return _to ## GetLongLong(baseKey, path, _retval); } \
  NS_IMETHOD SetLongLong(nsRegistryKey baseKey, const char *path, PRInt64 *value) { return _to ## SetLongLong(baseKey, path, value); } \
  NS_IMETHOD AddSubtree(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval) { return _to ## AddSubtree(baseKey, path, _retval); } \
  NS_IMETHOD RemoveSubtree(nsRegistryKey baseKey, const char *path) { return _to ## RemoveSubtree(baseKey, path); } \
  NS_IMETHOD GetSubtree(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval) { return _to ## GetSubtree(baseKey, path, _retval); } \
  NS_IMETHOD AddSubtreeRaw(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval) { return _to ## AddSubtreeRaw(baseKey, path, _retval); } \
  NS_IMETHOD RemoveSubtreeRaw(nsRegistryKey baseKey, const char *path) { return _to ## RemoveSubtreeRaw(baseKey, path); } \
  NS_IMETHOD GetSubtreeRaw(nsRegistryKey baseKey, const char *path, nsRegistryKey *_retval) { return _to ## GetSubtreeRaw(baseKey, path, _retval); } \
  NS_IMETHOD EnumerateSubtrees(nsRegistryKey baseKey, nsIEnumerator **_retval) { return _to ## EnumerateSubtrees(baseKey, _retval); } \
  NS_IMETHOD EnumerateAllSubtrees(nsRegistryKey baseKey, nsIEnumerator **_retval) { return _to ## EnumerateAllSubtrees(baseKey, _retval); } \
  NS_IMETHOD EnumerateValues(nsRegistryKey baseKey, nsIEnumerator **_retval) { return _to ## EnumerateValues(baseKey, _retval); } \
  NS_IMETHOD GetValueType(nsRegistryKey baseKey, const char *path, PRUint32 *_retval) { return _to ## GetValueType(baseKey, path, _retval); } \
  NS_IMETHOD GetValueLength(nsRegistryKey baseKey, const char *path, PRUint32 *_retval) { return _to ## GetValueLength(baseKey, path, _retval); } \
  NS_IMETHOD DeleteValue(nsRegistryKey baseKey, const char *path) { return _to ## DeleteValue(baseKey, path); } \
  NS_IMETHOD GetCurrentUserName(char * *aCurrentUserName) { return _to ## GetCurrentUserName(aCurrentUserName); } \
  NS_IMETHOD SetCurrentUserName(const char * aCurrentUserName) { return _to ## SetCurrentUserName(aCurrentUserName); } \
  NS_IMETHOD Pack(void) { return _to ## Pack(); } 


/* starting interface:    nsIRegistryNode */
#define NS_IREGISTRYNODE_IID_STR "d1b54831-ac07-11d2-805e-00600811a9c3"

#define NS_IREGISTRYNODE_IID \
  {0xd1b54831, 0xac07, 0x11d2, \
    { 0x80, 0x5e, 0x00, 0x60, 0x08, 0x11, 0xa9, 0xc3 }}

class nsIRegistryNode : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IREGISTRYNODE_IID)

  /* readonly attribute string nameUTF8; */
  NS_IMETHOD GetNameUTF8(char * *aNameUTF8) = 0;

  /* readonly attribute wstring name; */
  NS_IMETHOD GetName(PRUnichar * *aName) = 0;

  /* readonly attribute nsRegistryKey key; */
  NS_IMETHOD GetKey(nsRegistryKey *aKey) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIREGISTRYNODE \
  NS_IMETHOD GetNameUTF8(char * *aNameUTF8); \
  NS_IMETHOD GetName(PRUnichar * *aName); \
  NS_IMETHOD GetKey(nsRegistryKey *aKey); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIREGISTRYNODE(_to) \
  NS_IMETHOD GetNameUTF8(char * *aNameUTF8) { return _to ## GetNameUTF8(aNameUTF8); } \
  NS_IMETHOD GetName(PRUnichar * *aName) { return _to ## GetName(aName); } \
  NS_IMETHOD GetKey(nsRegistryKey *aKey) { return _to ## GetKey(aKey); } 


/* starting interface:    nsIRegistryValue */
#define NS_IREGISTRYVALUE_IID_STR "5316c380-b2f8-11d2-a374-0080c6f80e4b"

#define NS_IREGISTRYVALUE_IID \
  {0x5316c380, 0xb2f8, 0x11d2, \
    { 0xa3, 0x74, 0x00, 0x80, 0xc6, 0xf8, 0x0e, 0x4b }}

class nsIRegistryValue : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IREGISTRYVALUE_IID)

  /* readonly attribute wstring name; */
  NS_IMETHOD GetName(PRUnichar * *aName) = 0;

  /* readonly attribute string nameUTF8; */
  NS_IMETHOD GetNameUTF8(char * *aNameUTF8) = 0;

  /* readonly attribute unsigned long type; */
  NS_IMETHOD GetType(PRUint32 *aType) = 0;

  /* readonly attribute PRUint32 length; */
  NS_IMETHOD GetLength(PRUint32 *aLength) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIREGISTRYVALUE \
  NS_IMETHOD GetName(PRUnichar * *aName); \
  NS_IMETHOD GetNameUTF8(char * *aNameUTF8); \
  NS_IMETHOD GetType(PRUint32 *aType); \
  NS_IMETHOD GetLength(PRUint32 *aLength); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIREGISTRYVALUE(_to) \
  NS_IMETHOD GetName(PRUnichar * *aName) { return _to ## GetName(aName); } \
  NS_IMETHOD GetNameUTF8(char * *aNameUTF8) { return _to ## GetNameUTF8(aNameUTF8); } \
  NS_IMETHOD GetType(PRUint32 *aType) { return _to ## GetType(aType); } \
  NS_IMETHOD GetLength(PRUint32 *aLength) { return _to ## GetLength(aLength); } 

#include "nsIRegistryUtils.h"

#endif /* __gen_nsIRegistry_h__ */
