/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsISelectionController.idl
 */

#ifndef __gen_nsISelectionController_h__
#define __gen_nsISelectionController_h__

#include "nsISupports.h"


/* starting interface:    nsISelectionController */
#define NS_ISELECTIONCONTROLLER_IID_STR "d2d1d179-85a7-11d3-9932-00108301233c"

#define NS_ISELECTIONCONTROLLER_IID \
  {0xd2d1d179, 0x85a7, 0x11d3, \
    { 0x99, 0x32, 0x00, 0x10, 0x83, 0x01, 0x23, 0x3c }}

class nsISelectionController : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISELECTIONCONTROLLER_IID)

  /** CharacterMove will move the selection one character forward/backward in the document.
   *  this will also have the effect of collapsing the selection if the aExtend = PR_FALSE
   *  the "point" of selection that is extended is considered the "focus" point. 
   *  or the last point adjusted by the selection.
   *  @param aForward forward or backward if PR_FALSE
   *  @param aExtend  should it collapse the selection of extend it?
   */
  /* void characterMove (in boolean aForward, in boolean aExtend); */
  NS_IMETHOD CharacterMove(PRBool aForward, PRBool aExtend) = 0;

  /** WordMove will move the selection one word forward/backward in the document.
   *  this will also have the effect of collapsing the selection if the aExtend = PR_FALSE
   *  the "point" of selection that is extended is considered the "focus" point. 
   *  or the last point adjusted by the selection.
   *  @param aForward forward or backward if PR_FALSE
   *  @param aExtend  should it collapse the selection of extend it?
   */
  /* void wordMove (in boolean aForward, in boolean aExtend); */
  NS_IMETHOD WordMove(PRBool aForward, PRBool aExtend) = 0;

  /** LineMove will move the selection one line forward/backward in the document.
   *  this will also have the effect of collapsing the selection if the aExtend = PR_FALSE
   *  the "point" of selection that is extended is considered the "focus" point. 
   *  or the last point adjusted by the selection.
   *  @param aForward forward or backward if PR_FALSE
   *  @param aExtend  should it collapse the selection of extend it?
   */
  /* void lineMove (in boolean aForward, in boolean aExtend); */
  NS_IMETHOD LineMove(PRBool aForward, PRBool aExtend) = 0;

  /** IntraLineMove will move the selection to the front of the line or end of the line
   *  in the document.
   *  this will also have the effect of collapsing the selection if the aExtend = PR_FALSE
   *  the "point" of selection that is extended is considered the "focus" point. 
   *  or the last point adjusted by the selection.
   *  @param aForward forward or backward if PR_FALSE
   *  @param aExtend  should it collapse the selection of extend it?
   */
  /* void intraLineMove (in boolean aForward, in boolean aExtend); */
  NS_IMETHOD IntraLineMove(PRBool aForward, PRBool aExtend) = 0;

  /** PageMove will move the selection one page forward/backward in the document.
   *  this will also have the effect of collapsing the selection if the aExtend = PR_FALSE
   *  the "point" of selection that is extended is considered the "focus" point. 
   *  or the last point adjusted by the selection.
   *  @param aForward forward or backward if PR_FALSE
   *  @param aExtend  should it collapse the selection of extend it?
   */
  /* void pageMove (in boolean aForward, in boolean aExtend); */
  NS_IMETHOD PageMove(PRBool aForward, PRBool aExtend) = 0;

  /** CompleteScroll will move page view to the top or bottom of the document
   *  @param aForward forward or backward if PR_FALSE
   */
  /* void completeScroll (in boolean aForward); */
  NS_IMETHOD CompleteScroll(PRBool aForward) = 0;

  /** CompleteMove will move page view to the top or bottom of the document
   *  this will also have the effect of collapsing the selection if the aExtend = PR_FALSE
   *  the "point" of selection that is extended is considered the "focus" point. 
   *  or the last point adjusted by the selection.
   *  @param aForward forward or backward if PR_FALSE
   *  @param aExtend  should it collapse the selection of extend it?
   */
  /* void completeMove (in boolean aForward, in boolean aExtend); */
  NS_IMETHOD CompleteMove(PRBool aForward, PRBool aExtend) = 0;

  /** ScrollPage will scroll the page without affecting the selection.
   *  @param aForward scroll forward or backwards in selection
   */
  /* void scrollPage (in boolean aForward); */
  NS_IMETHOD ScrollPage(PRBool aForward) = 0;

  /** ScrolLine will scroll line up or down dependent on the boolean
   *  @param aForward scroll forward or backwards in selection
   */
  /* void scrollLine (in boolean aForward); */
  NS_IMETHOD ScrollLine(PRBool aForward) = 0;

  /** ScrolHorizontal will scroll left or right dependent on the boolean
   *  @param aLeft if true will scroll left. if not will scroll right.
   */
  /* void scrollHorizontal (in boolean aLeft); */
  NS_IMETHOD ScrollHorizontal(PRBool aLeft) = 0;

  /** SelectAll will select the whole page
   */
  /* void selectAll (); */
  NS_IMETHOD SelectAll(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISELECTIONCONTROLLER \
  NS_IMETHOD CharacterMove(PRBool aForward, PRBool aExtend); \
  NS_IMETHOD WordMove(PRBool aForward, PRBool aExtend); \
  NS_IMETHOD LineMove(PRBool aForward, PRBool aExtend); \
  NS_IMETHOD IntraLineMove(PRBool aForward, PRBool aExtend); \
  NS_IMETHOD PageMove(PRBool aForward, PRBool aExtend); \
  NS_IMETHOD CompleteScroll(PRBool aForward); \
  NS_IMETHOD CompleteMove(PRBool aForward, PRBool aExtend); \
  NS_IMETHOD ScrollPage(PRBool aForward); \
  NS_IMETHOD ScrollLine(PRBool aForward); \
  NS_IMETHOD ScrollHorizontal(PRBool aLeft); \
  NS_IMETHOD SelectAll(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISELECTIONCONTROLLER(_to) \
  NS_IMETHOD CharacterMove(PRBool aForward, PRBool aExtend) { return _to ## CharacterMove(aForward, aExtend); } \
  NS_IMETHOD WordMove(PRBool aForward, PRBool aExtend) { return _to ## WordMove(aForward, aExtend); } \
  NS_IMETHOD LineMove(PRBool aForward, PRBool aExtend) { return _to ## LineMove(aForward, aExtend); } \
  NS_IMETHOD IntraLineMove(PRBool aForward, PRBool aExtend) { return _to ## IntraLineMove(aForward, aExtend); } \
  NS_IMETHOD PageMove(PRBool aForward, PRBool aExtend) { return _to ## PageMove(aForward, aExtend); } \
  NS_IMETHOD CompleteScroll(PRBool aForward) { return _to ## CompleteScroll(aForward); } \
  NS_IMETHOD CompleteMove(PRBool aForward, PRBool aExtend) { return _to ## CompleteMove(aForward, aExtend); } \
  NS_IMETHOD ScrollPage(PRBool aForward) { return _to ## ScrollPage(aForward); } \
  NS_IMETHOD ScrollLine(PRBool aForward) { return _to ## ScrollLine(aForward); } \
  NS_IMETHOD ScrollHorizontal(PRBool aLeft) { return _to ## ScrollHorizontal(aLeft); } \
  NS_IMETHOD SelectAll(void) { return _to ## SelectAll(); } 

   #define NS_ISELECTIONCONTROLLER_CID \
   { 0xd2d1d179, 0x85a7, 0x11d3, \
   { 0x99, 0x32, 0x0, 0x10, 0x83, 0x1, 0x23, 0x3c }}

#endif /* __gen_nsISelectionController_h__ */
