/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsISmtpService.idl
 */

#ifndef __gen_nsISmtpService_h__
#define __gen_nsISmtpService_h__

#include "nsISupports.h"
#include "nsIFileSpec.h"

class nsISmtpServer; /* forward declaration */

class nsIURI; /* forward declaration */

class nsIUrlListener; /* forward declaration */

class nsISupportsArray; /* forward declaration */

class nsIMsgIdentity; /* forward declaration */

class nsINetPrompt; /* forward declaration */


/* starting interface:    nsISmtpService */
#define NS_ISMTPSERVICE_IID_STR "fbaf0f10-ca9b-11d2-8063-006008128c4e"

#define NS_ISMTPSERVICE_IID \
  {0xfbaf0f10, 0xca9b, 0x11d2, \
    { 0x80, 0x63, 0x00, 0x60, 0x08, 0x12, 0x8c, 0x4e }}

class nsISmtpService : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISMTPSERVICE_IID)

  /* void SendMailMessage (in nsIFileSpec aFilePath, in string aRecipients, in nsIMsgIdentity aSenderIdentity, in nsIUrlListener aUrlListener, in nsISmtpServer aServer, in nsINetPrompt aNetPrompt, out nsIURI aURL); */
  NS_IMETHOD SendMailMessage(nsIFileSpec *aFilePath, const char *aRecipients, nsIMsgIdentity *aSenderIdentity, nsIUrlListener *aUrlListener, nsISmtpServer *aServer, nsINetPrompt *aNetPrompt, nsIURI **aURL) = 0;

  /**
   * A copy of the array of SMTP servers, as stored in the preferences
   */
  /* readonly attribute nsISupportsArray smtpServers; */
  NS_IMETHOD GetSmtpServers(nsISupportsArray * *aSmtpServers) = 0;

  /**
   * The default server, across sessions of the app
   * (eventually there will be a session default which does not
   * persist past shutdown)
   */
  /* attribute nsISmtpServer defaultServer; */
  NS_IMETHOD GetDefaultServer(nsISmtpServer * *aDefaultServer) = 0;
  NS_IMETHOD SetDefaultServer(nsISmtpServer * aDefaultServer) = 0;

  /**
   * create a new SMTP server.
   * Use this instead of createInstance(), so that the SMTP Service can
   * be aware of this server
   */
  /* nsISmtpServer createSmtpServer (); */
  NS_IMETHOD CreateSmtpServer(nsISmtpServer **_retval) = 0;

  /**
   * find the server with the given hostname.
   * @param hostname the hostname of the server
   * @returns null if no server is found
   */
  /* nsISmtpServer findServer (in string hostname); */
  NS_IMETHOD FindServer(const char *hostname, nsISmtpServer **_retval) = 0;

  /**
   * look up the server with the given key
   * if the server does not exist, create it and add it to our list
   */
  /* nsISmtpServer getServerByKey (in string key); */
  NS_IMETHOD GetServerByKey(const char *key, nsISmtpServer **_retval) = 0;

  /**
   * delete the given server from the server list.
   * does nothing if the server does not exist
   * @param server the server to delete. Use findServer() if you only know
   *   the hostname
   */
  /* void deleteSmtpServer (in nsISmtpServer server); */
  NS_IMETHOD DeleteSmtpServer(nsISmtpServer *server) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISMTPSERVICE \
  NS_IMETHOD SendMailMessage(nsIFileSpec *aFilePath, const char *aRecipients, nsIMsgIdentity *aSenderIdentity, nsIUrlListener *aUrlListener, nsISmtpServer *aServer, nsINetPrompt *aNetPrompt, nsIURI **aURL); \
  NS_IMETHOD GetSmtpServers(nsISupportsArray * *aSmtpServers); \
  NS_IMETHOD GetDefaultServer(nsISmtpServer * *aDefaultServer); \
  NS_IMETHOD SetDefaultServer(nsISmtpServer * aDefaultServer); \
  NS_IMETHOD CreateSmtpServer(nsISmtpServer **_retval); \
  NS_IMETHOD FindServer(const char *hostname, nsISmtpServer **_retval); \
  NS_IMETHOD GetServerByKey(const char *key, nsISmtpServer **_retval); \
  NS_IMETHOD DeleteSmtpServer(nsISmtpServer *server); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISMTPSERVICE(_to) \
  NS_IMETHOD SendMailMessage(nsIFileSpec *aFilePath, const char *aRecipients, nsIMsgIdentity *aSenderIdentity, nsIUrlListener *aUrlListener, nsISmtpServer *aServer, nsINetPrompt *aNetPrompt, nsIURI **aURL) { return _to ## SendMailMessage(aFilePath, aRecipients, aSenderIdentity, aUrlListener, aServer, aNetPrompt, aURL); } \
  NS_IMETHOD GetSmtpServers(nsISupportsArray * *aSmtpServers) { return _to ## GetSmtpServers(aSmtpServers); } \
  NS_IMETHOD GetDefaultServer(nsISmtpServer * *aDefaultServer) { return _to ## GetDefaultServer(aDefaultServer); } \
  NS_IMETHOD SetDefaultServer(nsISmtpServer * aDefaultServer) { return _to ## SetDefaultServer(aDefaultServer); } \
  NS_IMETHOD CreateSmtpServer(nsISmtpServer **_retval) { return _to ## CreateSmtpServer(_retval); } \
  NS_IMETHOD FindServer(const char *hostname, nsISmtpServer **_retval) { return _to ## FindServer(hostname, _retval); } \
  NS_IMETHOD GetServerByKey(const char *key, nsISmtpServer **_retval) { return _to ## GetServerByKey(key, _retval); } \
  NS_IMETHOD DeleteSmtpServer(nsISmtpServer *server) { return _to ## DeleteSmtpServer(server); } 


#endif /* __gen_nsISmtpService_h__ */
