/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsISocketTransportService.idl
 */

#ifndef __gen_nsISocketTransportService_h__
#define __gen_nsISocketTransportService_h__

#include "nsISupports.h"

class nsIChannel; /* forward declaration */

class nsIEventSinkGetter; /* forward declaration */


/* starting interface:    nsISocketTransportService */
#define NS_ISOCKETTRANSPORTSERVICE_IID_STR "05331390-6884-11d3-9382-00104ba0fd40"

#define NS_ISOCKETTRANSPORTSERVICE_IID \
  {0x05331390, 0x6884, 0x11d3, \
    { 0x93, 0x82, 0x00, 0x10, 0x4b, 0xa0, 0xfd, 0x40 }}

class nsISocketTransportService : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISOCKETTRANSPORTSERVICE_IID)

  /**
     * Creates a transport for a specified host and port. 
     * The eventSinkGetter is used to get the appropriate callbacks
     * for the socket activity from the application. These include
     * the progress and the status messages like "Contacting host.."
     * etc. The printHost contains the actual hostname (and not the 
     * proxy) for displaying in status messages. 
     */
  /* nsIChannel createTransport (in string host, in long port, in string printHost, in unsigned long bufferSegmentSize, in unsigned long bufferMaxSize); */
  NS_IMETHOD CreateTransport(const char *host, PRInt32 port, const char *printHost, PRUint32 bufferSegmentSize, PRUint32 bufferMaxSize, nsIChannel **_retval) = 0;

  /* nsIChannel createTransportOfType (in string socketType, in string host, in long port, in string printHost, in unsigned long bufferSegmentSize, in unsigned long bufferMaxSize); */
  NS_IMETHOD CreateTransportOfType(const char *socketType, const char *host, PRInt32 port, const char *printHost, PRUint32 bufferSegmentSize, PRUint32 bufferMaxSize, nsIChannel **_retval) = 0;

  /**
     * Returns true if the specified transport is good enough for 
     * being used again. The situations in which this may return false
     * include- an error including server resets, an explicit 
     * Connection: close header (for HTTP) and timeouts! 
     */
  /* boolean reuseTransport (in nsIChannel i_Transport); */
  NS_IMETHOD ReuseTransport(nsIChannel *i_Transport, PRBool *_retval) = 0;

  /* void shutdown (); */
  NS_IMETHOD Shutdown(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISOCKETTRANSPORTSERVICE \
  NS_IMETHOD CreateTransport(const char *host, PRInt32 port, const char *printHost, PRUint32 bufferSegmentSize, PRUint32 bufferMaxSize, nsIChannel **_retval); \
  NS_IMETHOD CreateTransportOfType(const char *socketType, const char *host, PRInt32 port, const char *printHost, PRUint32 bufferSegmentSize, PRUint32 bufferMaxSize, nsIChannel **_retval); \
  NS_IMETHOD ReuseTransport(nsIChannel *i_Transport, PRBool *_retval); \
  NS_IMETHOD Shutdown(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISOCKETTRANSPORTSERVICE(_to) \
  NS_IMETHOD CreateTransport(const char *host, PRInt32 port, const char *printHost, PRUint32 bufferSegmentSize, PRUint32 bufferMaxSize, nsIChannel **_retval) { return _to ## CreateTransport(host, port, printHost, bufferSegmentSize, bufferMaxSize, _retval); } \
  NS_IMETHOD CreateTransportOfType(const char *socketType, const char *host, PRInt32 port, const char *printHost, PRUint32 bufferSegmentSize, PRUint32 bufferMaxSize, nsIChannel **_retval) { return _to ## CreateTransportOfType(socketType, host, port, printHost, bufferSegmentSize, bufferMaxSize, _retval); } \
  NS_IMETHOD ReuseTransport(nsIChannel *i_Transport, PRBool *_retval) { return _to ## ReuseTransport(i_Transport, _retval); } \
  NS_IMETHOD Shutdown(void) { return _to ## Shutdown(); } 

#define NS_SOCKETTRANSPORTSERVICE_CID                \
{ /* c07e81e0-ef12-11d2-92b6-00105a1b0d64 */         \
    0xc07e81e0,                                      \
    0xef12,                                          \
    0x11d2,                                          \
    {0x92, 0xb6, 0x00, 0x10, 0x5a, 0x1b, 0x0d, 0x64} \
}

#endif /* __gen_nsISocketTransportService_h__ */
