/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIStreamObserver.idl
 */

#ifndef __gen_nsIStreamObserver_h__
#define __gen_nsIStreamObserver_h__

#include "nsISupports.h"

class nsIEventQueue; /* forward declaration */

class nsIChannel; /* forward declaration */


/* starting interface:    nsIStreamObserver */
#define NS_ISTREAMOBSERVER_IID_STR "fd91e2e0-1481-11d3-9333-00104ba0fd40"

#define NS_ISTREAMOBSERVER_IID \
  {0xfd91e2e0, 0x1481, 0x11d3, \
    { 0x93, 0x33, 0x00, 0x10, 0x4b, 0xa0, 0xfd, 0x40 }}

class nsIStreamObserver : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISTREAMOBSERVER_IID)

  /* void onStartRequest (in nsIChannel channel, in nsISupports ctxt); */
  NS_IMETHOD OnStartRequest(nsIChannel *channel, nsISupports *ctxt) = 0;

  /* void onStopRequest (in nsIChannel channel, in nsISupports ctxt, in nsresult status, in wstring errorMsg); */
  NS_IMETHOD OnStopRequest(nsIChannel *channel, nsISupports *ctxt, nsresult status, const PRUnichar *errorMsg) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISTREAMOBSERVER \
  NS_IMETHOD OnStartRequest(nsIChannel *channel, nsISupports *ctxt); \
  NS_IMETHOD OnStopRequest(nsIChannel *channel, nsISupports *ctxt, nsresult status, const PRUnichar *errorMsg); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISTREAMOBSERVER(_to) \
  NS_IMETHOD OnStartRequest(nsIChannel *channel, nsISupports *ctxt) { return _to ## OnStartRequest(channel, ctxt); } \
  NS_IMETHOD OnStopRequest(nsIChannel *channel, nsISupports *ctxt, nsresult status, const PRUnichar *errorMsg) { return _to ## OnStopRequest(channel, ctxt, status, errorMsg); } 


/* starting interface:    nsIAsyncStreamObserver */
#define NS_IASYNCSTREAMOBSERVER_IID_STR "a28dc590-91b3-11d3-8cd9-0060b0fc14a3"

#define NS_IASYNCSTREAMOBSERVER_IID \
  {0xa28dc590, 0x91b3, 0x11d3, \
    { 0x8c, 0xd9, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3 }}

/**
 * An asynchronous stream observer is used to ship data over to another thread specified
 * by the thread's event queue. The receiver stream observer is then used to receive
 * the notifications on the other thread. 
 *
 * This interface only provides the initialization needed after construction. Otherwise,
 * these objects are used simply as nsIStreamObservers.
 */
class nsIAsyncStreamObserver : public nsIStreamObserver {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IASYNCSTREAMOBSERVER_IID)

  /**
     * Initializes an nsIAsyncStreamObserver. 
     * @param eventQueue - may be null indicating the calling thread's event queue
     */
  /* void init (in nsIStreamObserver receiver, in nsIEventQueue eventQueue); */
  NS_IMETHOD Init(nsIStreamObserver *receiver, nsIEventQueue *eventQueue) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIASYNCSTREAMOBSERVER \
  NS_IMETHOD Init(nsIStreamObserver *receiver, nsIEventQueue *eventQueue); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIASYNCSTREAMOBSERVER(_to) \
  NS_IMETHOD Init(nsIStreamObserver *receiver, nsIEventQueue *eventQueue) { return _to ## Init(receiver, eventQueue); } 

// Use this CID to construct an nsIAsyncStreamObserver
#define NS_ASYNCSTREAMOBSERVER_CID                   \
{ /* fcc7c380-91b3-11d3-8cd9-0060b0fc14a3 */         \
    0xfcc7c380,                                      \
    0x91b3,                                          \
    0x11d3,                                          \
    {0x8c, 0xd9, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3} \
}
////////////////////////////////////////////////////////////////////////////////
// Generic status codes for OnStopRequest:
#define NS_BINDING_SUCCEEDED    NS_OK
#define NS_BINDING_FAILED       NS_ERROR_GENERATE_FAILURE(NS_ERROR_MODULE_NETWORK, 1)
#define NS_BINDING_ABORTED      NS_ERROR_GENERATE_FAILURE(NS_ERROR_MODULE_NETWORK, 2)

#endif /* __gen_nsIStreamObserver_h__ */
