/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIZipReader.idl
 */

#ifndef __gen_nsIZipReader_h__
#define __gen_nsIZipReader_h__

#include "nsISupports.h"

class nsISimpleEnumerator; /* forward declaration */

class nsIInputStream; /* forward declaration */

class nsIPrincipal; /* forward declaration */

class nsIFile; /* forward declaration */


/* starting interface:    nsIZipEntry */
#define NS_IZIPENTRY_IID_STR "6ca5e43e-9632-11d3-8cd9-0060b0fc14a3"

#define NS_IZIPENTRY_IID \
  {0x6ca5e43e, 0x9632, 0x11d3, \
    { 0x8c, 0xd9, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3 }}

class nsIZipEntry : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IZIPENTRY_IID)

  /* readonly attribute string name; */
  NS_IMETHOD GetName(char * *aName) = 0;

  /* readonly attribute unsigned short compression; */
  NS_IMETHOD GetCompression(PRUint16 *aCompression) = 0;

  /* readonly attribute unsigned long size; */
  NS_IMETHOD GetSize(PRUint32 *aSize) = 0;

  /* readonly attribute unsigned long realSize; */
  NS_IMETHOD GetRealSize(PRUint32 *aRealSize) = 0;

  /* readonly attribute unsigned long CRC32; */
  NS_IMETHOD GetCRC32(PRUint32 *aCRC32) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIZIPENTRY \
  NS_IMETHOD GetName(char * *aName); \
  NS_IMETHOD GetCompression(PRUint16 *aCompression); \
  NS_IMETHOD GetSize(PRUint32 *aSize); \
  NS_IMETHOD GetRealSize(PRUint32 *aRealSize); \
  NS_IMETHOD GetCRC32(PRUint32 *aCRC32); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIZIPENTRY(_to) \
  NS_IMETHOD GetName(char * *aName) { return _to ## GetName(aName); } \
  NS_IMETHOD GetCompression(PRUint16 *aCompression) { return _to ## GetCompression(aCompression); } \
  NS_IMETHOD GetSize(PRUint32 *aSize) { return _to ## GetSize(aSize); } \
  NS_IMETHOD GetRealSize(PRUint32 *aRealSize) { return _to ## GetRealSize(aRealSize); } \
  NS_IMETHOD GetCRC32(PRUint32 *aCRC32) { return _to ## GetCRC32(aCRC32); } 


/* starting interface:    nsIZipReader */
#define NS_IZIPREADER_IID_STR "6ff6a966-9632-11d3-8cd9-0060b0fc14a3"

#define NS_IZIPREADER_IID \
  {0x6ff6a966, 0x9632, 0x11d3, \
    { 0x8c, 0xd9, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3 }}

class nsIZipReader : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IZIPREADER_IID)

  /**
     * Initializes a zip reader after construction.
     */
  /* void init (in nsIFile zipFile); */
  NS_IMETHOD Init(nsIFile *zipFile) = 0;

  /**
     * Opens a zip reader.
     */
  /* void open (); */
  NS_IMETHOD Open(void) = 0;

  /**
     * Parses meta-information for the jar format. Must be called before calls 
     * to getPrincipal and verifyExternalFile.
     */
  /* void parseManifest (); */
  NS_IMETHOD ParseManifest(void) = 0;

  /**
     * Closes a zip reader. Subsequent attempts to extract files or read from
     * its input stream will result in an error.
     */
  /* void close (); */
  NS_IMETHOD Close(void) = 0;

  /**
     * Extracts a zip entry into a local file specified by outFile.
     */
  /* void extract (in string zipEntry, in nsIFile outFile); */
  NS_IMETHOD Extract(const char *zipEntry, nsIFile *outFile) = 0;

  /**
     * Returns a nsIZipEntry describing a specified zip entry.
     */
  /* nsIZipEntry getEntry (in string zipEntry); */
  NS_IMETHOD GetEntry(const char *zipEntry, nsIZipEntry **_retval) = 0;

  /**
     * Returns a simple enumerator whose elements are of type nsIZipEntry.
     */
  /* nsISimpleEnumerator findEntries (in string aPattern); */
  NS_IMETHOD FindEntries(const char *aPattern, nsISimpleEnumerator **_retval) = 0;

  /**
     * Returns an input stream containing the contents of the specified zip entry.
     */
  /* nsIInputStream getInputStream (in string zipEntry); */
  NS_IMETHOD GetInputStream(const char *zipEntry, nsIInputStream **_retval) = 0;

  /**
     * Returns an object describing the owner (origin and/or signer) of 
     * an entry. parseManifest must be called first. If aEntryName is an
     * entry in the jar, getInputStream must be called after parseManifest.
     * If aEntryName is an external file which has meta-information 
     * stored in the jar, verifyExternalFile (not yet implemented) must 
     * be called before getPrincipal.
     */
  /* nsIPrincipal getPrincipal (in string aEntryName); */
  NS_IMETHOD GetPrincipal(const char *aEntryName, nsIPrincipal **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIZIPREADER \
  NS_IMETHOD Init(nsIFile *zipFile); \
  NS_IMETHOD Open(void); \
  NS_IMETHOD ParseManifest(void); \
  NS_IMETHOD Close(void); \
  NS_IMETHOD Extract(const char *zipEntry, nsIFile *outFile); \
  NS_IMETHOD GetEntry(const char *zipEntry, nsIZipEntry **_retval); \
  NS_IMETHOD FindEntries(const char *aPattern, nsISimpleEnumerator **_retval); \
  NS_IMETHOD GetInputStream(const char *zipEntry, nsIInputStream **_retval); \
  NS_IMETHOD GetPrincipal(const char *aEntryName, nsIPrincipal **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIZIPREADER(_to) \
  NS_IMETHOD Init(nsIFile *zipFile) { return _to ## Init(zipFile); } \
  NS_IMETHOD Open(void) { return _to ## Open(); } \
  NS_IMETHOD ParseManifest(void) { return _to ## ParseManifest(); } \
  NS_IMETHOD Close(void) { return _to ## Close(); } \
  NS_IMETHOD Extract(const char *zipEntry, nsIFile *outFile) { return _to ## Extract(zipEntry, outFile); } \
  NS_IMETHOD GetEntry(const char *zipEntry, nsIZipEntry **_retval) { return _to ## GetEntry(zipEntry, _retval); } \
  NS_IMETHOD FindEntries(const char *aPattern, nsISimpleEnumerator **_retval) { return _to ## FindEntries(aPattern, _retval); } \
  NS_IMETHOD GetInputStream(const char *zipEntry, nsIInputStream **_retval) { return _to ## GetInputStream(zipEntry, _retval); } \
  NS_IMETHOD GetPrincipal(const char *aEntryName, nsIPrincipal **_retval) { return _to ## GetPrincipal(aEntryName, _retval); } 

#define NS_ZIPREADER_CID                             \
{ /* 7526a738-9632-11d3-8cd9-0060b0fc14a3 */         \
    0x7526a738,                                      \
    0x9632,                                          \
    0x11d3,                                          \
    {0x8c, 0xd9, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3} \
}

#endif /* __gen_nsIZipReader_h__ */
