/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIAppShellService.idl
 */

#ifndef __gen_nsIAppShellService_h__
#define __gen_nsIAppShellService_h__

#include "nsISupports.h"
#include "domstubs.h"

#include "nscore.h"
#include "nsCom.h"
#include "nsISplashScreen.h"
class nsIWebShellWindow; /* forward declaration */

class nsIURI; /* forward declaration */

class nsIXULWindowCallbacks; /* forward declaration */

class nsICmdLineService; /* forward declaration */

class nsISplashScreen; /* forward declaration */

/* Forward declarations... */
struct PRThread;
class nsIFactory;
struct JSContext;
#define NS_SIZETOCONTENT -1
// e5e5af70-8a38-11d2-9938-0080c7cb1080
#define NS_IAPPSHELL_SERVICE_IID \
{ 0xe5e5af70, 0x8a38, 0x11d2, \
	{0x99, 0x38, 0x00, 0x80, 0xc7, 0xcb, 0x10, 0x80} }

/* starting interface:    nsIAppShellService */
#define NS_IAPPSHELLSERVICE_IID_STR "e5e5af70-8a38-11d2-9938-0080c7cb1080"

#define NS_IAPPSHELLSERVICE_IID \
  {0xe5e5af70, 0x8a38, 0x11d2, \
    { 0x99, 0x38, 0x00, 0x80, 0xc7, 0xcb, 0x10, 0x80 }}

class nsIAppShellService : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IAPPSHELLSERVICE_IID)

  /**
   * Required initialization routine.
   * @param aCmdLineService is stored and passed to appshell components as
   *                        they are initialized.
   */
  /* void Initialize (in nsICmdLineService aCmdLineService, in nsISplashScreen splashScreen); */
  NS_IMETHOD Initialize(nsICmdLineService *aCmdLineService, nsISplashScreen *splashScreen) = 0;

  /**
   * Runs an application event loop: normally the main event pump which
   * defines the lifetime of the application.
   */
  /* void Run (); */
  NS_IMETHOD Run(void) = 0;

  /* void Quit (); */
  NS_IMETHOD Quit(void) = 0;

  /**
   * Required exit routine.  Cleanly shuts down
   * the appshell components.
   */
  /* void Shutdown (); */
  NS_IMETHOD Shutdown(void) = 0;

  /**
   * Create a window.
   * @param aParent the parent window.  Can be null.
   * @param aUrl the contents of the new window.
   * @param aShowWindow the window remains invisible if PR_FALSE.
   * @param aLoadDefaultPage controls whether the window should try to
   *                         load a default content page on its own.
   * @param aChromeMask chrome flags affecting the kind of OS border
   *                    given to the window. see nsIBrowserWindow for
   *                    bit/flag definitions.
   * @param aCallbacks interface providing C++ hooks for window initialization
   *                   before the window is made visible.  Can be null.
   *                   Deprecated.
   * @param aInitialWidth width, in pixels, of the window.  Width of window
   *                      at creation.  Can be overridden by the "width"
   *                      tag in the XUL.  Set to NS_SIZETOCONTENT to force
   *                      the window to wrap to its contents.
   * @param aInitialHeight like aInitialWidth, but subtly different.
   * @param aResult the newly created window is returned here.
   */
  /* void CreateTopLevelWindow (in nsIWebShellWindow aParent, in nsIURI aUrl, in boolean aShowWindow, in boolean aLoadDefaultPage, in PRUint32 aChromeMask, in nsIXULWindowCallbacks aCallbacks, in long aInitialWidth, in long aInitialHeight, out nsIWebShellWindow aResult); */
  NS_IMETHOD CreateTopLevelWindow(nsIWebShellWindow *aParent, nsIURI *aUrl, PRBool aShowWindow, PRBool aLoadDefaultPage, PRUint32 aChromeMask, nsIXULWindowCallbacks *aCallbacks, PRInt32 aInitialWidth, PRInt32 aInitialHeight, nsIWebShellWindow **aResult) = 0;

  /**
   * Run a window modally.
   * @param aWindow the window to run modally.  If null or pointing to null,
   *                a new window is created.  If aWindow != null, the window
   *                is returned from this method, but callers should use it
   *                carefully: it's been closed, and is therefore partially
   *                deconstructed.  Note that all other parameters are ignored
   *                if an already created window is passed in.
   * @param aParent the parent window.  Can be null.
   * @param aUrl the contents of the window.
   * @param aChromeMask chrome flags affecting the kind of OS border
   *                    given to the window. see nsIBrowserWindow for
   *                    bit/flag definitions.
   * @param aCallbacks interface providing C++ hooks for window initialization
   *                   before the window is made visible.  Deprecated.
   * @param aInitialWidth width, in pixels, of the window.  Width of window
   *                      at creation.  Can be overridden by the "width"
   *                      tag in the XUL.  Set to NS_SIZETOCONTENT to force
   *                      the window to wrap to its contents.
   * @param aInitialHeight like aInitialWidth.
   */
  /* void RunModalDialog (inout nsIWebShellWindow aWindow, in nsIWebShellWindow aParent, in nsIURI aUrl, in PRUint32 aChromeMask, in nsIXULWindowCallbacks aCallbacks, in long aInitialWidth, in long aInitialHeight); */
  NS_IMETHOD RunModalDialog(nsIWebShellWindow **aWindow, nsIWebShellWindow *aParent, nsIURI *aUrl, PRUint32 aChromeMask, nsIXULWindowCallbacks *aCallbacks, PRInt32 aInitialWidth, PRInt32 aInitialHeight) = 0;

  /* void EnumerateAndInitializeComponents (); */
  NS_IMETHOD EnumerateAndInitializeComponents(void) = 0;

  /**
   * Close a window.
   * @param aWindow a window.
   */
  /* void CloseTopLevelWindow (in nsIWebShellWindow aWindow); */
  NS_IMETHOD CloseTopLevelWindow(nsIWebShellWindow *aWindow) = 0;

  /* [noscript] void CreateHiddenWindow (); */
  NS_IMETHOD CreateHiddenWindow(void) = 0;

  /**
   * Return the (singleton) application hidden window, automatically created
   * and maintained by this AppShellService.
   * @param aResult the hidden window.  Do not unhide hidden window.
   *                Do not taunt hidden window.
   */
  /* void GetHiddenWindow (out nsIWebShellWindow aResult); */
  NS_IMETHOD GetHiddenWindow(nsIWebShellWindow **aResult) = 0;

  /**
   * Return the (singleton) application hidden window as an nsIDOMWindow,
   * and, the corresponding JavaScript context pointer.  This is useful
   * if you'd like to subsequently call OpenDialog on the hidden window.
   * @aHiddenDOMWindow the hidden window QI'd to type nsIDOMWindow
   * @aJSContext       the corresponding JavaScript context
   */
  /* [noscript] void GetHiddenWindowAndJSContext (out nsIDOMWindow aHiddenDOMWindow, out JSContext aJSContext); */
  NS_IMETHOD GetHiddenWindowAndJSContext(nsIDOMWindow **aHiddenDOMWindow, JSContext * *aJSContext) = 0;

  /**
   * Add a window to the application's registry of windows.  These windows
   * are generally shown in the Windows taskbar, and the application
   * knows it can't quit until it's out of registered windows.
   * @param aWindow yes
   */
  /* void RegisterTopLevelWindow (in nsIWebShellWindow aWindow); */
  NS_IMETHOD RegisterTopLevelWindow(nsIWebShellWindow *aWindow) = 0;

  /**
   * Remove a window from the application's window registry.
   * @param aWindow you see the pattern
   */
  /* void UnregisterTopLevelWindow (in nsIWebShellWindow aWindow); */
  NS_IMETHOD UnregisterTopLevelWindow(nsIWebShellWindow *aWindow) = 0;

  /**
   * Remove the splash screen (if visible).  This need be called
   * only once per application session.
   */
  /* void HideSplashScreen (); */
  NS_IMETHOD HideSplashScreen(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIAPPSHELLSERVICE \
  NS_IMETHOD Initialize(nsICmdLineService *aCmdLineService, nsISplashScreen *splashScreen); \
  NS_IMETHOD Run(void); \
  NS_IMETHOD Quit(void); \
  NS_IMETHOD Shutdown(void); \
  NS_IMETHOD CreateTopLevelWindow(nsIWebShellWindow *aParent, nsIURI *aUrl, PRBool aShowWindow, PRBool aLoadDefaultPage, PRUint32 aChromeMask, nsIXULWindowCallbacks *aCallbacks, PRInt32 aInitialWidth, PRInt32 aInitialHeight, nsIWebShellWindow **aResult); \
  NS_IMETHOD RunModalDialog(nsIWebShellWindow **aWindow, nsIWebShellWindow *aParent, nsIURI *aUrl, PRUint32 aChromeMask, nsIXULWindowCallbacks *aCallbacks, PRInt32 aInitialWidth, PRInt32 aInitialHeight); \
  NS_IMETHOD EnumerateAndInitializeComponents(void); \
  NS_IMETHOD CloseTopLevelWindow(nsIWebShellWindow *aWindow); \
  NS_IMETHOD CreateHiddenWindow(void); \
  NS_IMETHOD GetHiddenWindow(nsIWebShellWindow **aResult); \
  NS_IMETHOD GetHiddenWindowAndJSContext(nsIDOMWindow **aHiddenDOMWindow, JSContext * *aJSContext); \
  NS_IMETHOD RegisterTopLevelWindow(nsIWebShellWindow *aWindow); \
  NS_IMETHOD UnregisterTopLevelWindow(nsIWebShellWindow *aWindow); \
  NS_IMETHOD HideSplashScreen(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIAPPSHELLSERVICE(_to) \
  NS_IMETHOD Initialize(nsICmdLineService *aCmdLineService, nsISplashScreen *splashScreen) { return _to ## Initialize(aCmdLineService, splashScreen); } \
  NS_IMETHOD Run(void) { return _to ## Run(); } \
  NS_IMETHOD Quit(void) { return _to ## Quit(); } \
  NS_IMETHOD Shutdown(void) { return _to ## Shutdown(); } \
  NS_IMETHOD CreateTopLevelWindow(nsIWebShellWindow *aParent, nsIURI *aUrl, PRBool aShowWindow, PRBool aLoadDefaultPage, PRUint32 aChromeMask, nsIXULWindowCallbacks *aCallbacks, PRInt32 aInitialWidth, PRInt32 aInitialHeight, nsIWebShellWindow **aResult) { return _to ## CreateTopLevelWindow(aParent, aUrl, aShowWindow, aLoadDefaultPage, aChromeMask, aCallbacks, aInitialWidth, aInitialHeight, aResult); } \
  NS_IMETHOD RunModalDialog(nsIWebShellWindow **aWindow, nsIWebShellWindow *aParent, nsIURI *aUrl, PRUint32 aChromeMask, nsIXULWindowCallbacks *aCallbacks, PRInt32 aInitialWidth, PRInt32 aInitialHeight) { return _to ## RunModalDialog(aWindow, aParent, aUrl, aChromeMask, aCallbacks, aInitialWidth, aInitialHeight); } \
  NS_IMETHOD EnumerateAndInitializeComponents(void) { return _to ## EnumerateAndInitializeComponents(); } \
  NS_IMETHOD CloseTopLevelWindow(nsIWebShellWindow *aWindow) { return _to ## CloseTopLevelWindow(aWindow); } \
  NS_IMETHOD CreateHiddenWindow(void) { return _to ## CreateHiddenWindow(); } \
  NS_IMETHOD GetHiddenWindow(nsIWebShellWindow **aResult) { return _to ## GetHiddenWindow(aResult); } \
  NS_IMETHOD GetHiddenWindowAndJSContext(nsIDOMWindow **aHiddenDOMWindow, JSContext * *aJSContext) { return _to ## GetHiddenWindowAndJSContext(aHiddenDOMWindow, aJSContext); } \
  NS_IMETHOD RegisterTopLevelWindow(nsIWebShellWindow *aWindow) { return _to ## RegisterTopLevelWindow(aWindow); } \
  NS_IMETHOD UnregisterTopLevelWindow(nsIWebShellWindow *aWindow) { return _to ## UnregisterTopLevelWindow(aWindow); } \
  NS_IMETHOD HideSplashScreen(void) { return _to ## HideSplashScreen(); } 


#endif /* __gen_nsIAppShellService_h__ */
