/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIEditorShell.idl
 */

#ifndef __gen_nsIEditorShell_h__
#define __gen_nsIEditorShell_h__

#include "nsISupports.h"
#include "domstubs.h"
#include "nsIFileSpec.h"
#include "nsISupportsArray.h"
#include "nsIDocumentStateListener.h"
#include "nsISelectionController.h"

class nsIDOMWindow;
class nsIDOMDocument;
class nsIDOMSelection;
class nsIDOMElement;
class nsIDOMNode;
class nsIFileSpec; /* forward declaration */

class nsIEditor; /* forward declaration */


/* starting interface:    nsIEditorShell */
#define NS_IEDITORSHELL_IID_STR "9afff72b-ca9a-11d2-96c9-0060b0fb9956"

#define NS_IEDITORSHELL_IID \
  {0x9afff72b, 0xca9a, 0x11d2, \
    { 0x96, 0xc9, 0x00, 0x60, 0xb0, 0xfb, 0x99, 0x56 }}

class nsIEditorShell : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IEDITORSHELL_IID)

  /* readonly attribute nsIDOMDocument editorDocument; */
  NS_IMETHOD GetEditorDocument(nsIDOMDocument * *aEditorDocument) = 0;

  /* readonly attribute nsIDOMSelection editorSelection; */
  NS_IMETHOD GetEditorSelection(nsIDOMSelection * *aEditorSelection) = 0;

  /* readonly attribute nsISelectionController selectionController; */
  NS_IMETHOD GetSelectionController(nsISelectionController * *aSelectionController) = 0;

  /* [noscript] readonly attribute nsIEditor editor; */
  NS_IMETHOD GetEditor(nsIEditor * *aEditor) = 0;

  enum {
    eDocumentStatusUnmodified,
    eDocumentStatusModified
  };
  enum {
    eDisplayModeEdit,
    eDisplayModeBrowserPreview
  };
  enum {
    eTable,
    eTableRow,
    eTableColumn,
    eTableCell,
    eTableCaption
  };
  /* readonly attribute boolean documentModified; */
  NS_IMETHOD GetDocumentModified(PRBool *aDocumentModified) = 0;

  /* readonly attribute boolean documentIsEmpty; */
  NS_IMETHOD GetDocumentIsEmpty(PRBool *aDocumentIsEmpty) = 0;

  /* readonly attribute long documentLength; */
  NS_IMETHOD GetDocumentLength(PRInt32 *aDocumentLength) = 0;

  /* attribute long wrapColumn; */
  NS_IMETHOD GetWrapColumn(PRInt32 *aWrapColumn) = 0;
  NS_IMETHOD SetWrapColumn(PRInt32 aWrapColumn) = 0;

  /* void SetEditorType (in wstring editorType); */
  NS_IMETHOD SetEditorType(const PRUnichar *editorType) = 0;

  /* void SetToolbarWindow (in nsIDOMWindow win); */
  NS_IMETHOD SetToolbarWindow(nsIDOMWindow *win) = 0;

  /* void SetContentWindow (in nsIDOMWindow win); */
  NS_IMETHOD SetContentWindow(nsIDOMWindow *win) = 0;

  /* void SetWebShellWindow (in nsIDOMWindow win); */
  NS_IMETHOD SetWebShellWindow(nsIDOMWindow *win) = 0;

  /* void LoadUrl (in wstring url); */
  NS_IMETHOD LoadUrl(const PRUnichar *url) = 0;

  /* void SetDocumentTitle (in wstring title); */
  NS_IMETHOD SetDocumentTitle(const PRUnichar *title) = 0;

  /* wstring GetDocumentTitle (); */
  NS_IMETHOD GetDocumentTitle(PRUnichar **_retval) = 0;

  /** Register a doc state listener. This gets added to a list of listeners
     which are registered with the editor when that gets instantiated.
     If the LoadUrl fails, this listener will not receive any notifcations.
     If you call this after the editor has been instantiated, it calls through
     to editor::AddDocumentStateListener().
  */
  /* void RegisterDocumentStateListener (in nsIDocumentStateListener docListener); */
  NS_IMETHOD RegisterDocumentStateListener(nsIDocumentStateListener *docListener) = 0;

  /** Unregister a listener.
     If you call this after the editor has been instantiated, it calls through
     to editor::RemoveDocumentStateListener().
  */
  /* void UnregisterDocumentStateListener (in nsIDocumentStateListener docListener); */
  NS_IMETHOD UnregisterDocumentStateListener(nsIDocumentStateListener *docListener) = 0;

  /* void Init (); */
  NS_IMETHOD Init(void) = 0;

  /* boolean checkOpenWindowForURLMatch (in wstring inFileURL, in nsIDOMWindow inCheckWindow); */
  NS_IMETHOD CheckOpenWindowForURLMatch(const PRUnichar *inFileURL, nsIDOMWindow *inCheckWindow, PRBool *_retval) = 0;

  /** 
   *  @param saveAs false to try to save to existing file
   *          If document is not already saved, it is treated as true
   *          so filename is prompted.
   *  @param saveCopy       
   *          true if we are saving off a copy of the document
   *          without changing the disk file associated with the doc.
   *          This would correspond to a 'Save Copy As' menu command
   *          (currently not in our UI)
   *  return value
   *          true if file was really saved.
   *          false if there is some problem with saving or user
   *          executed "Cancel" when prompted for a filename to save
   */
  /* boolean saveDocument (in boolean saveAs, in boolean saveCopy); */
  NS_IMETHOD SaveDocument(PRBool saveAs, PRBool saveCopy, PRBool *_retval) = 0;

  /** Check if current document has changes and prompt to save if it does.
   *  return value:
   *         false ONLY if user executed "Cancel" in the SaveAs dialog
   *         true if no changes in doc, or file was saved successfully
   *  @param reasonToSave 
   *         A string to append after "Save changes to <URL>"
   *         If null, just the question mark will be appended
   */
  /* boolean CheckAndSaveDocument (in wstring reasonToSave); */
  NS_IMETHOD CheckAndSaveDocument(const PRUnichar *reasonToSave, PRBool *_retval) = 0;

  /* boolean CloseWindow (); */
  NS_IMETHOD CloseWindow(PRBool *_retval) = 0;

  /* void Print (); */
  NS_IMETHOD Print(void) = 0;

  /* void Undo (); */
  NS_IMETHOD Undo(void) = 0;

  /* void Redo (); */
  NS_IMETHOD Redo(void) = 0;

  /* void Cut (); */
  NS_IMETHOD Cut(void) = 0;

  /* void Copy (); */
  NS_IMETHOD Copy(void) = 0;

  /* void Paste (); */
  NS_IMETHOD Paste(void) = 0;

  /* void PasteAsQuotation (); */
  NS_IMETHOD PasteAsQuotation(void) = 0;

  /* void PasteAsCitedQuotation (in wstring cite); */
  NS_IMETHOD PasteAsCitedQuotation(const PRUnichar *cite) = 0;

  /* void InsertAsQuotation (in wstring quotedText, out nsIDOMNode nodeInserted); */
  NS_IMETHOD InsertAsQuotation(const PRUnichar *quotedText, nsIDOMNode **nodeInserted) = 0;

  /* void InsertAsCitedQuotation (in wstring quotedText, in wstring cite, in wstring charset, out nsIDOMNode nodeInserted); */
  NS_IMETHOD InsertAsCitedQuotation(const PRUnichar *quotedText, const PRUnichar *cite, const PRUnichar *charset, nsIDOMNode **nodeInserted) = 0;

  /* void SelectAll (); */
  NS_IMETHOD SelectAll(void) = 0;

  /* void DeleteSelection (in PRInt32 action); */
  NS_IMETHOD DeleteSelection(PRInt32 action) = 0;

  /* void Find (); */
  NS_IMETHOD Find(void) = 0;

  /* void FindNext (); */
  NS_IMETHOD FindNext(void) = 0;

  /* void UpdateInterfaceState (); */
  NS_IMETHOD UpdateInterfaceState(void) = 0;

  /* wstring GetString (in wstring name); */
  NS_IMETHOD GetString(const PRUnichar *name, PRUnichar **_retval) = 0;

  /* wstring GetDocumentCharacterSet (); */
  NS_IMETHOD GetDocumentCharacterSet(PRUnichar **_retval) = 0;

  /* void SetDocumentCharacterSet (in wstring characterSet); */
  NS_IMETHOD SetDocumentCharacterSet(const PRUnichar *characterSet) = 0;

  /* void TypedText (in wstring textToInsert, in PRInt32 actionToTake); */
  NS_IMETHOD TypedText(const PRUnichar *textToInsert, PRInt32 actionToTake) = 0;

  /* void InsertText (in wstring textToInsert); */
  NS_IMETHOD InsertText(const PRUnichar *textToInsert) = 0;

  /* void InsertSource (in wstring textToInsert); */
  NS_IMETHOD InsertSource(const PRUnichar *textToInsert) = 0;

  /* void InsertSourceWithCharset (in wstring textToInsert, in wstring charset); */
  NS_IMETHOD InsertSourceWithCharset(const PRUnichar *textToInsert, const PRUnichar *charset) = 0;

  /* void InsertBreak (); */
  NS_IMETHOD InsertBreak(void) = 0;

  /* void MakeOrChangeList (in wstring listType); */
  NS_IMETHOD MakeOrChangeList(const PRUnichar *listType) = 0;

  /* void RemoveList (in wstring listType); */
  NS_IMETHOD RemoveList(const PRUnichar *listType) = 0;

  /* void Indent (in wstring indent); */
  NS_IMETHOD Indent(const PRUnichar *indent) = 0;

  /* void Align (in wstring align); */
  NS_IMETHOD Align(const PRUnichar *align) = 0;

  /** Element insert and property editing */
/** Return an element only if it is the only node selected,
    *    such as an image, horizontal rule, etc.
    * The exception is a link, which is more like a text attribute:
    *    The Anchor tag is returned if the selection is within the textnode(s)
    *    that are children of the "A" node.
    *    This could be a collapsed selection, i.e., a caret within the link text.
    *
    * tagName:  The HTML tagname or and empty string 
    *       to get any element (but only if it is the only element selected)
    *    Special input values for Links and Named anchors:
    *    Use "href" to get a link node
    *      (an "A" tag with the "href" attribute set)
    *    Use "anchor" or "namedanchor" to get a named anchor node
    *      (an "A" tag with the "name" attribute set)
    */
  /* nsIDOMElement GetSelectedElement (in wstring tagName); */
  NS_IMETHOD GetSelectedElement(const PRUnichar *tagName, nsIDOMElement **_retval) = 0;

  /** Return the input node or a parent matching the given aTagName,
    *   starting the search at the supplied node.
    * An example of use is for testing if a node is in a table cell
    *   given a selection anchor node.
    *
    * tagName:  The HTML tagname
    *    Special input values:
    *    Use "href" to get a link node 
    *      (an "A" tag with the "href" attribute set)
    *    Use "anchor" or "namedanchor" to get a named anchor node
    *      (an "A" tag with the "name" attribute set)
    *    Use "list" to get an OL, UL, or DL list node
    *    Use "td" to get either a TD or TH cell node
    *
    * node:    The node in the document to start the search
    *     If it is null, the anchor node of the current selection is used
    */
  /* nsIDOMElement GetElementOrParentByTagName (in wstring tagName, in nsIDOMNode node); */
  NS_IMETHOD GetElementOrParentByTagName(const PRUnichar *tagName, nsIDOMNode *node, nsIDOMElement **_retval) = 0;

  /** Return a new element with default attribute values
    * 
    * This does not rely on the selection, and is not sensitive to context.
    * 
    * Used primarily to supply new element for various insert element dialogs
    *  (Image, Link, NamedAnchor, Table, and HorizontalRule 
    *   are the only returned elements as of 7/25/99)
    *
    * tagName:  The HTML tagname
    *    Special input values for Links and Named anchors:
    *    Use "href" to get a link node
    *      (an "A" tag with the "href" attribute set)
    *    Use "anchor" or "namedanchor" to get a named anchor node
    *      (an "A" tag with the "name" attribute set)
    */
  /* nsIDOMElement CreateElementWithDefaults (in wstring tagName); */
  NS_IMETHOD CreateElementWithDefaults(const PRUnichar *tagName, nsIDOMElement **_retval) = 0;

  /** Insert an element, which may have child nodes, at the selection
    * Used primarily to insert a new element for various insert element dialogs,
    *   but it enforces the HTML 4.0 DTD "CanContain" rules, so it should
    *   be useful for other elements.
    *
    * element:           The element to insert
    * deleteSelection:   Delete the selection before inserting
    *     If deleteSelection is PR_FALSE, then the element is inserted 
    *     after the end of the selection for all element except
    *     Named Anchors, which insert before the selection
    */
  /* void InsertElementAtSelection (in nsIDOMElement element, in boolean deleteSelection); */
  NS_IMETHOD InsertElementAtSelection(nsIDOMElement *element, PRBool deleteSelection) = 0;

  /** Insert an link element as the parent of the current selection
    *
    * element   An "A" element with a non-empty "href" attribute
    */
  /* void InsertLinkAroundSelection (in nsIDOMElement anchorElement); */
  NS_IMETHOD InsertLinkAroundSelection(nsIDOMElement *anchorElement) = 0;

  /** 
   * Insert an element under parent at position.
   * No checking is done to verify the legality of the insertion.
   *  That is the responsibility of the caller.
   * element:   The DOM element to insert.
   * parent:    The element to insert the new object under
   * position:  The place in parent to insert the new element
   *                  0=first child, 1=second child, etc.
   *                  any number > number of current children = last child
   */
  /* void InsertElement (in nsIDOMElement element, in nsIDOMElement parent, in PRInt32 position); */
  NS_IMETHOD InsertElement(nsIDOMElement *element, nsIDOMElement *parent, PRInt32 position) = 0;

  /** 
    * DeleteNode removes element from the document
    */
  /* void DeleteElement (in nsIDOMElement element); */
  NS_IMETHOD DeleteElement(nsIDOMElement *element) = 0;

  /** 
    * Deletion methods which need to be accessible to JS:
    */
  /* void DeleteCharForward (); */
  NS_IMETHOD DeleteCharForward(void) = 0;

  /* void DeleteCharBackward (); */
  NS_IMETHOD DeleteCharBackward(void) = 0;

  /* void DeleteWordForward (); */
  NS_IMETHOD DeleteWordForward(void) = 0;

  /* void DeleteWordBackward (); */
  NS_IMETHOD DeleteWordBackward(void) = 0;

  /* void DeleteToBeginningOfLine (); */
  NS_IMETHOD DeleteToBeginningOfLine(void) = 0;

  /* void DeleteToEndOfLine (); */
  NS_IMETHOD DeleteToEndOfLine(void) = 0;

  /* void SelectElement (in nsIDOMElement element); */
  NS_IMETHOD SelectElement(nsIDOMElement *element) = 0;

  /* void SetSelectionAfterElement (in nsIDOMElement element); */
  NS_IMETHOD SetSelectionAfterElement(nsIDOMElement *element) = 0;

  /** Table insert and delete methods.  Done relative to selected cell or
   * cell containing the selection anchor.
   */
  /* void InsertTableCell (in PRInt32 number, in boolean after); */
  NS_IMETHOD InsertTableCell(PRInt32 number, PRBool after) = 0;

  /* void InsertTableRow (in PRInt32 number, in boolean after); */
  NS_IMETHOD InsertTableRow(PRInt32 number, PRBool after) = 0;

  /* void InsertTableColumn (in PRInt32 number, in boolean after); */
  NS_IMETHOD InsertTableColumn(PRInt32 number, PRBool after) = 0;

  /* void DeleteTable (); */
  NS_IMETHOD DeleteTable(void) = 0;

  /* void DeleteTableCell (in PRInt32 number); */
  NS_IMETHOD DeleteTableCell(PRInt32 number) = 0;

  /* void DeleteTableCellContents (); */
  NS_IMETHOD DeleteTableCellContents(void) = 0;

  /* void DeleteTableRow (in PRInt32 number); */
  NS_IMETHOD DeleteTableRow(PRInt32 number) = 0;

  /* void DeleteTableColumn (in PRInt32 number); */
  NS_IMETHOD DeleteTableColumn(PRInt32 number) = 0;

  /* void JoinTableCells (); */
  NS_IMETHOD JoinTableCells(void) = 0;

  /** Table selection methods
    * Selecting a row or column actually
    * selects all cells (not TR in the case of rows)
    */
  /* void SelectTableCell (); */
  NS_IMETHOD SelectTableCell(void) = 0;

  /* void SelectTableRow (); */
  NS_IMETHOD SelectTableRow(void) = 0;

  /* void SelectTableColumn (); */
  NS_IMETHOD SelectTableColumn(void) = 0;

  /* void SelectTable (); */
  NS_IMETHOD SelectTable(void) = 0;

  /* void SelectAllTableCells (); */
  NS_IMETHOD SelectAllTableCells(void) = 0;

  /** Scan through all rows and add cells as needed so 
    *   all locations in the cellmap are occupied.
    *   Used after inserting single cells or pasting
    *   a collection of cells that extend past the
    *   previous size of the table
    * If aTable is null, it uses table enclosing the selection anchor
    */
  /* void NormalizeTable (in nsIDOMElement tableElement); */
  NS_IMETHOD NormalizeTable(nsIDOMElement *tableElement) = 0;

  /** Get the indexes from layout's cellmap */
  /* PRInt32 GetRowIndex (in nsIDOMElement cellElement); */
  NS_IMETHOD GetRowIndex(nsIDOMElement *cellElement, PRInt32 *_retval) = 0;

  /* PRInt32 GetColumnIndex (in nsIDOMElement cellElement); */
  NS_IMETHOD GetColumnIndex(nsIDOMElement *cellElement, PRInt32 *_retval) = 0;

  /** Get the number of rows in a table from the layout's cellmap 
    * If tableElement is null, it will try to find enclosing table of selection anchor
    */
  /* PRInt32 GetTableRowCount (in nsIDOMElement tableElement); */
  NS_IMETHOD GetTableRowCount(nsIDOMElement *tableElement, PRInt32 *_retval) = 0;

  /* PRInt32 GetTableColumnCount (in nsIDOMElement tableElement); */
  NS_IMETHOD GetTableColumnCount(nsIDOMElement *tableElement, PRInt32 *_retval) = 0;

  /* nsIDOMElement GetCellAt (in nsIDOMElement tableElement, in PRInt32 rowIndex, in PRInt32 colIndex); */
  NS_IMETHOD GetCellAt(nsIDOMElement *tableElement, PRInt32 rowIndex, PRInt32 colIndex, nsIDOMElement **_retval) = 0;

  /* nsIDOMElement GetCellDataAt (in nsIDOMElement tableElement, in PRInt32 rowIndex, in PRInt32 colIndex, out PRInt32 startRowIndex, out PRInt32 startColIndex, out PRInt32 rowSpan, out PRInt32 colSpan, out PRInt32 actualRowSpan, out PRInt32 actualColSpan, out boolean isSelected); */
  NS_IMETHOD GetCellDataAt(nsIDOMElement *tableElement, PRInt32 rowIndex, PRInt32 colIndex, PRInt32 *startRowIndex, PRInt32 *startColIndex, PRInt32 *rowSpan, PRInt32 *colSpan, PRInt32 *actualRowSpan, PRInt32 *actualColSpan, PRBool *isSelected, nsIDOMElement **_retval) = 0;

  /* nsIDOMElement GetFirstRow (in nsIDOMElement tableElement); */
  NS_IMETHOD GetFirstRow(nsIDOMElement *tableElement, nsIDOMElement **_retval) = 0;

  /* nsIDOMElement GetNextRow (in nsIDOMElement currentRow); */
  NS_IMETHOD GetNextRow(nsIDOMElement *currentRow, nsIDOMElement **_retval) = 0;

  /** Examine the current selection and find
    *   a selected TABLE, TD or TH, or TR element.
    *   or return the parent TD or TH if selection anchor is inside a table cell
    *   Returns null if no table element is found.
    *
    * Returns:
    *   The table element (table, row, or cell) found
    *   tagName           The tagname of returned element
    *                       Note that "td" will be returned if name is actually "th"
    *   isSelected        Tells if element returned is a selected element 
    *                       (false if element is a parent cell of selection)
    */
  /* nsIDOMElement GetSelectedOrParentTableElement (out wstring tagName, out boolean isSelected); */
  NS_IMETHOD GetSelectedOrParentTableElement(PRUnichar **tagName, PRBool *isSelected, nsIDOMElement **_retval) = 0;

  /**** end of table editing *****/
  /* nsISupportsArray GetEmbeddedObjects (); */
  NS_IMETHOD GetEmbeddedObjects(nsISupportsArray **_retval) = 0;

  /* void SetAttribute (in nsIDOMElement element, in wstring attr, in wstring value); */
  NS_IMETHOD SetAttribute(nsIDOMElement *element, const PRUnichar *attr, const PRUnichar *value) = 0;

  /* void RemoveAttribute (in nsIDOMElement element, in wstring attr); */
  NS_IMETHOD RemoveAttribute(nsIDOMElement *element, const PRUnichar *attr) = 0;

  /* void SetTextProperty (in wstring prop, in wstring attr, in wstring value); */
  NS_IMETHOD SetTextProperty(const PRUnichar *prop, const PRUnichar *attr, const PRUnichar *value) = 0;

  /* void RemoveTextProperty (in wstring prop, in wstring attr); */
  NS_IMETHOD RemoveTextProperty(const PRUnichar *prop, const PRUnichar *attr) = 0;

  /* void GetTextProperty (in wstring prop, in wstring attr, in wstring value, out boolean firstHas, out boolean anyHas, out boolean allHas); */
  NS_IMETHOD GetTextProperty(const PRUnichar *prop, const PRUnichar *attr, const PRUnichar *value, PRBool *firstHas, PRBool *anyHas, PRBool *allHas) = 0;

  /* void IncreaseFontSize (); */
  NS_IMETHOD IncreaseFontSize(void) = 0;

  /* void DecreaseFontSize (); */
  NS_IMETHOD DecreaseFontSize(void) = 0;

  /* void SetParagraphFormat (in wstring paragraphFormat); */
  NS_IMETHOD SetParagraphFormat(const PRUnichar *paragraphFormat) = 0;

  /* void SetBodyAttribute (in wstring attr, in wstring value); */
  NS_IMETHOD SetBodyAttribute(const PRUnichar *attr, const PRUnichar *value) = 0;

  /* void SetBackgroundColor (in wstring color); */
  NS_IMETHOD SetBackgroundColor(const PRUnichar *color) = 0;

  /* void ApplyStyleSheet (in wstring url); */
  NS_IMETHOD ApplyStyleSheet(const PRUnichar *url) = 0;

  /** Set the display mode for editing
    * @param displayMode
    *       0 (eDisplayModeEdit) Use extra CSS style 
    *           (from override styles in EditorContent.css) 
    *           to show named anchors, table borders, etc for editing
    *       1 (eDisplayModeBrowserPreview) "WYSIWIG" or Preview mode
    *           that looks exactly like the browser display except
    *           for certain behaviors like cursor style over links, etc.
    */
  /* void SetDisplayMode (in PRInt32 displayMode); */
  NS_IMETHOD SetDisplayMode(PRInt32 displayMode) = 0;

  /* wstring GetContentsAs (in wstring format, in PRUint32 flags); */
  NS_IMETHOD GetContentsAs(const PRUnichar *format, PRUint32 flags, PRUnichar **_retval) = 0;

  /* void DumpContentTree (); */
  NS_IMETHOD DumpContentTree(void) = 0;

  /* wstring GetLocalFileURL (in nsIDOMWindow parent, in wstring filterType); */
  NS_IMETHOD GetLocalFileURL(nsIDOMWindow *parent, const PRUnichar *filterType, PRUnichar **_retval) = 0;

  /**
   * Tests if a node is a BLOCK element according the the HTML 4.0 DTD
   *   This does NOT consider CSS effect on display type
   */
  /* boolean NodeIsBlock (in nsIDOMNode node); */
  NS_IMETHOD NodeIsBlock(nsIDOMNode *node, PRBool *_retval) = 0;

  /**
   * This is similar to nsIDOMNode::cloneNode(),
   *   it assures the attribute nodes of the destination are identical with the source node
   *   by copying all existing attributes from the source and deleting those not in the source.
   *   This is used when the destination node (element) already exists
   *
   * The supplied nodes MUST BE ELEMENTS (most callers are working with nodes)
   * destNode     the destination element to operate on
   * sourceNode   the source element to copy attributes from
   */
  /* void CloneAttributes (in nsIDOMNode destNode, in nsIDOMNode sourceNode); */
  NS_IMETHOD CloneAttributes(nsIDOMNode *destNode, nsIDOMNode *sourceNode) = 0;

  /* void BeginBatchChanges (); */
  NS_IMETHOD BeginBatchChanges(void) = 0;

  /* void EndBatchChanges (); */
  NS_IMETHOD EndBatchChanges(void) = 0;

  /* void RunUnitTests (); */
  NS_IMETHOD RunUnitTests(void) = 0;

  /* void StartLogging (in nsIFileSpec logFile); */
  NS_IMETHOD StartLogging(nsIFileSpec *logFile) = 0;

  /* void StopLogging (); */
  NS_IMETHOD StopLogging(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIEDITORSHELL \
  NS_IMETHOD GetEditorDocument(nsIDOMDocument * *aEditorDocument); \
  NS_IMETHOD GetEditorSelection(nsIDOMSelection * *aEditorSelection); \
  NS_IMETHOD GetSelectionController(nsISelectionController * *aSelectionController); \
  NS_IMETHOD GetEditor(nsIEditor * *aEditor); \
  NS_IMETHOD GetDocumentModified(PRBool *aDocumentModified); \
  NS_IMETHOD GetDocumentIsEmpty(PRBool *aDocumentIsEmpty); \
  NS_IMETHOD GetDocumentLength(PRInt32 *aDocumentLength); \
  NS_IMETHOD GetWrapColumn(PRInt32 *aWrapColumn); \
  NS_IMETHOD SetWrapColumn(PRInt32 aWrapColumn); \
  NS_IMETHOD SetEditorType(const PRUnichar *editorType); \
  NS_IMETHOD SetToolbarWindow(nsIDOMWindow *win); \
  NS_IMETHOD SetContentWindow(nsIDOMWindow *win); \
  NS_IMETHOD SetWebShellWindow(nsIDOMWindow *win); \
  NS_IMETHOD LoadUrl(const PRUnichar *url); \
  NS_IMETHOD SetDocumentTitle(const PRUnichar *title); \
  NS_IMETHOD GetDocumentTitle(PRUnichar **_retval); \
  NS_IMETHOD RegisterDocumentStateListener(nsIDocumentStateListener *docListener); \
  NS_IMETHOD UnregisterDocumentStateListener(nsIDocumentStateListener *docListener); \
  NS_IMETHOD Init(void); \
  NS_IMETHOD CheckOpenWindowForURLMatch(const PRUnichar *inFileURL, nsIDOMWindow *inCheckWindow, PRBool *_retval); \
  NS_IMETHOD SaveDocument(PRBool saveAs, PRBool saveCopy, PRBool *_retval); \
  NS_IMETHOD CheckAndSaveDocument(const PRUnichar *reasonToSave, PRBool *_retval); \
  NS_IMETHOD CloseWindow(PRBool *_retval); \
  NS_IMETHOD Print(void); \
  NS_IMETHOD Undo(void); \
  NS_IMETHOD Redo(void); \
  NS_IMETHOD Cut(void); \
  NS_IMETHOD Copy(void); \
  NS_IMETHOD Paste(void); \
  NS_IMETHOD PasteAsQuotation(void); \
  NS_IMETHOD PasteAsCitedQuotation(const PRUnichar *cite); \
  NS_IMETHOD InsertAsQuotation(const PRUnichar *quotedText, nsIDOMNode **nodeInserted); \
  NS_IMETHOD InsertAsCitedQuotation(const PRUnichar *quotedText, const PRUnichar *cite, const PRUnichar *charset, nsIDOMNode **nodeInserted); \
  NS_IMETHOD SelectAll(void); \
  NS_IMETHOD DeleteSelection(PRInt32 action); \
  NS_IMETHOD Find(void); \
  NS_IMETHOD FindNext(void); \
  NS_IMETHOD UpdateInterfaceState(void); \
  NS_IMETHOD GetString(const PRUnichar *name, PRUnichar **_retval); \
  NS_IMETHOD GetDocumentCharacterSet(PRUnichar **_retval); \
  NS_IMETHOD SetDocumentCharacterSet(const PRUnichar *characterSet); \
  NS_IMETHOD TypedText(const PRUnichar *textToInsert, PRInt32 actionToTake); \
  NS_IMETHOD InsertText(const PRUnichar *textToInsert); \
  NS_IMETHOD InsertSource(const PRUnichar *textToInsert); \
  NS_IMETHOD InsertSourceWithCharset(const PRUnichar *textToInsert, const PRUnichar *charset); \
  NS_IMETHOD InsertBreak(void); \
  NS_IMETHOD MakeOrChangeList(const PRUnichar *listType); \
  NS_IMETHOD RemoveList(const PRUnichar *listType); \
  NS_IMETHOD Indent(const PRUnichar *indent); \
  NS_IMETHOD Align(const PRUnichar *align); \
  NS_IMETHOD GetSelectedElement(const PRUnichar *tagName, nsIDOMElement **_retval); \
  NS_IMETHOD GetElementOrParentByTagName(const PRUnichar *tagName, nsIDOMNode *node, nsIDOMElement **_retval); \
  NS_IMETHOD CreateElementWithDefaults(const PRUnichar *tagName, nsIDOMElement **_retval); \
  NS_IMETHOD InsertElementAtSelection(nsIDOMElement *element, PRBool deleteSelection); \
  NS_IMETHOD InsertLinkAroundSelection(nsIDOMElement *anchorElement); \
  NS_IMETHOD InsertElement(nsIDOMElement *element, nsIDOMElement *parent, PRInt32 position); \
  NS_IMETHOD DeleteElement(nsIDOMElement *element); \
  NS_IMETHOD DeleteCharForward(void); \
  NS_IMETHOD DeleteCharBackward(void); \
  NS_IMETHOD DeleteWordForward(void); \
  NS_IMETHOD DeleteWordBackward(void); \
  NS_IMETHOD DeleteToBeginningOfLine(void); \
  NS_IMETHOD DeleteToEndOfLine(void); \
  NS_IMETHOD SelectElement(nsIDOMElement *element); \
  NS_IMETHOD SetSelectionAfterElement(nsIDOMElement *element); \
  NS_IMETHOD InsertTableCell(PRInt32 number, PRBool after); \
  NS_IMETHOD InsertTableRow(PRInt32 number, PRBool after); \
  NS_IMETHOD InsertTableColumn(PRInt32 number, PRBool after); \
  NS_IMETHOD DeleteTable(void); \
  NS_IMETHOD DeleteTableCell(PRInt32 number); \
  NS_IMETHOD DeleteTableCellContents(void); \
  NS_IMETHOD DeleteTableRow(PRInt32 number); \
  NS_IMETHOD DeleteTableColumn(PRInt32 number); \
  NS_IMETHOD JoinTableCells(void); \
  NS_IMETHOD SelectTableCell(void); \
  NS_IMETHOD SelectTableRow(void); \
  NS_IMETHOD SelectTableColumn(void); \
  NS_IMETHOD SelectTable(void); \
  NS_IMETHOD SelectAllTableCells(void); \
  NS_IMETHOD NormalizeTable(nsIDOMElement *tableElement); \
  NS_IMETHOD GetRowIndex(nsIDOMElement *cellElement, PRInt32 *_retval); \
  NS_IMETHOD GetColumnIndex(nsIDOMElement *cellElement, PRInt32 *_retval); \
  NS_IMETHOD GetTableRowCount(nsIDOMElement *tableElement, PRInt32 *_retval); \
  NS_IMETHOD GetTableColumnCount(nsIDOMElement *tableElement, PRInt32 *_retval); \
  NS_IMETHOD GetCellAt(nsIDOMElement *tableElement, PRInt32 rowIndex, PRInt32 colIndex, nsIDOMElement **_retval); \
  NS_IMETHOD GetCellDataAt(nsIDOMElement *tableElement, PRInt32 rowIndex, PRInt32 colIndex, PRInt32 *startRowIndex, PRInt32 *startColIndex, PRInt32 *rowSpan, PRInt32 *colSpan, PRInt32 *actualRowSpan, PRInt32 *actualColSpan, PRBool *isSelected, nsIDOMElement **_retval); \
  NS_IMETHOD GetFirstRow(nsIDOMElement *tableElement, nsIDOMElement **_retval); \
  NS_IMETHOD GetNextRow(nsIDOMElement *currentRow, nsIDOMElement **_retval); \
  NS_IMETHOD GetSelectedOrParentTableElement(PRUnichar **tagName, PRBool *isSelected, nsIDOMElement **_retval); \
  NS_IMETHOD GetEmbeddedObjects(nsISupportsArray **_retval); \
  NS_IMETHOD SetAttribute(nsIDOMElement *element, const PRUnichar *attr, const PRUnichar *value); \
  NS_IMETHOD RemoveAttribute(nsIDOMElement *element, const PRUnichar *attr); \
  NS_IMETHOD SetTextProperty(const PRUnichar *prop, const PRUnichar *attr, const PRUnichar *value); \
  NS_IMETHOD RemoveTextProperty(const PRUnichar *prop, const PRUnichar *attr); \
  NS_IMETHOD GetTextProperty(const PRUnichar *prop, const PRUnichar *attr, const PRUnichar *value, PRBool *firstHas, PRBool *anyHas, PRBool *allHas); \
  NS_IMETHOD IncreaseFontSize(void); \
  NS_IMETHOD DecreaseFontSize(void); \
  NS_IMETHOD SetParagraphFormat(const PRUnichar *paragraphFormat); \
  NS_IMETHOD SetBodyAttribute(const PRUnichar *attr, const PRUnichar *value); \
  NS_IMETHOD SetBackgroundColor(const PRUnichar *color); \
  NS_IMETHOD ApplyStyleSheet(const PRUnichar *url); \
  NS_IMETHOD SetDisplayMode(PRInt32 displayMode); \
  NS_IMETHOD GetContentsAs(const PRUnichar *format, PRUint32 flags, PRUnichar **_retval); \
  NS_IMETHOD DumpContentTree(void); \
  NS_IMETHOD GetLocalFileURL(nsIDOMWindow *parent, const PRUnichar *filterType, PRUnichar **_retval); \
  NS_IMETHOD NodeIsBlock(nsIDOMNode *node, PRBool *_retval); \
  NS_IMETHOD CloneAttributes(nsIDOMNode *destNode, nsIDOMNode *sourceNode); \
  NS_IMETHOD BeginBatchChanges(void); \
  NS_IMETHOD EndBatchChanges(void); \
  NS_IMETHOD RunUnitTests(void); \
  NS_IMETHOD StartLogging(nsIFileSpec *logFile); \
  NS_IMETHOD StopLogging(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIEDITORSHELL(_to) \
  NS_IMETHOD GetEditorDocument(nsIDOMDocument * *aEditorDocument) { return _to ## GetEditorDocument(aEditorDocument); } \
  NS_IMETHOD GetEditorSelection(nsIDOMSelection * *aEditorSelection) { return _to ## GetEditorSelection(aEditorSelection); } \
  NS_IMETHOD GetSelectionController(nsISelectionController * *aSelectionController) { return _to ## GetSelectionController(aSelectionController); } \
  NS_IMETHOD GetEditor(nsIEditor * *aEditor) { return _to ## GetEditor(aEditor); } \
  NS_IMETHOD GetDocumentModified(PRBool *aDocumentModified) { return _to ## GetDocumentModified(aDocumentModified); } \
  NS_IMETHOD GetDocumentIsEmpty(PRBool *aDocumentIsEmpty) { return _to ## GetDocumentIsEmpty(aDocumentIsEmpty); } \
  NS_IMETHOD GetDocumentLength(PRInt32 *aDocumentLength) { return _to ## GetDocumentLength(aDocumentLength); } \
  NS_IMETHOD GetWrapColumn(PRInt32 *aWrapColumn) { return _to ## GetWrapColumn(aWrapColumn); } \
  NS_IMETHOD SetWrapColumn(PRInt32 aWrapColumn) { return _to ## SetWrapColumn(aWrapColumn); } \
  NS_IMETHOD SetEditorType(const PRUnichar *editorType) { return _to ## SetEditorType(editorType); } \
  NS_IMETHOD SetToolbarWindow(nsIDOMWindow *win) { return _to ## SetToolbarWindow(win); } \
  NS_IMETHOD SetContentWindow(nsIDOMWindow *win) { return _to ## SetContentWindow(win); } \
  NS_IMETHOD SetWebShellWindow(nsIDOMWindow *win) { return _to ## SetWebShellWindow(win); } \
  NS_IMETHOD LoadUrl(const PRUnichar *url) { return _to ## LoadUrl(url); } \
  NS_IMETHOD SetDocumentTitle(const PRUnichar *title) { return _to ## SetDocumentTitle(title); } \
  NS_IMETHOD GetDocumentTitle(PRUnichar **_retval) { return _to ## GetDocumentTitle(_retval); } \
  NS_IMETHOD RegisterDocumentStateListener(nsIDocumentStateListener *docListener) { return _to ## RegisterDocumentStateListener(docListener); } \
  NS_IMETHOD UnregisterDocumentStateListener(nsIDocumentStateListener *docListener) { return _to ## UnregisterDocumentStateListener(docListener); } \
  NS_IMETHOD Init(void) { return _to ## Init(); } \
  NS_IMETHOD CheckOpenWindowForURLMatch(const PRUnichar *inFileURL, nsIDOMWindow *inCheckWindow, PRBool *_retval) { return _to ## CheckOpenWindowForURLMatch(inFileURL, inCheckWindow, _retval); } \
  NS_IMETHOD SaveDocument(PRBool saveAs, PRBool saveCopy, PRBool *_retval) { return _to ## SaveDocument(saveAs, saveCopy, _retval); } \
  NS_IMETHOD CheckAndSaveDocument(const PRUnichar *reasonToSave, PRBool *_retval) { return _to ## CheckAndSaveDocument(reasonToSave, _retval); } \
  NS_IMETHOD CloseWindow(PRBool *_retval) { return _to ## CloseWindow(_retval); } \
  NS_IMETHOD Print(void) { return _to ## Print(); } \
  NS_IMETHOD Undo(void) { return _to ## Undo(); } \
  NS_IMETHOD Redo(void) { return _to ## Redo(); } \
  NS_IMETHOD Cut(void) { return _to ## Cut(); } \
  NS_IMETHOD Copy(void) { return _to ## Copy(); } \
  NS_IMETHOD Paste(void) { return _to ## Paste(); } \
  NS_IMETHOD PasteAsQuotation(void) { return _to ## PasteAsQuotation(); } \
  NS_IMETHOD PasteAsCitedQuotation(const PRUnichar *cite) { return _to ## PasteAsCitedQuotation(cite); } \
  NS_IMETHOD InsertAsQuotation(const PRUnichar *quotedText, nsIDOMNode **nodeInserted) { return _to ## InsertAsQuotation(quotedText, nodeInserted); } \
  NS_IMETHOD InsertAsCitedQuotation(const PRUnichar *quotedText, const PRUnichar *cite, const PRUnichar *charset, nsIDOMNode **nodeInserted) { return _to ## InsertAsCitedQuotation(quotedText, cite, charset, nodeInserted); } \
  NS_IMETHOD SelectAll(void) { return _to ## SelectAll(); } \
  NS_IMETHOD DeleteSelection(PRInt32 action) { return _to ## DeleteSelection(action); } \
  NS_IMETHOD Find(void) { return _to ## Find(); } \
  NS_IMETHOD FindNext(void) { return _to ## FindNext(); } \
  NS_IMETHOD UpdateInterfaceState(void) { return _to ## UpdateInterfaceState(); } \
  NS_IMETHOD GetString(const PRUnichar *name, PRUnichar **_retval) { return _to ## GetString(name, _retval); } \
  NS_IMETHOD GetDocumentCharacterSet(PRUnichar **_retval) { return _to ## GetDocumentCharacterSet(_retval); } \
  NS_IMETHOD SetDocumentCharacterSet(const PRUnichar *characterSet) { return _to ## SetDocumentCharacterSet(characterSet); } \
  NS_IMETHOD TypedText(const PRUnichar *textToInsert, PRInt32 actionToTake) { return _to ## TypedText(textToInsert, actionToTake); } \
  NS_IMETHOD InsertText(const PRUnichar *textToInsert) { return _to ## InsertText(textToInsert); } \
  NS_IMETHOD InsertSource(const PRUnichar *textToInsert) { return _to ## InsertSource(textToInsert); } \
  NS_IMETHOD InsertSourceWithCharset(const PRUnichar *textToInsert, const PRUnichar *charset) { return _to ## InsertSourceWithCharset(textToInsert, charset); } \
  NS_IMETHOD InsertBreak(void) { return _to ## InsertBreak(); } \
  NS_IMETHOD MakeOrChangeList(const PRUnichar *listType) { return _to ## MakeOrChangeList(listType); } \
  NS_IMETHOD RemoveList(const PRUnichar *listType) { return _to ## RemoveList(listType); } \
  NS_IMETHOD Indent(const PRUnichar *indent) { return _to ## Indent(indent); } \
  NS_IMETHOD Align(const PRUnichar *align) { return _to ## Align(align); } \
  NS_IMETHOD GetSelectedElement(const PRUnichar *tagName, nsIDOMElement **_retval) { return _to ## GetSelectedElement(tagName, _retval); } \
  NS_IMETHOD GetElementOrParentByTagName(const PRUnichar *tagName, nsIDOMNode *node, nsIDOMElement **_retval) { return _to ## GetElementOrParentByTagName(tagName, node, _retval); } \
  NS_IMETHOD CreateElementWithDefaults(const PRUnichar *tagName, nsIDOMElement **_retval) { return _to ## CreateElementWithDefaults(tagName, _retval); } \
  NS_IMETHOD InsertElementAtSelection(nsIDOMElement *element, PRBool deleteSelection) { return _to ## InsertElementAtSelection(element, deleteSelection); } \
  NS_IMETHOD InsertLinkAroundSelection(nsIDOMElement *anchorElement) { return _to ## InsertLinkAroundSelection(anchorElement); } \
  NS_IMETHOD InsertElement(nsIDOMElement *element, nsIDOMElement *parent, PRInt32 position) { return _to ## InsertElement(element, parent, position); } \
  NS_IMETHOD DeleteElement(nsIDOMElement *element) { return _to ## DeleteElement(element); } \
  NS_IMETHOD DeleteCharForward(void) { return _to ## DeleteCharForward(); } \
  NS_IMETHOD DeleteCharBackward(void) { return _to ## DeleteCharBackward(); } \
  NS_IMETHOD DeleteWordForward(void) { return _to ## DeleteWordForward(); } \
  NS_IMETHOD DeleteWordBackward(void) { return _to ## DeleteWordBackward(); } \
  NS_IMETHOD DeleteToBeginningOfLine(void) { return _to ## DeleteToBeginningOfLine(); } \
  NS_IMETHOD DeleteToEndOfLine(void) { return _to ## DeleteToEndOfLine(); } \
  NS_IMETHOD SelectElement(nsIDOMElement *element) { return _to ## SelectElement(element); } \
  NS_IMETHOD SetSelectionAfterElement(nsIDOMElement *element) { return _to ## SetSelectionAfterElement(element); } \
  NS_IMETHOD InsertTableCell(PRInt32 number, PRBool after) { return _to ## InsertTableCell(number, after); } \
  NS_IMETHOD InsertTableRow(PRInt32 number, PRBool after) { return _to ## InsertTableRow(number, after); } \
  NS_IMETHOD InsertTableColumn(PRInt32 number, PRBool after) { return _to ## InsertTableColumn(number, after); } \
  NS_IMETHOD DeleteTable(void) { return _to ## DeleteTable(); } \
  NS_IMETHOD DeleteTableCell(PRInt32 number) { return _to ## DeleteTableCell(number); } \
  NS_IMETHOD DeleteTableCellContents(void) { return _to ## DeleteTableCellContents(); } \
  NS_IMETHOD DeleteTableRow(PRInt32 number) { return _to ## DeleteTableRow(number); } \
  NS_IMETHOD DeleteTableColumn(PRInt32 number) { return _to ## DeleteTableColumn(number); } \
  NS_IMETHOD JoinTableCells(void) { return _to ## JoinTableCells(); } \
  NS_IMETHOD SelectTableCell(void) { return _to ## SelectTableCell(); } \
  NS_IMETHOD SelectTableRow(void) { return _to ## SelectTableRow(); } \
  NS_IMETHOD SelectTableColumn(void) { return _to ## SelectTableColumn(); } \
  NS_IMETHOD SelectTable(void) { return _to ## SelectTable(); } \
  NS_IMETHOD SelectAllTableCells(void) { return _to ## SelectAllTableCells(); } \
  NS_IMETHOD NormalizeTable(nsIDOMElement *tableElement) { return _to ## NormalizeTable(tableElement); } \
  NS_IMETHOD GetRowIndex(nsIDOMElement *cellElement, PRInt32 *_retval) { return _to ## GetRowIndex(cellElement, _retval); } \
  NS_IMETHOD GetColumnIndex(nsIDOMElement *cellElement, PRInt32 *_retval) { return _to ## GetColumnIndex(cellElement, _retval); } \
  NS_IMETHOD GetTableRowCount(nsIDOMElement *tableElement, PRInt32 *_retval) { return _to ## GetTableRowCount(tableElement, _retval); } \
  NS_IMETHOD GetTableColumnCount(nsIDOMElement *tableElement, PRInt32 *_retval) { return _to ## GetTableColumnCount(tableElement, _retval); } \
  NS_IMETHOD GetCellAt(nsIDOMElement *tableElement, PRInt32 rowIndex, PRInt32 colIndex, nsIDOMElement **_retval) { return _to ## GetCellAt(tableElement, rowIndex, colIndex, _retval); } \
  NS_IMETHOD GetCellDataAt(nsIDOMElement *tableElement, PRInt32 rowIndex, PRInt32 colIndex, PRInt32 *startRowIndex, PRInt32 *startColIndex, PRInt32 *rowSpan, PRInt32 *colSpan, PRInt32 *actualRowSpan, PRInt32 *actualColSpan, PRBool *isSelected, nsIDOMElement **_retval) { return _to ## GetCellDataAt(tableElement, rowIndex, colIndex, startRowIndex, startColIndex, rowSpan, colSpan, actualRowSpan, actualColSpan, isSelected, _retval); } \
  NS_IMETHOD GetFirstRow(nsIDOMElement *tableElement, nsIDOMElement **_retval) { return _to ## GetFirstRow(tableElement, _retval); } \
  NS_IMETHOD GetNextRow(nsIDOMElement *currentRow, nsIDOMElement **_retval) { return _to ## GetNextRow(currentRow, _retval); } \
  NS_IMETHOD GetSelectedOrParentTableElement(PRUnichar **tagName, PRBool *isSelected, nsIDOMElement **_retval) { return _to ## GetSelectedOrParentTableElement(tagName, isSelected, _retval); } \
  NS_IMETHOD GetEmbeddedObjects(nsISupportsArray **_retval) { return _to ## GetEmbeddedObjects(_retval); } \
  NS_IMETHOD SetAttribute(nsIDOMElement *element, const PRUnichar *attr, const PRUnichar *value) { return _to ## SetAttribute(element, attr, value); } \
  NS_IMETHOD RemoveAttribute(nsIDOMElement *element, const PRUnichar *attr) { return _to ## RemoveAttribute(element, attr); } \
  NS_IMETHOD SetTextProperty(const PRUnichar *prop, const PRUnichar *attr, const PRUnichar *value) { return _to ## SetTextProperty(prop, attr, value); } \
  NS_IMETHOD RemoveTextProperty(const PRUnichar *prop, const PRUnichar *attr) { return _to ## RemoveTextProperty(prop, attr); } \
  NS_IMETHOD GetTextProperty(const PRUnichar *prop, const PRUnichar *attr, const PRUnichar *value, PRBool *firstHas, PRBool *anyHas, PRBool *allHas) { return _to ## GetTextProperty(prop, attr, value, firstHas, anyHas, allHas); } \
  NS_IMETHOD IncreaseFontSize(void) { return _to ## IncreaseFontSize(); } \
  NS_IMETHOD DecreaseFontSize(void) { return _to ## DecreaseFontSize(); } \
  NS_IMETHOD SetParagraphFormat(const PRUnichar *paragraphFormat) { return _to ## SetParagraphFormat(paragraphFormat); } \
  NS_IMETHOD SetBodyAttribute(const PRUnichar *attr, const PRUnichar *value) { return _to ## SetBodyAttribute(attr, value); } \
  NS_IMETHOD SetBackgroundColor(const PRUnichar *color) { return _to ## SetBackgroundColor(color); } \
  NS_IMETHOD ApplyStyleSheet(const PRUnichar *url) { return _to ## ApplyStyleSheet(url); } \
  NS_IMETHOD SetDisplayMode(PRInt32 displayMode) { return _to ## SetDisplayMode(displayMode); } \
  NS_IMETHOD GetContentsAs(const PRUnichar *format, PRUint32 flags, PRUnichar **_retval) { return _to ## GetContentsAs(format, flags, _retval); } \
  NS_IMETHOD DumpContentTree(void) { return _to ## DumpContentTree(); } \
  NS_IMETHOD GetLocalFileURL(nsIDOMWindow *parent, const PRUnichar *filterType, PRUnichar **_retval) { return _to ## GetLocalFileURL(parent, filterType, _retval); } \
  NS_IMETHOD NodeIsBlock(nsIDOMNode *node, PRBool *_retval) { return _to ## NodeIsBlock(node, _retval); } \
  NS_IMETHOD CloneAttributes(nsIDOMNode *destNode, nsIDOMNode *sourceNode) { return _to ## CloneAttributes(destNode, sourceNode); } \
  NS_IMETHOD BeginBatchChanges(void) { return _to ## BeginBatchChanges(); } \
  NS_IMETHOD EndBatchChanges(void) { return _to ## EndBatchChanges(); } \
  NS_IMETHOD RunUnitTests(void) { return _to ## RunUnitTests(); } \
  NS_IMETHOD StartLogging(nsIFileSpec *logFile) { return _to ## StartLogging(logFile); } \
  NS_IMETHOD StopLogging(void) { return _to ## StopLogging(); } 


#endif /* __gen_nsIEditorShell_h__ */
