/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsISessionHistory.idl
 */

#ifndef __gen_nsISessionHistory_h__
#define __gen_nsISessionHistory_h__

#include "nsISupports.h"
#include "nsIChannel.h"
#include "nsIFactory.h"

#include "nscore.h"
class nsIWebShell;
#define NS_ISESSIONHISTORY_PROGID "component://netscape/appshell/component/browser/sessionhistory"

/* starting interface:    nsISessionHistory */
#define NS_ISESSIONHISTORY_IID_STR "68e73d51-12eb-11d3-bdc0-0050040a9b44"

#define NS_ISESSIONHISTORY_IID \
  {0x68e73d51, 0x12eb, 0x11d3, \
    { 0xbd, 0xc0, 0x00, 0x50, 0x04, 0x0a, 0x9b, 0x44 }}

class nsISessionHistory : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISESSIONHISTORY_IID)

  /**
   * Go forward in history 
   */
  /* [noscript] void goForward (in nsIWebShell aContainer); */
  NS_IMETHOD GoForward(nsIWebShell * aContainer) = 0;

  /**
   * Go Back in History
   */
  /* [noscript] void goBack (in nsIWebShell aContainer); */
  NS_IMETHOD GoBack(nsIWebShell * aContainer) = 0;

  /**
   * Reload the current history entry
   */
  /* [noscript] void reload (in nsIWebShell aContainer, in nsLoadFlags aReloadFlags); */
  NS_IMETHOD Reload(nsIWebShell * aContainer, nsLoadFlags aReloadFlags) = 0;

  /**
   * Can I go forward in History
   */
  /* boolean canGoForward (); */
  NS_IMETHOD CanGoForward(PRBool *_retval) = 0;

  /**
   * Can I go back in History
   */
  /* boolean canGoBack (); */
  NS_IMETHOD CanGoBack(PRBool *_retval) = 0;

  /**
   * Add a new URL to the History List
   */
  /* [noscript] void add (in string url, in string aReferrer, in nsIWebShell aContainer); */
  NS_IMETHOD Add(const char *url, const char *aReferrer, nsIWebShell * aContainer) = 0;

  /**
   * Goto to a particular point in history 
   */
  /* [noscript] void goto (in long aHistoryIndex, in nsIWebShell aContainer, in boolean aIsReloading); */
  NS_IMETHOD Goto(PRInt32 aHistoryIndex, nsIWebShell * aContainer, PRBool aIsReloading) = 0;

  /**
   * Get the length of the History list
   */
  /* long getHistoryLength (); */
  NS_IMETHOD GetHistoryLength(PRInt32 *_retval) = 0;

  /**
   * Get the index of the current document in the history list
   */
  /* long getCurrentIndex (); */
  NS_IMETHOD GetCurrentIndex(PRInt32 *_retval) = 0;

  /**
   * Set the flag whether a history entry is in the middle of loading a
   * doc. See comments below for details
   */
  /* void setLoadingFlag (in boolean aFlag); */
  NS_IMETHOD SetLoadingFlag(PRBool aFlag) = 0;

  /**
   * Get the flag whether a history entry is in the middle of loading a
   * doc. See comments below for details
   */
  /* boolean getLoadingFlag (); */
  NS_IMETHOD GetLoadingFlag(PRBool *_retval) = 0;

  /**
   * Get the URL of the index
   */
  /* string getURLForIndex (in long aIndex); */
  NS_IMETHOD GetURLForIndex(PRInt32 aIndex, char **_retval) = 0;

  /**
   * Set the URL of the index
   */
  /* void setURLForIndex (in long aIndex, in string aURL); */
  NS_IMETHOD SetURLForIndex(PRInt32 aIndex, const char *aURL) = 0;

  /**
   * Get the title of the index
   */
  /* wstring getTitleForIndex (in long aIndex); */
  NS_IMETHOD GetTitleForIndex(PRInt32 aIndex, PRUnichar **_retval) = 0;

  /**
   * Set the Title of the index
   */
  /* void setTitleForIndex (in long aIndex, in wstring aTitle); */
  NS_IMETHOD SetTitleForIndex(PRInt32 aIndex, const PRUnichar *aTitle) = 0;

  /**
   * Get the History object of the index
   */
  /* nsISupports getHistoryObjectForIndex (in PRInt32 aIndex); */
  NS_IMETHOD GetHistoryObjectForIndex(PRInt32 aIndex, nsISupports **_retval) = 0;

  /**
   * Set the History state of the index
   */
  /* void setHistoryObjectForIndex (in long aIndex, in nsISupports aState); */
  NS_IMETHOD SetHistoryObjectForIndex(PRInt32 aIndex, nsISupports *aState) = 0;

  /**
   *   Reconcile history status with the actual page load status 
   */
  /* [noscript] void updateStatus (in nsIWebShell aContainer, in long aStatus); */
  NS_IMETHOD UpdateStatus(nsIWebShell * aContainer, PRInt32 aStatus) = 0;

  enum { LOAD_HISTORY = 10 };

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISESSIONHISTORY \
  NS_IMETHOD GoForward(nsIWebShell * aContainer); \
  NS_IMETHOD GoBack(nsIWebShell * aContainer); \
  NS_IMETHOD Reload(nsIWebShell * aContainer, nsLoadFlags aReloadFlags); \
  NS_IMETHOD CanGoForward(PRBool *_retval); \
  NS_IMETHOD CanGoBack(PRBool *_retval); \
  NS_IMETHOD Add(const char *url, const char *aReferrer, nsIWebShell * aContainer); \
  NS_IMETHOD Goto(PRInt32 aHistoryIndex, nsIWebShell * aContainer, PRBool aIsReloading); \
  NS_IMETHOD GetHistoryLength(PRInt32 *_retval); \
  NS_IMETHOD GetCurrentIndex(PRInt32 *_retval); \
  NS_IMETHOD SetLoadingFlag(PRBool aFlag); \
  NS_IMETHOD GetLoadingFlag(PRBool *_retval); \
  NS_IMETHOD GetURLForIndex(PRInt32 aIndex, char **_retval); \
  NS_IMETHOD SetURLForIndex(PRInt32 aIndex, const char *aURL); \
  NS_IMETHOD GetTitleForIndex(PRInt32 aIndex, PRUnichar **_retval); \
  NS_IMETHOD SetTitleForIndex(PRInt32 aIndex, const PRUnichar *aTitle); \
  NS_IMETHOD GetHistoryObjectForIndex(PRInt32 aIndex, nsISupports **_retval); \
  NS_IMETHOD SetHistoryObjectForIndex(PRInt32 aIndex, nsISupports *aState); \
  NS_IMETHOD UpdateStatus(nsIWebShell * aContainer, PRInt32 aStatus); \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISESSIONHISTORY(_to) \
  NS_IMETHOD GoForward(nsIWebShell * aContainer) { return _to ## GoForward(aContainer); } \
  NS_IMETHOD GoBack(nsIWebShell * aContainer) { return _to ## GoBack(aContainer); } \
  NS_IMETHOD Reload(nsIWebShell * aContainer, nsLoadFlags aReloadFlags) { return _to ## Reload(aContainer, aReloadFlags); } \
  NS_IMETHOD CanGoForward(PRBool *_retval) { return _to ## CanGoForward(_retval); } \
  NS_IMETHOD CanGoBack(PRBool *_retval) { return _to ## CanGoBack(_retval); } \
  NS_IMETHOD Add(const char *url, const char *aReferrer, nsIWebShell * aContainer) { return _to ## Add(url, aReferrer, aContainer); } \
  NS_IMETHOD Goto(PRInt32 aHistoryIndex, nsIWebShell * aContainer, PRBool aIsReloading) { return _to ## Goto(aHistoryIndex, aContainer, aIsReloading); } \
  NS_IMETHOD GetHistoryLength(PRInt32 *_retval) { return _to ## GetHistoryLength(_retval); } \
  NS_IMETHOD GetCurrentIndex(PRInt32 *_retval) { return _to ## GetCurrentIndex(_retval); } \
  NS_IMETHOD SetLoadingFlag(PRBool aFlag) { return _to ## SetLoadingFlag(aFlag); } \
  NS_IMETHOD GetLoadingFlag(PRBool *_retval) { return _to ## GetLoadingFlag(_retval); } \
  NS_IMETHOD GetURLForIndex(PRInt32 aIndex, char **_retval) { return _to ## GetURLForIndex(aIndex, _retval); } \
  NS_IMETHOD SetURLForIndex(PRInt32 aIndex, const char *aURL) { return _to ## SetURLForIndex(aIndex, aURL); } \
  NS_IMETHOD GetTitleForIndex(PRInt32 aIndex, PRUnichar **_retval) { return _to ## GetTitleForIndex(aIndex, _retval); } \
  NS_IMETHOD SetTitleForIndex(PRInt32 aIndex, const PRUnichar *aTitle) { return _to ## SetTitleForIndex(aIndex, aTitle); } \
  NS_IMETHOD GetHistoryObjectForIndex(PRInt32 aIndex, nsISupports **_retval) { return _to ## GetHistoryObjectForIndex(aIndex, _retval); } \
  NS_IMETHOD SetHistoryObjectForIndex(PRInt32 aIndex, nsISupports *aState) { return _to ## SetHistoryObjectForIndex(aIndex, aState); } \
  NS_IMETHOD UpdateStatus(nsIWebShell * aContainer, PRInt32 aStatus) { return _to ## UpdateStatus(aContainer, aStatus); } \


#endif /* __gen_nsISessionHistory_h__ */
